#include"Instruction.h"

vector<Instruction *> Instruction::indirectSendTargets;
bool Instruction::printFires = false;
bool Instruction::alwaysProbe = false;
map<string, WSOpCode> Instruction::nameToOpcode;
map<WSOpCode, string> Instruction::opcodeToName;

Instruction::Instruction(uint inputs, uint outputs, int64 imm, const char *name) : 
     name(name), 
     inputs(inputs), 
     outputs(outputs)
{
     key = -1;
     immediate = imm;
     silent = false;
     invocationSets.resize(3, vector<uint>(0));
     instClass = INST_CLASS_BIT(generic);
}

void Instruction::InitializeISA()
{
#include"uniform_INST.def"
#define LINK(a, OPCODE) nameToOpcode[string(#OPCODE)] = OP_ENUM(OPCODE); opcodeToName[OP_ENUM(OPCODE)] = string(#OPCODE);     
#define INST(OPCODE, IN_COUNT, OUT_COUNT, IMM, IS_MEM, INPUTS, AUTO_INPUTS, OUTPUTS, AUTO_OUTPUTS, FIRE_0_SET, FIRE_0_CODE, FIRE_1_SET, FIRE_1_CODE, FIRE_2_SET, FIRE_2_CODE) LINK(a, OPCODE)

#include "Instructions.def"

#undef INST
#undef LINK
#undef CUSTOM_INST

}


void FromProbe(Designator from, Designator to) 
{
     //     Probe * probe = new Probe((from.first->name +" -> "+to.first->name).c_str()); // Memory leak
     //     From(from, (*probe)[Probe::IN], true);
     //     From((*probe)[Probe::OUT], to, true);
}

void From(Designator from, Designator  to, bool recursive) 
{
     if (recursive || !Instruction::alwaysProbe) {
	  from.first->outputs[from.second].push_back(to);
     } else {
	  FromProbe(from, to);
     }
}

void operator>>(Designator src, Designator dst)
{
     assert(src.first != NULL);
     assert(dst.first != NULL);
     From(src, dst);
}
