#ifndef COMMAND_LINE_INCLUDED
#define COMMAND_LINE_INCLUDED

#include<string>
#include<vector>
using std::vector;
using std::string;

#include "Foundation/Printable.h"
#include "Foundation/Global.h"
#include "Foundation/Types.h"
/**
 * This is C++ version of a normal command line with a few extra features.  The
 * most notable is that you can add options to it from a file with
 * LoadOptions().  The file format is simple, white space seperates options.
 *
 * FIXME:  I both need to write LoadOptions() and make sure it handle quotes.
 */
class CommandLine : public Printable {
public:

     class Arg {
     public:
	  string arg;
	  Arg(char *aArg) : arg(aArg) {
	  }
     };

     string executableName;
     //     vector<string> unprocessedArgs;
     vector<Arg> args;
     const char **c_args;

     CommandLine(int argc, char *argv[])
     {
	  int i;
	  executableName = (string)argv[0];

	  for (i = 1; i < argc; i++) {
	       args.push_back(Arg(argv[i]));
	       //	       unprocessedArgs.push_back((string)argv[i]);
	  }
	  c_args = NULL;
     }

     inline uint size()
     {
	  return args.size();
     }

     inline const string & operator [] (uint i) {
	  return args[i].arg;
     }
     
     inline void erase(uint l) {
	  args.erase(args.begin() + l);
     }
     
     const char *ToString(string &s) {
	  uint i;
	  s.clear();
	  for (i = 0;  i < args.size(); i++) {
	       s += args[i].arg;
	       s += " ";
	  }
	  return s.c_str();
     }

     const char **GetArgv() {
	  if (c_args == NULL) {
	       c_args = new (const char*)[args.size() + 1];
	       uint i; 
	       
	       for(i = 0; i < args.size(); i++) {
		    c_args[i] = args[i].arg.c_str();
	       }
	  }
	  c_args[args.size()] = NULL;
	  return c_args;
     }

};
#endif
