#ifndef FOUNDATION_COMPATIBILITY_INCLUDED
#define FOUNDATION_COMPATIBILITY_INCLUDED
// This file contains various system-specific fixes.

// default printf/fprintf formatting for 64 bit types
#	define	format_hex_int64	"%llx"
#	define	format_hex_uint64	"%llx"
#	define	format_dec_int64	"%lld"
#	define	format_dec_uint64	"%llu"



#if	defined(__alpha)	||	defined(__ALPHA)
// Alpha needs a couple of hacks
#	define	strtoll		strtol
#	define	strtoull	strtoul

#	undef	format_hex_int64
#	undef	format_hex_uint64
#	undef	format_dec_int64
#	undef	format_dec_uint64

#	define	format_hex_int64	"%lx"
#	define	format_hex_uint64	"%lx"
#	define	format_dec_int64	"%ld"
#	define	format_dec_uint64	"%lu"

#endif

// endian issues
#	define	little_endian	1
#	define	big_endian		0

#if	defined(__alpha)	||	defined(__ALPHA)
#	define	native_endian	little_endian
#else
#if	defined(__ppc__)
#	define	native_endian	big_endian
#else
#	define	native_endian	little_endian
#endif
#endif

#endif
