#ifndef FOUNDATION_ENDIAN_INCLUDED
#define FOUNDATION_ENDIAN_INCLUDED
// cross endian support

static	inline	uint16
SwitchEndian(uint16	x)
	{
	return ( ((x >> 8) & 0x00ff) | ((x << 8) & 0xff00) );
	}

static	inline	uint32
SwitchEndian(uint32	x)
	{
	return ( (uint32)SwitchEndian( ((uint16) (x >> 16))) |
			((uint32) (SwitchEndian ((uint16) (x & 0x0000ffff)) << 16) ));
	}

static	inline	uint64
SwitchEndian(uint64	x)
	{
	return ( (uint64) SwitchEndian( ((uint32) (x >> 32))) |
			(((uint64) (SwitchEndian ((uint32) (x & ((uint64)0xffffffff) ))) << 32) ));
	}


template	<class	nativetype>
	class	crossendian
	{
	public:
		nativetype	n;

		crossendian<nativetype>	&	operator	=	(crossendian<nativetype>	x)						{ n = x.n; return(*this); }
		crossendian<nativetype>	&	operator	=	(nativetype x)										{ n = SwitchEndian(x); return(*this); }
		crossendian<nativetype>	*	operator	&	()													{ return( (crossendian<nativetype> *) & n); }
									operator	nativetype	()											{ return ( SwitchEndian(n) ); }
												crossendian<nativetype>	()								{ n = 0; }
												crossendian<nativetype>	(const crossendian<nativetype>	&x)	{ n = x.n; }
												crossendian<nativetype>	(const nativetype &x)			{ n = SwitchEndian(x); }
	};

#if	native_endian	==	little_endian
typedef	byte				le_uint8;
typedef	uint16				le_uint16;
typedef	uint32				le_uint32;
typedef	uint64				le_uint64;
typedef	byte				be_uint8;
typedef	crossendian<uint16>	be_uint16;
typedef	crossendian<uint32>	be_uint32;
typedef	crossendian<uint64>	be_uint64;
#else
typedef	byte				be_uint8;
typedef	uint16				be_uint16;
typedef	uint32				be_uint32;
typedef	uint64				be_uint64;
typedef	byte				le_uint8;
typedef	crossendian<uint16>	le_uint16;
typedef	crossendian<uint32>	le_uint32;
typedef	crossendian<uint64>	le_uint64;
#endif

#endif
