#ifndef FREE_LIST_ALLOCATION_INCLUDED
#define FREE_LIST_ALLOCATION_INCLUDED


#define FREE_LIST_ALLOCATION_MEMBERS							\
 private:										\
     typedef vector<void *> FreeList;							\
     static vector<FreeList* > freeLists;						\
     static Counter allocated;								\
     static Counter inUse;									\
     static Counter maxInUse;								\
     static const uint ALLOC_BLOCK_SIZE;						\
											\
 public:										\
     void *operator new(size_t size) {							\
	  void *ret;									\
											\
	  if (size >= freeLists.size()) {						\
	       freeLists.resize(size + 1, NULL);					\
	  }										\
											\
	  FreeList *l = freeLists[size];						\
											\
	  if(l == NULL) {								\
	       l = new FreeList();							\
	       freeLists[size] = l;							\
	  }										\
     											\
	  if(l->empty()) {								\
	       uint i;									\
	       for ( i= 0; i < ALLOC_BLOCK_SIZE; i++) {					\
		    l->push_back(new char[size]);					\
		    allocated++;							\
	       }									\
	  }										\
											\
	  inUse++;									\
	  if (inUse > maxInUse) {							\
	       maxInUse = inUse;							\
	  }										\
	  ret = l->back();								\
	  l->pop_back();								\
	  return ret;									\
     }											\
     void operator delete(void *p, size_t size) {	       				\
	  FreeList *l = freeLists[size];						\
	  inUse--;									\
	  l->push_back(p);								\
     }





#define FREE_LIST_ALLOCATION_DATA(CLASS, allocBlock)		        \
const uint    CLASS::ALLOC_BLOCK_SIZE = allocBlock;			\
									\
Counter    CLASS::allocated = 0;						\
Counter    CLASS::inUse = 0;						\
Counter    CLASS::maxInUse = 0;						\
									\
vector<CLASS::FreeList* > CLASS::freeLists
								
#endif
