#ifndef HISTOGRAM_INCLUDED
#define HISTOGRAM_INCLUDED

class Histogram :public Printable{
     uint smallestActiveBucket;
     Counter sum;
     Counter itemCount;
     vector<Counter> data;
     
 public:
     
     Histogram() {
	  Reset();
     }

     void Increment(uint bucket, int delta = 1) {
	  if (bucket < smallestActiveBucket) {
	       smallestActiveBucket = bucket;
	  }
	  if (data.size() < bucket + 1) {
	       data.resize(bucket + 1);
	  }
	  data[bucket] += delta;
	  sum += bucket*delta;
	  itemCount += delta;
     }
     
     void Reset() {
	  smallestActiveBucket = 1000000000;
	  data.resize(0);
	  itemCount = 0;
	  sum = 0;
     }

     const char *ToString(string &buf) {
	  uint i;
	  Counter cdfSum = 0;
	  buf.clear();
	  for(i = smallestActiveBucket; i < data.size(); i++) {
	       char b[1000];
	       cdfSum += data[i];
	       sprintf(b,"%9u[%9llu %5.3f %9llu %5.3f]\t", i, 
		       data[i], ((data[i]+0.0)/(itemCount+0.0)), 
		       cdfSum,  ((cdfSum+0.0)/(itemCount+0.0)));
	       buf += b;
	  }

	  return buf.c_str();
     }
};
#endif
