#include"Util/SimOutput.h"
#include"Util/File.h"
#include"Util/Regression.h"
#include <stdio.h>
#include <stdarg.h>

File SimOutput::err(stderr);
File SimOutput::out(stdout);
File SimOutput::debug(stderr);
File SimOutput::trace(stderr);

void SimOutput::Print(const char *format, ...)
{
     if (out.GetFILE() != NULL) {
	  va_list ap;
	  va_start(ap, format);
	  out.Print(format, ap);
	  va_end(ap);
     }
}

void SimOutput::PrintError(const char *format, ...)
{
     if (err.GetFILE() != NULL) {
	  va_list ap;
	  va_start(ap, format);
	  err.Print(format, ap);
	  va_end(ap);
     }
}

void SimOutput::_Debug(const char *file, int line, const char *format, ...)
{
     if (debug.GetFILE() != NULL) {
	  va_list ap;
	  debug.Print("[%s:%d]:  ", file, line);
	  va_start(ap, format);
	  debug.Print(format, ap);
	  va_end(ap);

	  if (format[strlen(format) - 1] != '\n'){
	       debug.Print("\n");
	  }

     }
     
}

void SimOutput::_Trace(const char *file, int line, const char *format, ...)
{
     if (trace.GetFILE() != NULL) {
	  va_list ap;
	  va_start(ap, format);
	  trace.Print(format, ap);
	  va_end(ap);
	  
	  if (format[strlen(format) - 1] != '\n'){
	       trace.Print("\n");
	  }

     }
     
}

void SimOutput::_Warn(const char *file, int line, const char *format, ...)
{
     if (err.GetFILE() != NULL) {
	  va_list ap;
	  err.Print("WARN[%s:%d]:  ", file, line);
	  va_start(ap, format);
	  err.Print(format, ap);
	  va_end(ap);
	  
	  if (format[strlen(format) - 1] != '\n'){
	       err.Print("\n");
	  }
     }

}

void SimOutput::_Crash(const char *file, int line, const char *format, ...)
{
     if (err.GetFILE() != NULL) {
	  va_list ap;
	  err.Print("CRASH[%s:%d]:  ", file, line);
	  va_start(ap, format);
	  err.Print(format, ap);
	  va_end(ap);

	  if (format[strlen(format) - 1] != '\n'){
	       err.Print("\n");
	  }
     }
     Regression::Fail();
     abort();
}

