#ifndef SPARSE_PTR_MAP_INCLUDED
#define SPARSE_PTR_MAP_INCLUDED

#include"Engines/SimulatedAlpha/Sparse64BitMemorySpace.h"

class SparsePtrMap {
     Sparse64BitMemorySpace map;
     
 public:
     SparsePtrMap() {
	  Clear();
     }
     
     void *Get(uint64 index) {
	  return (void *)map.ReadMemory32(index << 2);
     }
     
     void Set(uint64 index, void *v) {
	  map.WriteMemory32(index << 2, (uint32)v);
     }
     
     void Clear() {
	  map.Initialize(16,16,16,16);
     }
};

#endif
