#ifndef VECTOR_EXT_INCLUDED
#define VECTOR_EXT_INCLUDED

#include<vector>
using std::vector;

template <class TYPE>
File::FileStatus WriteVectorToDisk(const vector<TYPE> &v, File &f)
{
     uint i;
     unsigned long long int l = v.size();
     File::FileStatus r;
     if ((r = f.Write(&l, sizeof(unsigned long long int))) != File::SUCCESS) {
	  return r;
     }
     
     for(i = 0; i < v.size(); i++) {
	  const TYPE *t = &v[i];
	  if ((r = f.Write(t, sizeof(TYPE))) != File::SUCCESS) {
	       return r;
	  }
     }
     return File::SUCCESS;
}

template <class TYPE>
File::FileStatus ReadVectorFromDisk(vector<TYPE> &v, File &f)
{
     uint i;
     unsigned long long int l;
     File::FileStatus r;

     v.clear();

     if ((r = f.Read(&l, sizeof(unsigned long long int))) != File::SUCCESS) {
	  return r;
     }
     
     for(i = 0; i < l; i++) {
	  TYPE t;
	  if ((r = f.Read(&t, sizeof(TYPE))) != File::SUCCESS) {
	       return r;
	  }
	  v.push_back(t);
     }
     return File::SUCCESS;
}
#endif

