#ifndef WAVE_SCALAR_VALUE_INCLUDED
#define WAVE_SCALAR_VALUE_INCLUDED

#include"Types.h"
#include"Util/Printable.h"



class WaveScalarValue : public Printable {
public:

     WaveScalarValue (uint64 aAsid, uint64 aThread, uint64 aWave, int64 aValue, WaveScalarValue *s = NULL) {
	  if (s != NULL) {
	       *this = *s;
	  }
	  asid = aAsid;
	  wave = aWave;
	  thread = aThread;
	  value = aValue;
     }

     WaveScalarValue (uint64 aThread = 0, uint64 aWave = 0, int64 aValue = 0, WaveScalarValue *s = NULL) {
	  if (s != NULL) {
	       *this = *s;
	  }
	  asid = 0;
	  wave = aWave;
	  thread = aThread;
	  value = aValue;
     }

     uint64 asid;
     uint64 wave;
     uint64 thread;
     int64 value;
     
     bool Match(const WaveScalarValue &v) const {
	  return v.thread == thread && 
	       v.asid == asid && 
	       v.wave == wave;
     }

     const char *ToString(string &buf) const {
	  char b[100];
	  buf.clear();
	  sprintf(b, "%llu:%llu:%lld", thread, wave, value);
	  buf += b;
	  return buf.c_str();
     }
};

#endif
