#include"Util/File.h"
#include"Instruction.h"


// void WaveAdvance()
// {
//      Source in;
//      Sink out;
//      WaveToData wtd;
//      AddI add(1);
//      DataToWave dtw;
     
//      FromProbe(in.O(0), wtd.I(0));
//      FromProbe(wtd.O(0), add.I(0));
//      FromProbe(add.O(0), dtw.I(0));
//      FromProbe(in.O(0), dtw.I(1));
//      FromProbe(dtw.O(0), out.I(0));

//      in.Fire(Value(0,0,0));
     
//      dtw.DumpQueues(File::Stdout);
// }

#if (0)
void IndirectSendTest()
{
     Source addr1("a1");
     Source data1("d1");
     Source addr2("a2");
     Source data2("d2");
     AddI id1(0,"id1");
     AddI id2(0,"id2");
     IndirectSend is1("s1");
     IndirectSend is2("s2");
     Add add;
     Sink out;
     
     Instruction::RegisterIndirectSendTarget(&id1);
     Instruction::RegisterIndirectSendTarget(&id2);     
     
     addr1[0] >> is1[0];
     addr2[0] >> is2[0];
     data1[0] >> is1[1];
     data2[0] >> is2[1];
     
     id1[0] >> add[0];
     id2[0] >> add[1];
     
     add[0] >> out[0];

     data1.Fire(WaveScalarValue(0,0,1));
     data2.Fire(WaveScalarValue(0,0,2));

     addr1.Fire(WaveScalarValue(0,0,id1.key));
     addr2.Fire(WaveScalarValue(0,0,id2.key));
}

void SemaphoreTest ()
{
     Add spinner("spinner"), gate("gate");
     LE le;
     PhiInv phiInv;
     IndirectSend responder;
     
     Source retAddress("retAddress"), acquire("acquire"), release("release"), reset0("reset0"),
	  reset1("reset1");
     
     Instruction::alwaysProbe = true;
     Instruction::printFires = true;

     reset0[OUTPUT] >> spinner[A];
     reset1[OUTPUT] >> spinner[B];

     retAddress[OUTPUT] >> responder[DST];
     release[OUTPUT] >> spinner[A];
     acquire[OUTPUT] >> gate[B];

     gate[OUTPUT] >> responder[DATA];
     
     phiInv[OUT_FALSE] >> gate[A];
     phiInv[OUT_FALSE] >> spinner[A];
     
     le[OUTPUT] >> phiInv[PREDICATE];
     le[OUTPUT] >> phiInv[VALUE];
     
     spinner[OUTPUT] >> le[INPUT];
     spinner[OUTPUT] >> spinner[B];
     
     reset0.Fire(WaveScalarValue(0,0,1));
     reset1.Fire(WaveScalarValue(0,0,0));
     
     spinner.DumpQueues(File::Stdout);
     
}

void ANFTest()
{
     Source req("req"), tok("tok");
     ANF anf;
     Sink sink;
     
     Instruction::alwaysProbe = true;
     Instruction::printFires = true;

     req[OUTPUT] >> anf[WILDCARD_INPUT];
     tok[OUTPUT] >> anf[TOKEN_INPUT];
     
     anf[OUTPUT] >> sink[INPUT];
     
     req.Fire(WaveScalarValue(1,2,3));
     tok.Fire(WaveScalarValue(3,4,5));
     
     anf.DumpQueues(File::Stdout);
}

void SemaphoreTest()
{

     Source ret("ret");
     Source req("req");
     Source inject("inject");
     Sink sink1("sink1");
     Sink sink2("sink2");
     ANF anf;

     Instruction::RegisterIndirectSendTarget(&sink1); 
     Instruction::RegisterIndirectSendTarget(&sink2); 
     
     AddI inc(1, "inc");
     
     IndirectSend respond("resp");

     ret[Source::OUT] >> respond[IndirectSend::DST];
     
     req[Source::OUT] >> anf[ANF::WILD_CARD];
     
     inject[Source::OUT] >> anf[ANF::TOKEN];
     
     anf[ANF::OUT] >> inc[AddI::A];
     
     inc[AddI::OUT] >> respond[IndirectSend::DATA];
     
     inject.Fire(WaveScalarValue(100, 0, 0));
     
     req.Fire(WaveScalarValue(1,0,100));
     ret.Fire(WaveScalarValue(1,0,sink1.key));

     req.Fire(WaveScalarValue(2,0,100));
     ret.Fire(WaveScalarValue(2,0,sink2.key));
     
     anf.DumpQueues(File::Stdout);
     
     inject.Fire(WaveScalarValue(100,1,0));     
}


void Loop1()
{
     Source source;
     EQI eq(10);
     WaveAdvance advance;
     AddI add(1);
     PhiInv phi;
     Sink sink("sink");     

//      Instruction::alwaysProbe = true;
//      Instruction::printFires = true;
     
     source[OUTPUT] >> advance[INPUT];
     advance[OUTPUT] >> eq[INPUT];
     advance[OUTPUT] >> add[INPUT];
     add[INPUT] >> phi[VALUE];
     
     eq[OUTPUT] >> phi[PREDICATE];
     phi[OUT_TRUE] >> sink[INPUT];
     phi[OUT_FALSE] >> advance[INPUT];
     
     source.Fire(WaveScalarValue(0,0,0));
}

void variadic()
{
#define _(a) a(#a)

     
     Source _(ctr), _(data);
     AddI ctrIn(0, "ctrIn"), dataIn(0, "dataIn");

     // Instruction::alwaysProbe = true;
     Instruction::printFires = true;
     
     WaveToData _(ctrWtd);
     WaveToData _(dataWtd);
     Const zero(0, "zero");
     AddI plus1(1, "plus1");
     
     WaveAdvance _(retAdvance);
     WaveAdvance _(firstCheckAdvance);
     WaveAdvance _(boundAdvance);
     WaveAdvance _(indexAdvance);
     WaveAdvance _(sumAdvance);
          
     EQ _(firstCheck);
     Phi _(boundSelect);
     PhiInv _(firstSelect);
     AddI indexIncrement(1, "indexIncrement");
     LT _(boundCheck);
     Add _(sumAdd);
     
     PhiInv _(retSteer);
     PhiInv _(firstCheckSteer);
     PhiInv _(boundSteer);
     PhiInv _(indexSteer);
     PhiInv _(sumSteer);

     IndirectSend _(ret);

     ctrIn[OUTPUT] >> retAdvance[INPUT];
     ctrIn[OUTPUT] >> ctrWtd[INPUT];
     ctrIn[OUTPUT] >> zero[INPUT];
     
     dataIn[OUTPUT] >> dataWtd[INPUT];
     dataIn[OUTPUT] >> firstSelect[VALUE];

     ctrWtd[OUTPUT] >> plus1[INPUT];
     
     dataWtd[OUTPUT] >> firstCheck[A];
     
     zero[OUTPUT] >> boundAdvance[INPUT];
     zero[OUTPUT] >> indexAdvance[INPUT];
     zero[OUTPUT] >> sumAdvance[INPUT];

     plus1[OUTPUT] >> firstCheckAdvance[INPUT];
     
     retAdvance[OUTPUT] >> retSteer[VALUE];
     
     firstCheckAdvance[OUTPUT] >> firstCheckSteer[VALUE];
     firstCheckAdvance[OUTPUT] >> firstCheck[B];
     
     boundAdvance[OUTPUT] >> boundSelect[IN_FALSE];
     
     indexAdvance[OUTPUT] >> indexIncrement[INPUT];
     
     sumAdvance[OUTPUT] >> sumAdd[A];
     
     firstCheck[OUTPUT] >> boundSelect[PREDICATE];
     firstCheck[OUTPUT] >> firstSelect[PREDICATE];
     
     boundSelect[OUTPUT] >> boundCheck[B];
     boundSelect[OUTPUT] >> boundSteer[VALUE];
     
     firstSelect[OUT_TRUE] >> boundSelect[IN_TRUE];
     firstSelect[OUT_FALSE] >> sumAdd[B];
     
     indexIncrement[OUTPUT] >> boundCheck[A];
     indexIncrement[OUTPUT] >> indexSteer[VALUE];
     
     //     FromProbe(sumAdd[OUTPUT], sumSteer[VALUE]);
      sumAdd[OUTPUT] >> sumSteer[VALUE];

     boundCheck[OUTPUT] >> retSteer[PREDICATE];
     boundCheck[OUTPUT] >> firstCheckSteer[PREDICATE];
     boundCheck[OUTPUT] >> boundSteer[PREDICATE];
     boundCheck[OUTPUT] >> indexSteer[PREDICATE];
     boundCheck[OUTPUT] >> sumSteer[PREDICATE];
     
     retSteer[OUT_FALSE] >> retAdvance[INPUT];
     firstCheckSteer[OUT_FALSE] >> firstCheckAdvance[INPUT];
     boundSteer[OUT_FALSE] >> boundAdvance[INPUT];
     indexSteer[OUT_FALSE] >> indexAdvance[INPUT];
     sumSteer[OUT_FALSE] >> sumAdvance[INPUT];
     
     sumSteer[OUT_TRUE] >> ret[DATA];
     retSteer[OUT_TRUE] >> ret[DST];
 
     ctr[OUTPUT] >> ctrIn[INPUT];
     data[OUTPUT] >> dataIn[INPUT];

     Sink sink;

     ctr.Fire(WaveScalarValue(0,0,0));

     data.Fire(WaveScalarValue(0,1,4));
     data.Fire(WaveScalarValue(0,2,1));
     data.Fire(WaveScalarValue(0,3,1));
     data.Fire(WaveScalarValue(0,4,1));
     data.Fire(WaveScalarValue(0,5,1));
}
#endif
int main (int argc, char *argv[]) 
{

}
