#ifndef WS_ASM_PROCS_HEADER
#define WS_ASM_PROCS_HEADER

#define OUTPUT_RETURN_OFFSET  0
#define OUTPUT_RA_OFFSET      1
#define OUTPUT_GP_OFFSET      2
#define OUTPUT_SP_OFFSET      3
#define OUTPUT_FP0_OFFSET     4
#define OUTPUT_FP1_OFFSET     5
#define WAVE_RENDEVOUS_OFFSET 6

#define FN_LABEL(fname) ^.code::fname

#define CALL_IMPL_NB(IS_INST, TARG, RA, OUTPUT_RET, OUTPUT_FP, \
                     OUTPUT_A0, OUTPUT_A1, OUTPUT_A2, OUTPUT_A3, OUTPUT_A4, OUTPUT_A5, \
                     OUTPUT_RA, OUTPUT_PV, OUTPUT_GP, OUTPUT_SP, OUTPUT_FP0, OUTPUT_FP1, \
                     OUTPUT_FPA0, OUTPUT_FPA1, OUTPUT_FPA2, OUTPUT_FPA3, OUTPUT_FPA4, OUTPUT_FPA5, \
                     RENDEVOUS_WAVE) \
print RA, RA | \
IS_INST RA, TARG, 0 .attrs(isForFunctionCall=1)|                \
IS_INST OUTPUT_RET,  TARG,  1 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FP,   TARG,  2 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_A0,   TARG,  3 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_A1,   TARG,  4 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_A2,   TARG,  5 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_A3,   TARG,  6 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_A4,   TARG,  7 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_A5,   TARG,  8 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_RA,   TARG,  9 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_PV,   TARG, 10 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_GP,   TARG, 11 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_SP,   TARG, 12 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FP0,  TARG, 13 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FP1,  TARG, 14 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FPA0, TARG, 15 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FPA1, TARG, 16 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FPA2, TARG, 17 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FPA3, TARG, 18 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FPA4, TARG, 19 .attrs(isForFunctionCall=1) | \
IS_INST OUTPUT_FPA5, TARG, 20 .attrs(isForFunctionCall=1) | \
IS_INST RENDEVOUS_WAVE, TARG, 21 .attrs(isForFunctionCall=1)


#define CALL_PC_NB(TARG, RA, OUTPUT_RET, OUTPUT_FP, \
                   OUTPUT_A0, OUTPUT_A1, OUTPUT_A2, OUTPUT_A3, OUTPUT_A4, OUTPUT_A5, \
                   OUTPUT_RA, OUTPUT_PV, OUTPUT_GP, OUTPUT_SP, OUTPUT_FP0, OUTPUT_FP1, \
                   OUTPUT_FPA0, OUTPUT_FPA1, OUTPUT_FPA2, OUTPUT_FPA3, OUTPUT_FPA4, OUTPUT_FPA5, \
                   RENDVOUS_WAVE) \
CALL_IMPL_NB(is_pc, TARG, RA, OUTPUT_RET, OUTPUT_FP, \
                    OUTPUT_A0, OUTPUT_A1, OUTPUT_A2, OUTPUT_A3, OUTPUT_A4, OUTPUT_A5, \
                    OUTPUT_RA, OUTPUT_PV, OUTPUT_GP, OUTPUT_SP, OUTPUT_FP0, OUTPUT_FP1, \
                    OUTPUT_FPA0, OUTPUT_FPA1, OUTPUT_FPA2, OUTPUT_FPA3, OUTPUT_FPA4, OUTPUT_FPA5, \
                    RENDVOUS_WAVE) 

#define CALL_NB(TARG, RA, OUTPUT_RET, OUTPUT_FP, \
                   OUTPUT_A0, OUTPUT_A1, OUTPUT_A2, OUTPUT_A3, OUTPUT_A4, OUTPUT_A5, \
                   OUTPUT_RA, OUTPUT_PV, OUTPUT_GP, OUTPUT_SP, OUTPUT_FP0, OUTPUT_FP1, \
                   OUTPUT_FPA0, OUTPUT_FPA1, OUTPUT_FPA2, OUTPUT_FPA3, OUTPUT_FPA4, OUTPUT_FPA5, \
                   RENDVOUS_WAVE) \
CALL_IMPL_NB(is, TARG, RA, OUTPUT_RET, OUTPUT_FP, \
                 OUTPUT_A0, OUTPUT_A1, OUTPUT_A2, OUTPUT_A3, OUTPUT_A4, OUTPUT_A5, \
                 OUTPUT_RA, OUTPUT_PV, OUTPUT_GP, OUTPUT_SP, OUTPUT_FP0, OUTPUT_FP1, \
                 OUTPUT_FPA0, OUTPUT_FPA1, OUTPUT_FPA2, OUTPUT_FPA3, OUTPUT_FPA4, OUTPUT_FPA5, \
                 RENDVOUS_WAVE)

#define RECV_RETURN(RETURN_LABEL, OUTPUT_RETURN, OUTPUT_RA, OUTPUT_GP, OUTPUT_SP, \
                    OUTPUT_FP0, OUTPUT_FP1, CURR_WAVE_IN_RENDEVOUS_WAVE) \
RETURN_LABEL: ir OUTPUT_RETURN |\
              ir OUTPUT_RA | \
              ir OUTPUT_GP | \
              ir OUTPUT_SP | \
              ir OUTPUT_FP0 | \
              ir OUTPUT_FP1 | \
              ir CURR_WAVE_IN_RENDEVOUS_WAVE

#define PROC_START(NAME)                                    \
  .declare_labels NAME, NAME##_local|			    \
.scope_explicit_import NAME |                               \
.import NAME |                                              \
.import NAME##_local |                                              \
  NAME##_local: |						      \
NAME: |                                                     \
func_start RA             .attrs(regNum=80) |               \
func_start OUTPUT_RET     .attrs(regNum=0)  |               \
func_start OUTPUT_FP      .attrs(regNum=15) |               \
func_start OUTPUT_A0      .attrs(regNum=16) |               \
func_start OUTPUT_A1      .attrs(regNum=17) |               \
func_start OUTPUT_A2      .attrs(regNum=18) |               \
func_start OUTPUT_A3      .attrs(regNum=19) |               \
func_start OUTPUT_A4      .attrs(regNum=20) |               \
func_start OUTPUT_A5      .attrs(regNum=21) |               \
func_start OUTPUT_RA      .attrs(regNum=26) |               \
func_start OUTPUT_PV      .attrs(regNum=27) |               \
func_start OUTPUT_GP      .attrs(regNum=29) |               \
func_start OUTPUT_SP      .attrs(regNum=30) |               \
func_start OUTPUT_FP0     .attrs(regNum=32) |               \
func_start OUTPUT_FP1     .attrs(regNum=33) |               \
func_start OUTPUT_FPA0    .attrs(regNum=48) |               \
func_start OUTPUT_FPA1    .attrs(regNum=49) |               \
func_start OUTPUT_FPA2    .attrs(regNum=50) |               \
func_start OUTPUT_FPA3    .attrs(regNum=51) |               \
func_start OUTPUT_FPA4    .attrs(regNum=52) |               \
func_start OUTPUT_FPA5    .attrs(regNum=53) |               \
func_start RENDEVOUS_WAVE .attrs(regNum=78)


#define PROC_END_NOMEM(NAME, _OUTPUT_RETURN, _RENDEVOUS_WAVE, _RETURN_ADDR)      \
.scope_explicit |                                                       \
.import _OUTPUT_RETURN as peOUTPUT_RETURN |                               \
.import _RENDEVOUS_WAVE as peRENDEVOUS_WAVE |                             \
.import _RETURN_ADDR as peRA |                                            \
/*.import RENDEVOUS_WAVE, OUTPUT_RA, OUTPUT_GP, OUTPUT_SP, OUTPUT_FP0, OUTPUT_FP1 |       */\
.declare_arcs rwOUTPUT_RA, rwOUTPUT_GP, rwOUTPUT_SP, rwOUTPUT_FP0, rwOUTPUT_FP1 | \
.declare_arcs peOUTPUT_RA, peOUTPUT_GP, peOUTPUT_SP, peOUTPUT_FP0, peOUTPUT_FP1 | \
.declare_arcs raInRendevousWave, currWaveInRendevousWave |              \
    wtd peCurrWave, peRENDEVOUS_WAVE |                                  \
    dtw rwCurrWave, peRENDEVOUS_WAVE, peCurrWave | \
    dtw rwOUTPUT_RA, NAME::RENDEVOUS_WAVE, NAME::OUTPUT_RA | \
    dtw rwOUTPUT_GP, NAME::RENDEVOUS_WAVE, NAME::OUTPUT_GP | \
    dtw rwOUTPUT_SP, NAME::RENDEVOUS_WAVE, NAME::OUTPUT_SP | \
    dtw rwOUTPUT_FP0, NAME::RENDEVOUS_WAVE, NAME::OUTPUT_FP0 | \
    dtw rwOUTPUT_FP1, NAME::RENDEVOUS_WAVE, NAME::OUTPUT_FP1 | \
    dtw peOUTPUT_RA, rwCurrWave, rwOUTPUT_RA | \
    dtw peOUTPUT_GP, rwCurrWave, rwOUTPUT_GP | \
    dtw peOUTPUT_SP, rwCurrWave, rwOUTPUT_SP | \
    dtw peOUTPUT_FP0, rwCurrWave, rwOUTPUT_FP0 | \
    dtw peOUTPUT_FP1, rwCurrWave, rwOUTPUT_FP1 | \
    dtw raInRendevouseWave, peRENDEVOUS_WAVE, peRA |                    \
    dtw currWaveInRendevousWave, peRENDEVOUS_WAVE, peCurrWave |         \
    isret  peOUTPUT_RETURN, peRA, OUTPUT_RETURN_OFFSET |                   \
    isret  peOUTPUT_RA,     peRA, OUTPUT_RA_OFFSET | \
    isret  peOUTPUT_GP,     peRA, OUTPUT_GP_OFFSET | \
    isret  peOUTPUT_SP,     peRA, OUTPUT_SP_OFFSET | \
    isret  peOUTPUT_FP0,    peRA, OUTPUT_FP0_OFFSET | \
    isret  peOUTPUT_FP1,    peRA, OUTPUT_FP1_OFFSET | \
    isret  currWaveInRendevousWave, raInRendevouseWave, WAVE_RENDEVOUS_OFFSET | \
.endscope |\
.endscope


#define PROC_END(NAME, OUTPUT_RETURN, RENDEVOUS_WAVE, RETURN_ADDR) \
.scope_explicit |                                                       \
.import OUTPUT_RETURN as _OUTPUT_RETURN |                               \
.import RENDEVOUS_WAVE as _RENDEVOUS_WAVE |                             \
.import RETURN_ADDR as _RA |                                            \
.declare_arcs peOUTPUT_RETURN, peRENDEVOUS_WAVE, peRA |                 \
    cwa peRA,  _RA <?, 1, 1>.0                     |                    \
    wa  peOUTPUT_RETURN, _OUTPUT_RETURN            |                    \
    wa  peRENDEVOUS_WAVE, _RENDEVOUS_WAVE |                             \
    PROC_END_NOMEM(NAME, peOUTPUT_RETURN, peRENDEVOUS_WAVE, peRA) |     \
.endscope


#endif

/*

#define PROC_END_NOMEM(OUTPUT_RETURN, OUTPUT_RA, OUTPUT_GP, OUTPUT_SP, OUTPUT_FP0, OUTPUT_FP1, RENDEVOUS_WAVE, RETURN_ADDR) \
.scope_explicit |                                                \
.import OUTPUT_RETURN as _OUTPUT_RETURN |                               \
.import OUTPUT_RA as peOUTPUT_RA |                                       \
.import OUTPUT_GP as peOUTPUT_GP |                                       \
.import OUTPUT_SP as peOUTPUT_SP |                                       \
.import OUTPUT_FP0 as peOUTPUT_FP0 |                                     \
.import OUTPUT_FP1 as peOUTPUT_FP1 |                                     \
.import RENDEVOUS_WAVE as peRENDEVOUS_WAVE |                             \
.import RETURN_ADDR as peRA |                                            \
.declare_arcs peOUTPUT_RETURN, peOUTPUT_RA, peOUTPUT_GP, peOUTPUT_SP |  \
.declare_arcs peOUTPUT_FP0, peOUTPUT_FP1, peRENDEVOUS_WAVE, peRA |      \
    wtd peCurrWave, peRENDEVOUS_WAVE |                                  \
    dtw raInRendevouseWave, peRENDEVOUS_WAVE, peRA |                    \
    dtw currWaveInRendevousWave, peRENDEVOUS_WAVE, peCurrWave |         \
    is  peOUTPUT_RETURN, peRA, OUTPUT_RETURN_OFFSET |                   \
    is  peOUTPUT_RA, peRA, OUTPUT_RA_OFFSET | \
    is  peOUTPUT_GP, peRA, OUTPUT_GP_OFFSET | \
    is  peOUTPUT_SP, peRA, OUTPUT_SP_OFFSET | \
    is  peOUTPUT_FP0, peRA, OUTPUT_FP0_OFFSET | \
    is  peOUTPUT_FP1, peRA, OUTPUT_FP1_OFFSET | \
    is  currWaveInRendevousWave, raInRendevouseWave, WAVE_RENDEVOUS_OFFSET | \
.endscope |\
.endscope

#define PROC_END(OUTPUT_RETURN, OUTPUT_RA, OUTPUT_GP, OUTPUT_SP, OUTPUT_FP0, OUTPUT_FP1, RENDEVOUS_WAVE, RETURN_ADDR) \
.scope_explicit |                                                       \
.import OUTPUT_RETURN as _OUTPUT_RETURN |                               \
.import OUTPUT_RA as _OUTPUT_RA |                                       \
.import OUTPUT_GP as _OUTPUT_GP |                                       \
.import OUTPUT_SP as _OUTPUT_SP |                                       \
.import OUTPUT_FP0 as _OUTPUT_FP0 |                                     \
.import OUTPUT_FP1 as _OUTPUT_FP1 |                                     \
.import RENDEVOUS_WAVE as _RENDEVOUS_WAVE |                             \
.import RETURN_ADDR as _RA |                                            \
.declare_arcs peOUTPUT_RETURN, peOUTPUT_RA, peOUTPUT_GP, peOUTPUT_SP |  \
.declare_arcs peOUTPUT_FP0, peOUTPUT_FP1, peRENDEVOUS_WAVE, peRA |      \
    cwa peOUTPUT_RETURN, OUTPUT_RETURN <?, 1, 1> |                      \
    wa  peOUTPUT_RA,      _OUTPUT_RA |                                  \
    wa  peOUTPUT_GP,      _OUTPUT_GP |                                  \
    wa  peOUTPUT_SP,      _OUTPUT_SP |                                  \
    wa  peOUTPUT_FP0,     _OUTPUT_FP0 |                                 \
    wa  peOUTPUT_FP1,     _OUTPUT_FP1 |                                 \
    wa  peRENDEVOUS_WAVE, _RENDEVOUS_WAVE |                             \
    wa  peRA, _RA |                                                     \
    PROC_END_NOMEM(peOUTPUT_RETURN, peOUTPUT_RA, peOUTPUT_GP, peOUTPUT_SP, peOUTPUT_FP0, peOUTPUT_FP1, peRENDEVOUS_WAVE, peRA) |\
.endscope

*/
