#ifndef __MBARRIER_HEADER
#define __MBARRIER_HEADER

#include <memthreads/mtypes.h>
#include <memthreads/qlock.h>

typedef struct _mbarrier {
  volatile wsint64 count, max_count;
  volatile wsint64 lock;
  volatile thread_queue_t waiters;
} mbarrier_t;

void mbarrier_initialize(volatile mbarrier_t *barrier, wsint64 max_count);
void mbarrier_wait(volatile mbarrier_t *barrier);
#define mbarrier_reset(barrier) (spinlock_acquire(&(barrier)->lock), mbarrier_reset_impl(barrier))
void mbarrier_reset_impl(volatile mbarrier_t *barrier);

#endif
