#ifndef __MTHREADS_HEADER
#define __MTHREADS_HEADER

/**
 * Header for memory-based threads package
 * 
 * $Id: mthreads.h,v 1.9 2004/02/29 00:46:09 schwerin Exp $
 */

#include <memthreads/mtypes.h>
#include <ws/types.h>
#include <memthreads/qlock.h>
#include <memthreads/mcslock.h>

typedef struct _mthread_context {
  volatile mcs_qnode_t mcs_qnode;
  volatile void * retval;
  volatile MBOOL spin_signal;
  volatile MBOOL is_detached;
  volatile MBOOL is_done;
} mthread_context_t;

typedef struct _mthread_global {
  volatile qlock_t           mt_global_qlock;
  volatile mtid_t            next_mtid;
  volatile thread_queue_t    free_mtids;
} volatile mthread_global_t;

union _mthread_context_u {
  mthread_context_t context;
  char buffer[128];
};

extern mthread_global_t _mthread_global;
extern union _mthread_context_u _mtcdata[MAXTHREADS];


#define MT_GLOBAL_QLOCK (_mthread_global.mt_global_qlock)
#define MT_GLOBAL_FREE_TIDQ (_mthread_global.free_mtids)
#define MT_GLOBAL_NEXT_MTID (_mthreads_global.next_mtid)
#define MT_CONTEXT(TID) (_mtcdata[TID].context)
#define MT_SPIN_SIGNAL(TID) (MT_CONTEXT(TID).spin_signal)
#define MT_MCS_QNODE(TID) (MT_CONTEXT(TID).mcs_qnode)

mtid_t mthread_create_pc(mthread_fn fnptr, void *param);
void mthread_detach(mtid_t tid);
void * mthread_join(mtid_t tid);
mtid_t mthread_get_tid(void);

void _mthread_launch_pc(mthread_fn fnptr, mtid_t tid, void *param, void *drfn);
void _mthread_do_run(mthread_fn fnptr, mtid_t tid, void *param);

#endif
