#define INCLUDE_SMT_OP_STUFF
#include"alphaInst.h"
#include <glib.h>
#include <assert.h>

guint32 buildConstBIS(int dst, int immediate) 
{
     union alpha_instruction r;
 
     assert(dst <= 31);

     r.word = 0;
     r.l_format.rc = dst;
     r.l_format.ra = 31;
     r.l_format.literal = immediate;
     r.l_format.opcode  = 0x11;
     r.l_format.function = BIS;
     r.l_format.form = 1;
     return (guint32)r.word;
}

guint32 buildCopyInst(int reg) {
     union alpha_instruction r;
     if (reg <= 31) {
	  r.word = 0;
	  r.o_format.rc = reg;
	  r.o_format.ra = reg;
	  r.o_format.rb = 31;
	  r.o_format.opcode  = 0x11;
	  r.o_format.function = BIS;
	  r.o_format.form = 0;
	  return (guint32)r.word;
     } else {
	  reg -= 31;
	  r.f_format.fc = reg;
	  r.f_format.fa = reg;
	  r.f_format.opcode = FLTI;
	  r.f_format.function = ADDS;
	  return (guint32)r.word;
     }
}

guint32 buildNopInst() 
{
     union alpha_instruction r;
     r.word = 0;
     r.o_format.rc = 31;
     r.o_format.ra = 31;
     r.o_format.rb = 31;
     r.o_format.opcode  = 0x11;
     r.o_format.function = BIS;
     r.o_format.form = 0;
     return (guint32)r.word;
}

guint32 buildBISInst(int src1, int src2, int dst)
{
     union alpha_instruction r;
     
     r.word = 0;
     r.o_format.rc = dst;
     r.o_format.ra = src1;
     r.o_format.rb = src2;
     r.o_format.opcode  = 0x11;
     r.o_format.function = BIS;
     r.o_format.form = 0;
     
     return (guint32)r.word;
}
