#ifndef CONTROL_DISTRIBUTION_INCLUDED
#define CONTROL_DISTRIBUTION_INCLUDED

typedef struct _CONTROL_DISTRIBUTION_EDGE *PControlDistributionEdge;

#include "basicBlock.h"
#include "set.h"

typedef enum {CONTROL_DISTRIBUTION_CONDITIONAL, 
	      CONTROL_DISTRIBUTION_UNCONDITIONAL, 
	      CONTROL_DISTRIBUTION_MAX} ControlDistributionType;
 
typedef struct _CONTROL_DISTRIBUTION_EDGE {
     PSet dsts;
     ControlDistributionType type;
     PBasicBlock src;
} ControlDistributionEdge;

void controlDistributionInit(PFunction func);
void controlDistrubutionOptimize(PFunction func);
PControlDistributionEdge controlDistributionEdgeNew(PBasicBlock src, ControlDistributionType type);
void controlDistributionEdgeFree(PControlDistributionEdge e);
void controlDistributionPrint(PFunction func, FILE *f);
void controlDistributionAddDfgEdges(PFunction func);

#endif
