#ifndef DOMINANCE_INCLUDED
#define DOMINANCE_INCLUDED

typedef struct _DOMINANCE_DATA *PDominanceData;

typedef enum {DOMINANCE_DIRECTION_PRE = 0, 
	      DOMINANCE_DIRECTION_POST = 1, 
	      DOMINANCE_DIRECTION_MAX = 2} DominanceDirection;

#include <stdio.h>
#include "function.h"
#include "set.h"
#include "ptrSet.h"

typedef struct _DOMINANCE_DATA {
     GList *dominates;
     PBasicBlock dominator;
     PSet dominanceFrontier;
     PPtrSet dominatedNodes;
} DominanceData;

void dominanceComputeDominanceFrontiers(PFunction func, DominanceDirection dir);
void dominancePrintDominatorTree(PFunction func, FILE *f, DominanceDirection dir);
void dominancePrintCDG(PFunction func, FILE *f);
void dominanceComputeDominatorTree(PFunction func, DominanceDirection dir);
void dominanceTearDown(PFunction func);

#endif
