#ifndef EPOCH_INCLUDED
#define EPOCH_INCLUDED

#include <stdio.h>

#define EPOCH_ORDER_UNKNOWN   -1
#define EPOCH_ORDER_UNDEFINED -2
#define EPOCH_ORDER_TERMINATE -3
#define EPOCH_ORDER_START     -4
     
inline static char* EPOCH_ORDER_NAME(int n) 
{
     static char buf[1024];
     switch(-n) {
     case 1:
	  return "UNKN";
     case 2:
	  return "UNDEF";
     case 3:
	  return "TERM";
     case 4:
	  return "START";
     default:
	  sprintf(buf, "%d", n);
	  return buf;
     }
}

#ifndef IN_SURFER
#include "inst.h"

void epochTagSPrint(char *s, PInst inst);
void epochTagPrint(FILE *f, PInst inst);
void epochOptimize(PFunction func);
void epochTagPrintRaw(FILE *f, Epoch prev, Epoch cur, Epoch next, RippleSize rippleSize);
void epochTagSPrintRaw(char *s, Epoch prev, Epoch cur, Epoch next, RippleSize rippleSize);

void epochOptimizeCoordinators(PFunction func);
void epochMarkUnneededCoordinators(PFunction func);
#endif

#endif
