#include"WSOpCode.h"

#ifndef IN_SURFER
#include"md_opcode.h"
#endif

#include "instDefs.h"

// This array maps from input and output types to function input regs.  This is
// only for function calls.  0 is the return value register. It is not strictly
// input but it won't hurt to list it since it is caller saved.
//
// For the new Bliss-based simulator this is use in conjunction with
// functionDef.h:functionOutputType to figure out which output values to log in
// FunctionInvocation
/* int ARG_TYPE_TO_REG[] = {0, 15, 16, 17,  */
/* 			 18, 19, 20, 21,  */
/* 			 26, 27, 29, 30,  */
/* 			 32 + 0, 32 + 1, 32+16, 32+17,  */
/* 			 32+18, 32+19, 32+20, 32+21,  */
/* 			 78, -1}; */

/* // This maps the other way.  IT is imperative that the orderings in the */
/* // definitions of InputType and OutputType be the same so that we can use one */
/* // map for both. */
/* int REG_TO_ARG_TYPE[] = {OUTPUT_RET, /\*0*\/ */
/* 			 -1, /\*1*\/ */
/* 			 -1, /\*2*\/ */
/* 			 -1, /\*3*\/ */
/* 			 -1, /\*4*\/ */
/* 			 -1, /\*5*\/ */
/* 			 -1, /\*6*\/ */
/* 			 -1, /\*7*\/ */
/* 			 -1, /\*8*\/ */
/* 			 -1, /\*9*\/ */
/* 			 -1, /\*10*\/ */
/* 			 -1, /\*11*\/ */
/* 			 -1, /\*12*\/ */
/* 			 -1, /\*13*\/ */
/* 			 -1, /\*14*\/ */
/* 			 OUTPUT_FP, /\*15*\/ */
/* 			 OUTPUT_A0, /\*16*\/ */
/* 			 OUTPUT_A1, /\*17*\/ */
/* 			 OUTPUT_A2, /\*18*\/ */
/* 			 OUTPUT_A3, /\*19*\/ */
/* 			 OUTPUT_A4, /\*20*\/ */
/* 			 OUTPUT_A5, /\*21*\/ */
/* 			 -1, /\*22*\/ */
/* 			 -1, /\*23*\/ */
/* 			 -1, /\*24*\/ */
/* 			 -1, /\*25*\/ */
/* 			 OUTPUT_RA, /\*26*\/ */
/* 			 OUTPUT_PV, /\*27*\/ */
/* 			 -1, /\*28*\/ */
/* 			 OUTPUT_GP, /\*29*\/ */
/* 			 OUTPUT_SP, /\*30*\/ */
/* 			 -1, /\*31*\/ */
/* 			 OUTPUT_FP0, /\*32*\/ */
/* 			 OUTPUT_FP1, /\*33*\/ */
/* 			 -1, /\*34*\/ */
/* 			 -1, /\*35*\/ */
/* 			 -1, /\*36*\/ */
/* 			 -1, /\*37*\/ */
/* 			 -1, /\*38*\/ */
/* 			 -1, /\*39*\/ */
/* 			 -1, /\*40*\/ */
/* 			 -1, /\*41*\/ */
/* 			 -1, /\*42*\/ */
/* 			 -1, /\*43*\/ */
/* 			 -1, /\*44*\/ */
/* 			 -1, /\*45*\/ */
/* 			 -1, /\*46*\/ */
/* 			 -1, /\*47*\/ */
/* 			 OUTPUT_FPA0, /\*48*\/ */
/* 			 OUTPUT_FPA1, /\*49*\/ */
/* 			 OUTPUT_FPA2, /\*50*\/ */
/* 			 OUTPUT_FPA3, /\*51*\/ */
/* 			 OUTPUT_FPA4, /\*52*\/ */
/* 			 OUTPUT_FPA5, /\*53*\/ */
/* 			 -1, /\*54*\/ */
/* 			 -1, /\*55*\/ */
/* 			 -1, /\*56*\/ */
/* 			 -1, /\*57*\/ */
/* 			 -1, /\*58*\/ */
/* 			 -1, /\*59*\/ */
/* 			 -1, /\*60*\/ */
/* 			 -1, /\*61*\/ */
/* 			 -1, /\*62*\/ */
/* 			 -1, /\*63*\/ */
/* 			 -1, /\*64*\/ */
/* 			 -1, /\*65*\/ */
/* 			 -1, /\*66*\/ */
/* 			 -1, /\*67*\/ */
/* 			 -1, /\*68*\/ */
/* 			 -1, /\*69*\/ */
/* 			 -1, /\*71*\/ */
/* 			 -1, /\*72*\/ */
/* 			 -1, /\*73*\/ */
/* 			 -1, /\*74*\/ */
/* 			 -1, /\*75*\/ */
/* 			 -1, /\*76*\/ */
/* 			 -1, /\*77*\/ */
/* 			 OUTPUT_WAVE, /\*78*\/ */
/* 			 -1, /\*79*\/ */
			 
/* }; */




char *INPUT_ARG_TYPE_NAME[] = {/* "INPUT_RET",    	                              */
			       		       	 
/* 			       "INPUT_FP",      */
			       		       
/* 			       "INPUT_A0",      */
/* 			       "INPUT_A1",      */
/* 			       "INPUT_A2",      */
/* 			       "INPUT_A3",      */
/* 			       "INPUT_A4",      */
/* 			       "INPUT_A5",      */
	      				       
/* 			       "INPUT_RA",      */
/* 			       "INPUT_PV",      */
			       		       
/* 			       "INPUT_GP",      */
/* 			       "INPUT_SP",      */
					       
/* 			       "INPUT_FP0",     */
/* 			       "INPUT_FP1",     */
			       		       
/* 			       "INPUT_FPA0",    */
/* 			       "INPUT_FPA1",    */
/* 			       "INPUT_FPA2",    */
/* 			       "INPUT_FPA3",    */
/* 			       "INPUT_FPA4",    */
/* 			       "INPUT_FPA5",    */
/* 			       "INPUT_WAVE", */
					       
			       "INPUT_A",  
			       "INPUT_B", 
			       "INPUT_C", 
			       //			       "INPUT_PREDICATE",
			       //			       "INPUT_CONTROL",
			       //"INPUT_TAKEN", /* These two are for phi functions */
			       //			       "INPUT_NOT_TAKEN",
			       //"INPUT_LOOP_ENTRY",	/* These are for loop phi functions */
			       //"INPUT_LOOP_CARRIED",
/* 			       "INPUT_MEM", */
/* 			       "INPUT_MEM_ORDER", */
/* 			       "INPUT_MEM_ORDER_COORDINATION", */
//			       "INPUT_OTHER",  
			       //"INPUT_SWITCH", 
			       //"INPUT_JMP_DST",
			       //			       "INPUT_IDENTITY",
			       //"INPUT_CMOVE",
			       "INPUT_SERIALIZE",
			       //"INPUT_EPOCH",
			       //"INPUT_EPOCH_COOR",
			       //"INPUT_SPECIAL_ARCH_TRACE",

			       // None of these are really inputs
			       "INPUT_LOAD_VALUE",   // This is a special input for values returning from the store buffer
			       "INPUT_LOAD_REQUEST", // These four are for the store buffer 
			       "INPUT_STORE_REQUEST",
			       "INPUT_MEM_NOOP_REQUEST",
			       "INPUT_WAVE_ADVANCE_REQUEST",
			       "INPUT_MAX",
			       "INPUT_INVALID"};                            


char *OUTPUT_ARG_TYPE_NAME[] = {/* "OUTPUT_RET",                                 */
				
/* 				"OUTPUT_FP", */
				
/* 				"OUTPUT_A0", */
/* 				"OUTPUT_A1", */
/* 				"OUTPUT_A2", */
/* 				"OUTPUT_A3", */
/* 				"OUTPUT_A4", */
/* 				"OUTPUT_A5", */
				
/* 				"OUTPUT_RA", */
/* 				"OUTPUT_PV", */
				
/* 				"OUTPUT_GP", */
/* 				"OUTPUT_SP", */
				
/* 				"OUTPUT_FP0", */
/* 				"OUTPUT_FP1", */

/* 				"OUTPUT_FPA0", */
/* 				"OUTPUT_FPA1", */
/* 				"OUTPUT_FPA2", */
/* 				"OUTPUT_FPA3", */
/* 				"OUTPUT_FPA4", */
/* 				"OUTPUT_FPA5", */
/* 				"OUTPUT_WAVE", */

				"OUTPUT_A",
				"OUTPUT_B",
				"OUTPUT_C",
				//				"OUTPUT_CONTROL",
/* 				"OUTPUT_CONTROL_NOT_TAKEN", */
/* 				"OUTPUT_CONTROL_TAKEN", */
/* 				"OUTPUT_NOT_TAKEN",   */
/* 				"OUTPUT_TAKEN", */
/* 				"OUTPUT_MEM", */
/* 				"OUTPUT_MEM_ORDER", */
/* 				"OUTPUT_MEM_LOAD_ORDER", */
/* 				"OUTPUT_MEM_STORE_ORDER", */
/* 				"OUTPUT_MEM_ORDER_COORDINATION", */
//				"OUTPUT_JMP_DST",
				//				"OUTPUT_OTHER", 
				"OUTPUT_SERIALIZE",
/* 				"OUTPUT_EPOCH", */
/* 				"OUTPUT_EPOCH_COOR", */
/* 				"OUTPUT_SPECIAL_ARCH_TRACE", */
				"OUTPUT_MEM_REQUEST_ADDR",  // This is a special output for requests going to the store buffer
				"OUTPUT_MEM_REQUEST_DATA",  // This is a special output for requests going to the store buffer
				"OUTPUT_LOAD_RESPONSE", // This is a special output for requests coming from the store buffer
				"OUTPUT_MAX",
				"OUTPUT_INVALID"};

#if (0)
char *OP_TYPE_NAME[] = { "ALPHA OP",
			   "PHI",
			   "RHO",
			   "SINK",
			   "SOURCE",
			   "CALL",
			   "COPY",
			   "EPOCH",
			   //"EPOCH COOR",
			   "M_NOOP",
			   "SEND",
			   "IND_SEND"};
#endif



#include"uniform_INST.def"
#define INST(OPCODE, FLAGS, IN_COUNT, OUT_COUNT, IMM, IS_MEM, INPUTS, AUTO_INPUTS, OUTPUTS, AUTO_OUTPUTS, FIRE_0_IN_SET, FIRE_0_OUT_SET, FIRE_0_CODE, FIRE_1_IN_SET, FIRE_1_OUT_SET, FIRE_1_CODE, FIRE_2_IN_SET, FIRE_2_OUT_SET, FIRE_2_CODE) #OPCODE ,
#define LINK(a, b) #b , 
char *OP_TYPE_NAME[] = {
#include"Instructions.def"
     "ALPHA OP",
     "CALL"
};
#undef INST

#ifndef IN_SURFER


WSOpCode SSToWSMap[OP_MAX + 1];

void InitSSToWSMap()
{
     unsigned int i;
     for (i = 0; i < OP_MAX + 1; i++) {
	  SSToWSMap[i] = -1;
     }
#define MAP(SS, WS) SSToWSMap[SS] = OP_##WS;
#define SS_NOTHING OP_MAX
#define OP_WS_NOTHING -1
#include"SSToDripMap.def"
#undef MAP
}
#endif
