#ifndef LCC_INCLUDED
#define LCC_INCLUDED

//#define DISPLAY_PROGRESS
#ifdef DISPLAY_PROGRESS
#define progress(format, args...)  fprintf (stderr, format , ## args)
#else
#define progress(format, args...)  
#endif

#define info(format, args...)  fprintf (stderr, format , ## args)
#define error(format, args...)  fprintf (stderr, format , ## args)

typedef struct LCC_OPTIONS {
     char *placeAlgorithm;
     bool_t   printDfg; // data flow
     bool_t   printCfg; // control flow
     bool_t   printCdg; // control dependence
     bool_t   printPostDom; // post dominators
     bool_t   printPreDom; // pre dominators
     bool_t   analyzeOnly; // Only analyze the program, don't change it.
     bool_t   doTiny;  // Use test code (see lcc.c) instead of loading real file
     bool_t   printControlDistribution; 
     bool_t includeExitEnterBlocks; // include the enter and exit blocks in
				    // functions.
     char *cfgOut;  // Export for input in to placement simulator
     char *dfgOut;  // Export for input in to placement simulator
     char *mapOut;  // Export for input in to placement simulator

     char *traceFile;
     char *mapFile;
  
     char *kenTraceBase;

     bool_t performEpochNumbering;
     
     bool_t dumpFinal;
     
     bool_t printEpochControl;

     char *compiledOutput;

     bool_t doRhoFolding;

} LccOptions, *PLccOptions;

extern LccOptions lccOptions;
//typedef void (*PlaceFunction)(GList *basicBlocks, Substrate substrate, int size);



#endif
