#ifndef LIGHTCYCLE_STATS_INCLUDED
#define LIGHTCYCLE_STATS_INCLUDED

typedef struct STATS *PStats;

#include "types.h"
#include "stdio.h"

#define STATS(a) ((a)->stats)

typedef struct STATS {
     StatCount instructionCount[1024];
     StatCount replicatedInstructionCount;
     StatCount noAlphaOpCycles;
} Stats;

typedef struct _STATS_BASIC {
     StatCount epochInvocations;     
     StatCount epochInstructionDistribution[1024];
} StatsBasicBlock;

typedef struct _STATS_INST {
     StatCount executionCount;
     StatCount totalLoadLatency;
} StatsInst;


PStats statsNew();

void statsPrint(void* es, void * p, FILE *f) ;
void statsRecordExecution(void *i);

#endif
