#include <glib.h>
#include "list.h"
#include <assert.h>


GList *g_list_append_link(GList *list, GList *link)
{
     
     return g_list_concat(list, link);

}

GList *g_list_prepend_link(GList *list, GList *link)
{
     return g_list_concat(link, list);
}

GList *g_list_insert_link_after(GList *list, gconstpointer after, GList *link)
{
     GList *l;

     forEachLink(list, l) {
	  if (l->data == after) {
	       l = l->next;
	       break;
	  }
     }

     if (l == NULL) { 
 	  list = g_list_append_link(list, link); 
     } else { 
	  GList *n = link;

	  n->next = l;
	  n->prev = l->prev;
	  
	  l->prev->next = n;
	  l->prev = n;
     } 

     return list;
     
}

GList *g_list_insert_link_before(GList *list, gconstpointer before, GList *link)
{
     GList *l;

     forEachLink(list, l) {
	  if (l->data == before) {
	       break;
	  }
     }

     assert(l);
     if (l == list) { 
 	  list = g_list_prepend_link(list, link); 
     } else { 
	  GList *n = link;

	  n->next = l;
	  n->prev = l->prev;
	  
	  l->prev->next = n;
	  l->prev = n;
     } 

     return list;
     
}

GList * g_list_insert_after(GList *list, gconstpointer after, gconstpointer insert)
{
     
     GList *l;
     forEachLink(list, l) {
	  if (l->data == after) {
	       l = l->next;
	       break;
	  }
     }

     if (l == NULL) { 
 	  list = g_list_append(list, (gpointer)insert); 
     } else { 
	  GList *n = NULL;
	  n = g_list_append(n, (gpointer)insert); // create a new link.

	  n->next = l;
	  n->prev = l->prev;
	  
	  l->prev->next = n;
	  l->prev = n;
     } 
     return list;
}

GList * g_list_insert_before(GList *list, gconstpointer before, gconstpointer insert)
{
     GList *l;

     forEachLink(list, l) {
	  if (l->data == before) {
	       break;
	  }
     }

     assert(l);
     if (l == list) { 
 	  list = g_list_prepend(list, (gpointer)insert); 
     } else { 
	  GList *n = NULL;
	  n = g_list_append(n, (gpointer)insert); // create a new link.

	  n->next = l;
	  n->prev = l->prev;
	  
	  l->prev->next = n;
	  l->prev = n;
     } 

     return list;
}

gpointer g_list_top(GList *list)
{
     if (list) {
	  return (list->data);
     } else {
	  return NULL;
     }
}

GList * g_list_push(GList *list, gpointer data) 
{
     return g_list_prepend(list, data);
}

GList * g_list_pop(GList *list) 
{
     GList *head = list;
     
     list = g_list_remove_link(list, head);
     g_list_free_1(head);

     return list;
}

gpointer g_list_head(GList *list)
{
     return g_list_top(list);
}

GList * g_list_enqueue(GList *list, gpointer data)
{
     return g_list_append(list, data);    
}

GList * g_list_dequeue(GList *list)
{
     return g_list_pop(list);
}

void g_list_sanity(GList *list)
{
     GList *i;

     for(i = list; i != NULL; i = i->next) {
	  if (list->next) {
	       assert(list->next->prev = list);
	  }
	  if (list->prev) {
	       assert(list->prev->next = list);
	  }
     }
}
