#ifndef LIST_INCLUDED
#define LIST_INCLUDED

// This file contains my own extension to the glib doubly-linked list data type

#include <glib.h>

#define forEach(list, link, var) for((link) =                (list), (var) = (typeof(var))((list) == NULL ? NULL : (list)->data) ; (link) != NULL; (link) = g_list_next    (link), (var) = (typeof(var))((link) == NULL ? NULL : (link)->data))


#define forEach_r(list, link, var) for((link) = (g_list_last(list)), (var) = (typeof(var))((g_list_last(list)) == NULL ? NULL : (g_list_last(list))->data) ; (link) != NULL; (link) = g_list_previous(link), (var) = (typeof(var))((link) == NULL ? NULL : (link)->data))

#define forEachLink(list, link) for((link) = (list) ; (link) != NULL; (link) = g_list_next(link))

#define forEachLink_r(list, link) for((link) = (list) ; (link) != NULL; (link) = g_list_previous(link))

#define g_list_empty(list) ((list) == NULL)

GList * g_list_insert_after(GList *list, gconstpointer after, gconstpointer insert);
GList * g_list_insert_before(GList *list, gconstpointer before, gconstpointer insert);

gpointer g_list_top(GList *list);
GList * g_list_push(GList *list, gpointer data);
GList * g_list_pop(GList *list);

gpointer g_list_head(GList *list);
GList * g_list_enqueue(GList *list, gpointer data);
GList * g_list_dequeue(GList *list);

void g_list_sanity(GList *list);

GList *g_list_append_link(GList *list, GList *link);
GList *g_list_prepend_link(GList *list, GList *link);
GList *g_list_insert_link_after(GList *list, gconstpointer after, GList *link);
GList *g_list_insert_link_before(GList *list, gconstpointer before, GList *link);

#endif

