#ifndef PTR_SET_INCLUDED
#define PTR_SET_INCLUDED

#include <glib.h>


typedef struct _PTR_SET *PPtrSet;
typedef GList *PtrSetIndex;

#include "host.h"
#include "list.h"

#define forEachPtrElement(s, i, v) forEach(s->elements, i, v)

typedef struct _PTR_SET {
     GList *elements;
} PtrSet;

void *ptrSetElement(PPtrSet s);
PPtrSet ptrSetNew() ;
void ptrSetFree(PPtrSet s) ;
void ptrSetAdd(PPtrSet s, void *ptr);
bool_t ptrSetElementOf(PPtrSet s, void *ptr) ;
void *ptrSetElement(PPtrSet s);
void ptrSetRemove(PPtrSet s, void *ptr);
void *ptrSetElementIndex(PPtrSet s, int i);
int ptrSetSize(PPtrSet s);
bool_t ptrSetEqual(PPtrSet a, PPtrSet b);
void ptrSetEmpty(PPtrSet s);
void ptrSetUnion(PPtrSet dst, PPtrSet a, PPtrSet b) ;
bool_t ptrSetContains(PPtrSet a, PPtrSet b);
void ptrSetMinus(PPtrSet dst, PPtrSet a, PPtrSet b);
PPtrSet ptrSetCopy(PPtrSet s);
void ptrSetIntersect(PPtrSet dst, PPtrSet a, PPtrSet b) ;
#endif

