#include"rippleChunk.h"
#include"list.h"

PRippleChunk rippleChunkNew(PBasicBlock b)
{
     PRippleChunk n;

     n = (PRippleChunk)calloc(1, sizeof(RippleChunk));
     assert(n);
     n->insts = ptrSetNew();
     n->owner = b;

     n->epochOrder = EPOCH_ORDER_UNDEFINED;
     n->epochOrderPrev = EPOCH_ORDER_UNDEFINED;
     n->epochOrderNext = EPOCH_ORDER_UNDEFINED;
     n->rippleSize = 0;
     n->lastStoreSequenceNumber = -1;
     return n;
}

void rippleChunkSetOwner(PRippleChunk c, PBasicBlock block)
{
     c->owner = block;
}

void rippleChunkAddInst(PRippleChunk c, PInst inst)
{
     inst->rippleChunk = c;
     c->rippleSize++;
     ptrSetAdd(c->insts, inst);
}

PPtrSet rippleChunkGetInstSet(PRippleChunk c)
{
     return c->insts;
}

