#ifndef RIPPLE_CHUNK_INCLUDED
#define RIPPLE_CHUNK_INCLUDED

#include<glib.h>
#include<stdio.h>

#include"types.h"

typedef struct _RIPPLE_CHUNK *PRippleChunk;
#include"ptrSet.h"
#include "function.h"
#include"basicBlock.h"
#include "inst.h"

typedef struct _RIPPLE_CHUNK {
     Epoch epochOrderPrev;
     Epoch epochOrder;
     Epoch epochOrderNext;
     int rippleSize;
     PPtrSet insts;
     PBasicBlock owner;
     PPtrSet possiblePrevMemOps;
     PPtrSet possibleNextMemOps;
     
     int lastStoreSequenceNumber;
} RippleChunk;


PRippleChunk rippleChunkNew(PBasicBlock b);
void rippleChunkSetOwner(PRippleChunk c, PBasicBlock block);
void rippleChunkAddInst(PRippleChunk c, PInst inst);
PPtrSet rippleChunkGetInstSet(PRippleChunk c);

#endif
