/******************************************************************************
******************************************************************************
******************************************************************************
******************************************************************************

THIS IS THE ORIGINAL LIGHT CYCLE LOADER.  I AM NOT SURE WHAT IS DOES ANYMORE OR
WHY IT DOES IT.  I SAVED IT BECAUSE I CAN NEVER BRING MYSELF TO THROW ANYTHING
AWAY.

******************************************************************************
******************************************************************************
******************************************************************************
*******************************************************************************/

/*
 * loader.c - program loader routines
 *
 * This file is a part of the SimpleScalar tool suite written by
 * Todd M. Austin as a part of the Multiscalar Research Project.
 *  
 * The tool suite is currently maintained by Doug Burger and Todd M. Austin.
 * 
 * Copyright (C) 1994, 1995, 1996, 1997 by Todd M. Austin
 *
 * This source file is distributed "as is" in the hope that it will be
 * useful.  The tool set comes with no warranty, and no author or
 * distributor accepts any responsibility for the consequences of its
 * use. 
 * 
 * Everyone is granted permission to copy, modify and redistribute
 * this tool set under the following conditions:
 * 
 *    This source code is distributed for non-commercial use only. 
 *    Please contact the maintainer for restrictions applying to 
 *    commercial use.
 *
 *    Permission is granted to anyone to make or distribute copies
 *    of this source code, either as received or modified, in any
 *    medium, provided that all copyright notices, permission and
 *    nonwarranty notices are preserved, and that the distributor
 *    grants the recipient permission for further redistribution as
 *    permitted by this document.
 *
 *    Permission is granted to distribute this file in compiled
 *    or executable form under the same conditions that apply for
 *    source code, provided that either:
 *
 *    A. it is accompanied by the corresponding machine-readable
 *       source code,
 *    B. it is accompanied by a written offer, with no time limit,
 *       to give anyone a machine-readable copy of the corresponding
 *       source code in return for reimbursement of the cost of
 *       distribution.  This written offer must permit verbatim
 *       duplication by anyone, or
 *    C. it is distributed by someone who received only the
 *       executable form, and is accompanied by a copy of the
 *       written offer of source code that they received concurrently.
 *
 * In other words, you are welcome to use, share and improve this
 * source file.  You are forbidden to forbid anyone else to use, share
 * and improve what you give them.
 *
 * INTERNET: dburger@cs.wisc.edu
 * US Mail:  1210 W. Dayton Street, Madison, WI 53706
 *
 * $Id: lightCycle-loader.c,v 1.1.1.1 2003/01/09 05:41:10 swanson Exp $
 *
 * $Log: lightCycle-loader.c,v $
 * Revision 1.1.1.1  2003/01/09 05:41:10  swanson
 * Kick it off
 *
 * Revision 1.12  2001/12/20 02:04:58  swanson
 * *** empty log message ***
 *
 * Revision 1.11  2001/12/19 22:16:52  swanson
 * *** empty log message ***
 *
 * Revision 1.10  2001/12/17 17:35:28  swanson
 * *** empty log message ***
 *
 * Revision 1.9  2001/12/10 22:59:41  swanson
 * *** empty log message ***
 *
 * Revision 1.8  2001/11/30 19:23:11  swanson
 * *** empty log message ***
 *
 * Revision 1.7  2001/11/30 08:16:41  swanson
 * *** empty log message ***
 *
 * Revision 1.6  2001/11/29 19:51:58  swanson
 * *** empty log message ***
 *
 * Revision 1.5  2001/11/29 02:55:41  swanson
 * *** empty log message ***
 *
 * Revision 1.4  2001/11/28 07:42:13  swanson
 * *** empty log message ***
 *
 * Revision 1.3  2001/11/28 02:28:49  swanson
 * *** empty log message ***
 *
 * Revision 1.2  2001/11/27 09:15:46  swanson
 * *** empty log message ***
 *
 * Revision 1.1.1.1  2001/11/27 00:05:17  swanson
 * simple scalar
 *
 * Revision 1.1.1.1  2000/05/26 15:22:27  taustin
 * SimpleScalar Tool Set
 *
 *
 * Revision 1.3  1999/12/31 18:59:46  taustin
 * quad_t naming conflicts removed
 * cross-endian execution support added (w/ limited syscall support)
 *
 * Revision 1.2  1999/12/13 19:00:08  taustin
 * cross endian execution support added
 *
 * Revision 1.1  1998/08/27 16:54:16  taustin
 * Initial revision
 *
 * Revision 1.1  1998/05/06  01:08:39  calder
 * Initial revision
 *
 * Revision 1.6  1997/04/16  22:09:05  taustin
 * added standalone loader support
 *
 * Revision 1.5  1997/03/11  01:12:39  taustin
 * updated copyright
 * swapping supported disabled until it can be tested further
 *
 * Revision 1.4  1997/01/06  15:59:22  taustin
 * stat_reg calls now do not initialize stat variable values
 * ld_prog_fname variable exported
 *
 * Revision 1.3  1996/12/27  15:51:28  taustin
 * updated comments
 *
 * Revision 1.1  1996/12/05  18:52:32  taustin
 * Initial revision
 *
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include "host.h"
#include "misc.h"
#include "machine.h"
#include "endian.h"
#include "regs.h"
#include "memory.h"
#include "sim.h"
#include "eio.h"
#include "target-alpha/ecoff.h"
#include "loader.h"

#include <assert.h>
#include <glib.h>
#include "function.h"
#include "inst.h"
#include "basicBlock.h"
#include "list.h"
#include "sim-lightCycle.h"
#include "dfg.h"
#include "cfg.h"

#include "program.h"
#include "assert.h"

#ifdef BFD_LOADER
#error 
#endif /* BFD_LOADER */


/* amount of tail padding added to all loaded text segments */
#define TEXT_TAIL_PADDING 0 /* was: 128 */

/* program text (code) segment base */
md_addr_t ld_text_base = 0;

/* program text (code) size in bytes */
unsigned int ld_text_size = 0;

/* program initialized data segment base */
md_addr_t ld_data_base = 0;

/* top of the data segment */
md_addr_t ld_brk_point = 0;

/* program initialized ".data" and uninitialized ".bss" size in bytes */
unsigned int ld_data_size = 0;

/* program stack segment base (highest address in stack) */
md_addr_t ld_stack_base = 0;

/* program initial stack size */
unsigned int ld_stack_size = 0;

/* lowest address accessed on the stack */
md_addr_t ld_stack_min = -1;

/* program file name */
char *ld_prog_fname = NULL;

/* program entry point (initial PC) */
md_addr_t ld_prog_entry = 0;

/* program environment base address address */
md_addr_t ld_environ_base = 0;

/* target executable endian-ness, non-zero if big endian */
int ld_target_big_endian;

/* register simulator-specific statistics */
void
ld_reg_stats(struct stat_sdb_t *sdb)	/* stats data base */
{
     stat_reg_addr(sdb, "ld_text_base",
		   "program text (code) segment base",
		   &ld_text_base, ld_text_base, "0x%010p");
     stat_reg_uint(sdb, "ld_text_size",
		   "program text (code) size in bytes",
		   &ld_text_size, ld_text_size, NULL);
     stat_reg_addr(sdb, "ld_data_base",
		   "program initialized data segment base",
		   &ld_data_base, ld_data_base, "0x%010p");
     stat_reg_uint(sdb, "ld_data_size",
		   "program init'ed `.data' and uninit'ed `.bss' size in bytes",
		   &ld_data_size, ld_data_size, NULL);
     stat_reg_addr(sdb, "ld_stack_base",
		   "program stack segment base (highest address in stack)",
		   &ld_stack_base, ld_stack_base, "0x%010p");
#if 0 /* FIXME: broken... */
     stat_reg_addr(sdb, "ld_stack_min",
		   "program stack segment lowest address",
		   &ld_stack_min, ld_stack_min, "0x%010p");
#endif
     stat_reg_uint(sdb, "ld_stack_size",
		   "program initial stack size",
		   &ld_stack_size, ld_stack_size, NULL);
     stat_reg_addr(sdb, "ld_prog_entry",
		   "program entry point (initial PC)",
		   &ld_prog_entry, ld_prog_entry, "0x%010p");
     stat_reg_addr(sdb, "ld_environ_base",
		   "program environment base address address",
		   &ld_environ_base, ld_environ_base, "0x%010p");
     stat_reg_int(sdb, "ld_target_big_endian",
		  "target executable endian-ness, non-zero if big endian",
		  &ld_target_big_endian, ld_target_big_endian, NULL);
}


/* load program text and initialized data into simulated virtual memory
   space and initialize program segment range variables */
PProgram
ld_load_prog(
	     char *fname,		/* program to load */
	     int argc, char **argv,	/* simulated program cmd line args */
	     char **envp,		/* simulated program environment */
	     struct regs_t *regs,	/* registers to initialize for load */
	     struct mem_t *mem,		/* memory space to load prog into */
	     int zero_bss_segs)		/* zero uninit data segment? */
{
     int i;
     qword_t temp;
     md_addr_t sp, data_break = 0, null_ptr = 0, argv_addr, envp_addr;
     FILE *fobj;
     long floc;
     int instCount = 0;
     PProgram program;
     struct ecoff_filehdr fhdr;
     struct ecoff_aouthdr ahdr;
     struct ecoff_scnhdr shdr;     
     if (sim_chkpt_fname != NULL)
	  fatal("checkpoints only supported while EIO tracing");

     assert(0);
     /* record profile file name */
     ld_prog_fname = argv[0];

     /* load the program into memory, try both endians */

     fobj = fopen(argv[0], "r");

     if (!fobj)
	  fatal("cannot open executable `%s'", argv[0]);

     if (fread(&fhdr, sizeof(struct ecoff_filehdr), 1, fobj) < 1)
	  fatal("cannot read header from executable `%s'", argv[0]);

     /* record endian of target */
     if (fhdr.f_magic == MD_SWAPH(ECOFF_ALPHAMAGIC))
	  ld_target_big_endian = FALSE;
     else if (fhdr.f_magic == MD_SWAPH(ECOFF_EB_MAGIC)
	      || fhdr.f_magic == MD_SWAPH(ECOFF_EL_MAGIC)
	      || fhdr.f_magic == MD_SWAPH(ECOFF_EB_OTHER)
	      || fhdr.f_magic == MD_SWAPH(ECOFF_EL_OTHER))
	  fatal("Alpha simulator cannot run PISA binary `%s'", argv[0]);
     else
	  fatal("bad magic number in executable `%s' (not an executable)",
		argv[0]);

     if (fread(&ahdr, sizeof(struct ecoff_aouthdr), 1, fobj) < 1)
	  fatal("cannot read AOUT header from executable `%s'", argv[0]);

     ld_text_base  = MD_SWAPQ(ahdr.text_start);
     ld_text_size  = MD_SWAPQ(ahdr.tsize);
     ld_prog_entry = MD_SWAPQ(ahdr.entry);
     ld_data_base  = MD_SWAPQ(ahdr.data_start);
     ld_data_size  = MD_SWAPQ(ahdr.dsize) + MD_SWAPQ(ahdr.bsize);
     regs->regs_R[MD_REG_GP] = MD_SWAPQ(ahdr.gp_value);

     /* compute data segment size from data break point */
     data_break = ld_data_base + ld_data_size;



     {
	  char mapName[1024];
	  FILE *mapFile;

	  /* seek to the beginning of the first section header, the file header comes
	     first, followed by the optional header (this is the aouthdr), the size
	     of the aouthdr is given in Fdhr.f_opthdr */
	  fseek(fobj, sizeof(struct ecoff_filehdr) + MD_SWAPH(fhdr.f_opthdr), 0);

	  debug("processing %d sections in `%s'...",
		MD_SWAPH(fhdr.f_nscns), argv[0]);

	  /* loop through the section headers */
	  floc = ftell(fobj);
	  for (i = 0; i < MD_SWAPH(fhdr.f_nscns); i++) {
	       if (fseek(fobj, floc, 0) == -1)
		    fatal("could not reset location in executable");
	       if (fread(&shdr, sizeof(struct ecoff_scnhdr), 1, fobj) < 1)
		    fatal("could not read section %d from executable", i);
	       floc = ftell(fobj);
			 
	       switch (MD_SWAPW(shdr.s_flags)) {

	       case ECOFF_STYP_TEXT:
		    fprintf(stderr, 
			    "found section with %d, will load at %x\n",
			    (int)MD_SWAPQ(shdr.s_size) << 2, 
			    (unsigned int) MD_SWAPQ(shdr.s_vaddr));		    
		    instCount += MD_SWAPQ(shdr.s_size);
		    break;
	       case ECOFF_STYP_INIT:
	       case ECOFF_STYP_FINI:
	       }
	  }

	  instCount = instCount/4 /* alpha inst size */;

	  strcpy(mapName, argv[0]);
	  strcat(mapName, ".map");
				   
	  mapFile = fopen(mapName, "r");
	  if (mapFile == NULL) {
	       fatal("Missing map file for executable `%s'", mapName);
	  }

	  program = programLoad(mapFile, instCount);
	  
	  if (!program) {
	       fatal("Error loading map file '%s'", mapName);
	  }
	  
/*  	  forEach(program->functions, l, func) { */
/*  	       checkFunctionRegUsage(func); */
/*  	  } */
     }
     /* seek to the beginning of the first section header, the file header comes
	first, followed by the optional header (this is the aouthdr), the size
	of the aouthdr is given in Fdhr.f_opthdr */
     fseek(fobj, sizeof(struct ecoff_filehdr) + MD_SWAPH(fhdr.f_opthdr), 0);

     debug("processing %d sections in `%s'...",
	   MD_SWAPH(fhdr.f_nscns), argv[0]);

     /* loop through the section headers */
     floc = ftell(fobj);
     for (i = 0; i < MD_SWAPH(fhdr.f_nscns); i++) {
	  char *p;
	  if (fseek(fobj, floc, 0) == -1)
	       fatal("could not reset location in executable");
	  if (fread(&shdr, sizeof(struct ecoff_scnhdr), 1, fobj) < 1)
	       fatal("could not read section %d from executable", i);
	  floc = ftell(fobj);
		    
	  switch (MD_SWAPW(shdr.s_flags)) {
	  case ECOFF_STYP_TEXT:
	       {
		    // SS: We don't actually load the intsructions
		    // into memory.  Insntead, we load pointers to
		    // our representation of the instruction which
		    // includes all the def-use information. 
		    //
		    // This abuses the fact we intend to run a
		    // 32 machine (so the host pointers are the
		    // same length as instructionts).  The
		    // alternative is to do another level of
		    // mapping somehow.
		    //
		    // We also have to be careful because the
		    // map files don't differentiate between the
		    // main text section and the init/fini
		    // stuff.
				
		    // We need to know which instruction is the
		    // first in the section, so we find the
		    // basic block that starts here and the
		    // first instruction in that block should be
		    // the first instruction in the section.  We
		    // can then just fill in the addresses for
		    // the following instructions.  
		    PC firstBlockAddress = MD_SWAPQ(shdr.s_vaddr);
		    PBasicBlock firstBlock = programFindBasicBlockByPC(program, firstBlockAddress);
		    PInst firstInst = (PInst)firstBlock->insts->data;
		    gint32 binInst;
		    int j;
		    // Grab the first instruction from the section.  This is a sanity check.
		    if (fseek(fobj, MD_SWAPQ(shdr.s_scnptr), 0) == -1)
			 fatal("could not read `.text' from executable", i);
		    if (fread(&binInst, sizeof(md_inst_t), 1, fobj) < 1)
			 fatal("could not read text section from executable");
		    assert(binInst == firstInst->binInst);
				   
		    fprintf(stderr, "From Binary:\n");
		    md_print_insn(binInst, 0, stderr);
		    fprintf(stderr, "\n");
		    for (j = 0; j < 32; j++) {
			 if (fread(&binInst, sizeof(md_inst_t), 1, fobj) < 1)
			      fatal("could not read text section from executable");
			 md_print_insn(binInst, 0, stderr);
			 fprintf(stderr, "\n");
		    }
				   
		    for (j = 0; j < MD_SWAPQ(shdr.s_size); j += 4) {
			 int k = j/4;
			 MEM_WRITE_WORD(mem, 
					MD_SWAPQ(shdr.s_vaddr) + j, 
					(firstInst + k));
		    }
#if (0)
				   
		    fprintf(stderr, "From map:\n") ;
		    for (j = 0; j < 32; j++) {
					
			 md_print_insn((firstInst + j)->binInst, 0, stderr);
										
			 fprintf(stderr, "\n");
		    }
				   
		    fprintf(stderr, "From memory:\n") ;
		    for (j = 0; j < 32; j++) {
			 md_print_insn(MEM_READ_WORD(mem, MD_SWAPQ(shdr.s_vaddr) + j * 4), 0, stderr);
			 fprintf(stderr, "\n");
		    }
#endif
	       }
	       break;
	  case ECOFF_STYP_INIT:
	  case ECOFF_STYP_FINI:
	       if (MD_SWAPQ(shdr.s_size) > 0) {
		    PFunction func = functionNew("INIT-FINI"); 
		    PBasicBlock block = basicBlockNew("INIT-FINI", -1);
		    Inst *instArray;
		    int k, l;
		    assert(0); 

		    functionAddBasicBlock(func, block);
		    basicBlockSetPC(block, MD_SWAPQ(shdr.s_vaddr));
				    
		    if (MD_SWAPW(shdr.s_flags) == ECOFF_STYP_INIT) {
			 assert(!program->initInstructions);
			 program->initInstructions = (Inst *)calloc(sizeof(Inst), MD_SWAPQ(shdr.s_size)/sizeof(md_inst_t));
			 instArray = program->initInstructions;
		    } else if (MD_SWAPW(shdr.s_flags) == ECOFF_STYP_FINI) {
			 assert(!program->finiInstructions);
			 program->finiInstructions = (Inst *)calloc(sizeof(Inst), MD_SWAPQ(shdr.s_size)/sizeof(md_inst_t));
			 instArray = program->finiInstructions;
		    } else {
			 assert(0);
		    }
			 
		    p = calloc(MD_SWAPQ(shdr.s_size), sizeof(char));
		    if (!p)
			 fatal("out of virtual memory");
		
		    if (fseek(fobj, MD_SWAPQ(shdr.s_scnptr), 0) == -1)
			 fatal("could not read `.text' from executable", i);
		    if (fread(p, MD_SWAPQ(shdr.s_size), 1, fobj) < 1)
			 fatal("could not read text section from executable");

		    //		    fprintf(stderr, MD_SWAPW(shdr.s_flags) == ECOFF_STYP_FINI ? "FINI:\n" : "INIT:\n");

		    for (k = 0, l = 0; k < MD_SWAPQ(shdr.s_size); k += sizeof(md_inst_t), l++) {
			 instInitFromBin(instArray + l,*(md_inst_t*)(p + k), MD_SWAPQ(shdr.s_vaddr) + k);

			 basicBlockAppendInst(block, instArray + l);
			 MEM_WRITE_WORD(mem, 
					MD_SWAPQ(shdr.s_vaddr) + k, 
					instArray + l);
			 md_print_insn((instArray + l)->binInst, 0, stderr);
			 fprintf(stderr, "\n");
		    }
		    /* release the section buffer */
		    programAddFunction(program, func);
		    free(p);
	       }
	       else
		    warn("section `%s' is empty...", shdr.s_name);
	       break;

	  case ECOFF_STYP_LITA:
	  case ECOFF_STYP_LIT8:
	  case ECOFF_STYP_LIT4:
	  case ECOFF_STYP_XDATA:
	  case ECOFF_STYP_PDATA:
	  case ECOFF_STYP_RCONST:
	       /* fall through */

	  case ECOFF_STYP_RDATA:
	       /* The .rdata section is sometimes placed before the text
		* section instead of being contiguous with the .data section.
		*/
	       /* fall through */
	  case ECOFF_STYP_DATA:
	       /* fall through */
	  case ECOFF_STYP_SDATA:
	       if (MD_SWAPQ(shdr.s_size) > 0)
		    {
			 p = calloc(MD_SWAPQ(shdr.s_size), sizeof(char));
			 if (!p)
			      fatal("out of virtual memory");

			 if (fseek(fobj, MD_SWAPQ(shdr.s_scnptr), 0) == -1)
			      fatal("could not read `.text' from executable", i);
			 if (fread(p, MD_SWAPQ(shdr.s_size), 1, fobj) < 1)
			      fatal("could not read text section from executable");

			 /* copy program section it into simulator target memory */
			 mem_bcopy(mem_access, mem,
				   Write, MD_SWAPQ(shdr.s_vaddr),
				   p, MD_SWAPQ(shdr.s_size));

			 /* release the section buffer */
			 free(p);
		    }
	       else
		    warn("section `%s' is empty...", shdr.s_name);
	       break;

	  case ECOFF_STYP_BSS:
	  case ECOFF_STYP_SBSS:
	       /* no data to read... */
	       break;

	  default:
	       warn("section `%s' ignored...", shdr.s_name);
	  }
     }

     /* done with the executable, close it */
     if (fclose(fobj))
	  fatal("could not close executable `%s'", argv[0]);



     /* perform sanity checks on segment ranges */
     if (!ld_text_base || !ld_text_size)
	  fatal("executable is missing a `.text' section");
     if (!ld_data_base || !ld_data_size)
	  fatal("executable is missing a `.data' section");
     if (!ld_prog_entry)
	  fatal("program entry point not specified");

     /* determine byte/words swapping required to execute on this host */
     sim_swap_bytes = (endian_host_byte_order() != endian_target_byte_order());
     if (sim_swap_bytes)
	  {
	       assert(0);
	  }
     sim_swap_words = (endian_host_word_order() != endian_target_word_order());
     if (sim_swap_words)
	  {
	       assert(0);
	  }

     /* set up a local stack pointer, this is where the argv and envp
	data is written into program memory */
     ld_stack_base = ld_text_base - (409600+4096);

     sp = ld_stack_base - MD_MAX_ENVIRON;
     ld_stack_size = ld_stack_base - sp;

     /* initial stack pointer value */
     ld_environ_base = sp;

     /* write [argc] to stack */
     temp = MD_SWAPQ(argc);
     mem_access(mem, Write, sp, &temp, sizeof(qword_t));
     regs->regs_R[MD_REG_A0] = temp;
     sp += sizeof(qword_t);

     /* skip past argv array and NULL */
     argv_addr = sp;
     regs->regs_R[MD_REG_A1] = argv_addr;
     sp = sp + (argc + 1) * sizeof(md_addr_t);

     /* save space for envp array and NULL */
     envp_addr = sp;
     for (i=0; envp[i]; i++)
	  sp += sizeof(md_addr_t);
     sp += sizeof(md_addr_t);

     /* fill in the argv pointer array and data */
     for (i=0; i<argc; i++)
	  {
	       /* write the argv pointer array entry */
	       temp = MD_SWAPQ(sp);
	       mem_access(mem, Write, argv_addr + i*sizeof(md_addr_t),
			  &temp, sizeof(md_addr_t));
	       /* and the data */
	       mem_strcpy(mem_access, mem, Write, sp, argv[i]);
	       sp += strlen(argv[i])+1;
	  }
     /* terminate argv array with a NULL */
     mem_access(mem, Write, argv_addr + i*sizeof(md_addr_t),
		&null_ptr, sizeof(md_addr_t));

     /* write envp pointer array and data to stack */
     for (i = 0; envp[i]; i++)
	  {
	       /* write the envp pointer array entry */
	       temp = MD_SWAPQ(sp);
	       mem_access(mem, Write, envp_addr + i*sizeof(md_addr_t),
			  &temp, sizeof(md_addr_t));
	       /* and the data */
	       mem_strcpy(mem_access, mem, Write, sp, envp[i]);
	       sp += strlen(envp[i]) + 1;
	  }
     /* terminate the envp array with a NULL */
     mem_access(mem, Write, envp_addr + i*sizeof(md_addr_t),
		&null_ptr, sizeof(md_addr_t));

     /* did we tromp off the stop of the stack? */
     if (sp > ld_stack_base)
	  {
	       /* we did, indicate to the user that MD_MAX_ENVIRON must be increased,
		  alternatively, you can use a smaller environment, or fewer
		  command line arguments */
	       fatal("environment overflow, increase MD_MAX_ENVIRON in alpha.h");
	  }

     /* initialize the bottom of heap to top of data segment */
     ld_brk_point = ROUND_UP(ld_data_base + ld_data_size, MD_PAGE_SIZE);

     /* set initial minimum stack pointer value to initial stack value */
     ld_stack_min = regs->regs_R[MD_REG_SP];

     regs->regs_R[MD_REG_SP] = ld_environ_base;
     regs->regs_PC = ld_prog_entry;

     debug("ld_text_base: 0x%08x  ld_text_size: 0x%08x",
	   ld_text_base, ld_text_size);
     debug("ld_data_base: 0x%08x  ld_data_size: 0x%08x",
	   ld_data_base, ld_data_size);
     debug("ld_stack_base: 0x%08x  ld_stack_size: 0x%08x",
	   ld_stack_base, ld_stack_size);
     debug("ld_prog_entry: 0x%08x", ld_prog_entry);

     return program;
}
