#ifndef UTIL_INCLUDED
#define UTIL_INCLUDED

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#define simPrint if(!options.quiet) fprintf

#define nice_malloc(var, s) \
do {\
   if (!(var = (typeof(var)) malloc ((s)))) {\
      fprintf (stderr, "File: %s Line: %d  Can't allocate memory:\n", __FILE__, __LINE__);\
      assert(0);\
        }\
} while (0)

#define nice_calloc(var,  s) \
do {\
   if (!(var = (typeof(var)) calloc (s, 1))) {\
      fprintf (stderr, "File: %s Line: %d  Can't allocate memory.\n", __FILE__, __LINE__); \
      fprintf (stderr, "line:  %d\n", __LINE__);\
                assert(0);\
        }\
} while (0)

#define nice_realloc(var,  s) \
do {\
   if ((var = (typeof(var)) realloc ((void *)var,(s))) == NULL) {\
      fprintf (stderr, "file: %s Line: %d  Can't allocate memory\n", __FILE__, __LINE__);\
           assert(0);\
        }\
} while (0)

#ifndef MAX
#define MAX(a,b) ((a) < (b) ? (b) : (a))
#endif
#define RATIO(a,b) (((a) + 0.0)/((b) + 0.0))
#define PERCENT(a, b) (100.0*RATIO(a,b))


void dotifyString(char *t);

#endif
