#include <threads/defs.h>
#include <asm/procs.h>

.section .code

#define MTHREAD_CTX_BASE 5368754376
	
#define MCS_GET_QNODE(QNODE_OUT, TRIGGER) \
.scope_explicit | \
.import QNODE_OUT as qnode_out | \
.import TRIGGER as trigger | \
.declare_arcs tid, ctx_base, ctx_offset | \
	ttd tid, trigger | \
	cnst ctx_base, trigger, MTHREAD_CTX_BASE | \
	sll_I ctx_offset, tid, 7 | \
	addq qnode_out, ctx_base, ctx_offset |\
.endscope

PROC_START(mcs_lock_acquire)
        cwa rw, RENDEVOUS_WAVE <?, 1, 2>.0
        wa  ra, RA
        wa  pLock, OUTPUT_A0

;;; i = &((_mtcdata[mthread_get_tid()].context).mcs_qnode);
.declare_arcs qnode_i
	MCS_GET_QNODE(qnode_i, rw)

;;; i->next = 0;
        cnst zero, ra, 0
        stq  zero, qnode_i, 0                    <1, 2, 3>.1
;;; predecessor = atomic_swap(lock, i)
        swap predecessor, pLock, qnode_i         <2, 3, 1>.2
; 	assert_ne predecessor, qnode_i
; 	print qnode_i, predecessor

;;; if(NULL != predecessor)
        rho {ra_wait,startcnt},       ra_ret,  ra,    predecessor
        rho rw_wait,       rw_ret,             rw,    predecessor
        rho pLock_wait,       { },             pLock, predecessor
        rho qnode_i_wait,     { },           qnode_i, predecessor
        rho predecessor_wait, { },       predecessor, predecessor
; 	print qnode_i_wait, predecessor_wait
;;; {
;;;   i->locked = 1L;
        cnst one, qnode_i_wait, 1
        stq_U spin_trigger,  one, qnode_i_wait, 8
;;;   predecessor->next = i;
        stq_U { sttrig },  qnode_i_wait, predecessor_wait, 0
; 	wait  pww, predecessor_wait, sttrig
; 	ldq_U qiw, pww, 0
; 	print qiw, pww

	;cnst cnt, startcnt, 0
;;;   while(i->locked);
	wait  qnode_i_spin, qnode_i_wait, spin_trigger
	wtd   outwave_spin, qnode_i_wait
        ldq_U iIsLocked, qnode_i_spin, 8
	;addq_I cnt_up, cnt, 1
        rho   qnode_i_spin, { },              qnode_i_spin, iIsLocked .attrs(waveAdvanceAmount=1)
	rho   outwave_spin, outwave_spindone, outwave_spin, iIsLocked .attrs(waveAdvanceAmount=1)
	;rho   cnt,          { },              cnt_up,       iIsLocked .attrs(waveAdvanceAmount=1)
	dtw   spindone_trigger, outwave_spindone, outwave_spindone
	wait  ra_ret, ra_wait, spindone_trigger
	wait  rw_ret, rw_wait, spindone_trigger
	;cnst  ctwo, cnt, 2
	;print cnt, iIsLocked
	;print qnode_i_spin, iIsLocked
;;; }
; 	print rw_ret, ra_ret
PROC_END(mcs_lock_acquire, rw_ret, rw_ret, ra_ret)


PROC_START(mcs_lock_release)
        cwa rw_pre, RENDEVOUS_WAVE     <?, 1, 2>.0
        wa  ra, RA
        wa  pLock, OUTPUT_A0
	mnop_ping rw, rw_pre <1, 2, 3>.1

;;; i = &((_mtcdata[mthread_get_tid()].context).mcs_qnode);
	.declare_arcs qnode_i
	MCS_GET_QNODE(qnode_i, rw)

;;; if(NULL == i->next)
        ldq_U next_of_i, qnode_i, 0
        rho elsemnop, pLock_nosucc, pLock, next_of_i
        rho { }, qnode_i_nosucc, qnode_i, next_of_i
        rho iNext, { }, next_of_i, next_of_i
	rho rw_ret, rw_nosucc, rw, next_of_i
        mnop elsemnop <2, 3, 1>.1
;;; {
;;;   if(compare_and_swap(lock, i, 0L)) return;
        cnst zero, qnode_i_nosucc, 0
        cas definitely_no_succ, pLock_nosucc, qnode_i_nosucc, zero <2, 3, 1>.1
        rho { }, {cnttrig,qnode_i_spin}, qnode_i_nosucc, definitely_no_succ
	rho rw_ret, rw_spin, rw_nosucc, definitely_no_succ
; 	print definitely_no_succ, cnttrig

;;;   while(NULL == i->next);
        ldq_U iHasNext, qnode_i_spin, 0
	wtd   outwave_spin, rw_spin
; 	print qnode_i_spin, iHasNext
        rho { }, qnode_i_spin, qnode_i_spin, iHasNext .attrs(waveAdvanceAmount=1)
        rho iNext, { }, iHasNext, iHasNext .attrs(waveAdvanceAmount=1)
	rho outwave_ret, outwave_spin, outwave_spin, iHasNext .attrs(waveAdvanceAmount=1)
	dtw outwave_trig, outwave_ret, outwave_ret
	wait rw_ret, rw_spin, outwave_trig
;;; }
	cnst zrel, iNext, 0
        stq_U  released_trig, zrel, iNext, 8
; 	print  released_trig, iNext
PROC_END(mcs_lock_release, rw_ret, rw_ret, ra)
