#include <asm/procs.h>

;;;
;;; OUTPUT_A0 is the pointer of the function to run in _mthread_do_run
;;; OUTPUT_A1 is the tid
;;; OUTPUT_A2 is the parameter
;;; OUTPUT_A3 is a pointer to _mthread_do_run
;;;
PROC_START(_mthread_launch_pc)
    cnst wave, RA, 0
    thread_create tid, OUTPUT_A1, wave

    dttw fnptr_in_tid, tid, wave, OUTPUT_A0
    dttw param_in_tid, tid, wave, OUTPUT_A2
    dttw callpc_in_tid, tid, wave, OUTPUT_A3
    dttw oret_in_tid, tid, wave, OUTPUT_RET
    dttw ofp_in_tid, tid, wave, OUTPUT_FP
    dttw ora_in_tid, tid, wave, OUTPUT_RA
    dttw pv_in_tid, tid, wave, OUTPUT_PV
    dttw gp_in_tid, tid, wave, OUTPUT_GP
    dttw fp0_in_tid, tid, wave, OUTPUT_FP0
    dttw fp1_in_tid, tid, wave, OUTPUT_FP1
    dttw fpa0_in_tid, tid, wave, OUTPUT_FPA0
    dttw fpa1_in_tid, tid, wave, OUTPUT_FPA1
    dttw fpa2_in_tid, tid, wave, OUTPUT_FPA2
    dttw fpa3_in_tid, tid, wave, OUTPUT_FPA3
    dttw fpa4_in_tid, tid, wave, OUTPUT_FPA4
    dttw fpa5_in_tid, tid, wave, OUTPUT_FPA5
    ttd  tid_in_tid, param_in_tid
    wtd  wave_in_tid, oret_in_tid
    cnst zero_in_tid, fnptr_in_tid, 0
    cnst _mthread_do_run_arc, oret_in_tid, FN_LABEL(_mthread_do_run)
    cnst _mthread_do_run_ra_arc, ofp_in_tid, ^thread_fn_rtn
    sll_I tid_shifted_in_tid, tid_in_tid, 32
    bis_I sp_in_tid, tid_shifted_in_tid, 0x8000000000000000
    CALL_NB_PC(_mthread_do_run_arc, _mthread_do_run_ra_arc, oret_in_tid, ofp_in_itd,
               fnptr_in_tid, tid_in_tid, param_in_tid, zero_in_tid, zero_in_tid,
               ora_in_tid, callpc_in_tid, gp_in_tid, sp_in_tid, fp0_in_tid, fp1_in_tid,
               zero_in_tid, zero_in_tid, zero_in_tid, zero_in_tid, zero_in_tid, 
               wave_in_tid)
    RECV_RETURN(_mthread_do_run_ra_arc, retval_in_new_wave, { }, { }, { }, { }, { }, { })
    thread_destroy retval_in_new_wave <?, 1, 1>.1
PROC_END(_mthread_launch_pc, tid, RENDEVOUS_WAVE, RA)
