#include <memthreads/mthreads.h>
#include <memthreads/spinlock.h>

void spinlock_acquire(spinlock_t lock) { *lock = 1; }
void spinlock_release(spinlock_t lock) { *lock = 0; }
void spinwait(wsint64 *addr) { while(!*addr); }

wsint64 atomic_swap(wsint64 *addr, wsint64 val)
{
  wsint64 tmp = *addr;
  *addr = val;
  return tmp;
}

wsint64 compare_and_swap(wsint64 *addr, wsint64 test, wsint64 newval)
{
  if(*addr == test) {
    *addr = newval;
    return 1;
  }
  return 0;
}
