#include <limits.h>
#include <ws/tid_acquire.h>
#include <ws/threads.h>
#include <ws/barrier.h>
#include <ws/mutex.h>
#include <ws/condvar.h>

barrier_t barrier_create(wsint64 max_count)
{
  barrier_t bid = thread_create_pc(barrier_thread, max_count, 0, 0);
  thread_detach(bid);
  return bid;
}

void barrier_destroy(barrier_t barrier_id)
{
  barrier_reset(barrier_id, -2);
}

wsint64 thread_join(tid_t tid)
{
  return mutex_acquire(tid);
}


condvar_t condvar_create(void)
{
  return barrier_create(INT_MAX);
}

void condvar_destroy(condvar_t cv)
{
  barrier_destroy(cv);
}


void condvar_notify(condvar_t cv)
{
  barrier_reset(cv, -1);
}
