#ifndef __TID_ACQUIRE_IMPL
#define __TID_ACQUIRE_IMPL
;;; FILE:	tid_acquire.S
;;; AUTHOR:	Andrew Petersen (petersen@cs.washington.edu)
;;; NOTE:	Code idea taken from Andrew Schwerin, initial barrier.S.
;;;

#include <asm/procs.h>
#include <asm/tid.h>
#include <threads/defs.h>

.section TSECTION

next_tid_tc:
	tc { }, { }, { }
next_tid_is:
        is ^next_tid_tc:0, { }, 0 ; is value, target, offset

PROC_START(initialize_tid_acquire)
	;;; Using the RENDEVOUS_WAVE as a trigger
	cnst one, RENDEVOUS_WAVE, 1
	cnst zero, RENDEVOUS_WAVE, 0
	dtt ^TSECTION::next_tid_tc:2, zero, one
PROC_END_NOMEM(initialize_tid_acquire, one, RENDEVOUS_WAVE, RA)

PROC_START(deinitialize_tid_acquire)
        cnst ^TSECTION::next_tid_tc:1, RENDEVOUS_WAVE, 0
deinit_recv:    ir last_tid
        cnst ^TSECTION::next_tid_is:1, RENDEVOUS_WAVE, ^deinit_recv
PROC_END(deinitialize_tid_acquire, last_tid, RENDEVOUS_WAVE, RA)

PROC_START(tid_acquire)
.declare_arcs next_tid
        GET_NEXT_TID(next_tid, RA)
PROC_END(tid_acquire, next_tid, RENDEVOUS_WAVE, RA)
#endif
