#!/usr/bin/perl -w

package Drip::Type;
use Pebble::HashObject;
use Exporter;
use strict;
use Carp;
use constant BYTE => 8;
use constant LONG => 32;
use constant LONGLONG => 64;

BEGIN {
    our @ISA = qw( Pebble::HashObject Exporter );
    our %FIELDS = (
    );
    our @EXPORT_OK = qw( Field INT UINT BYTE LONG LONGLONG );

    __PACKAGE__->DECLARE_ACCESSORS;
}

my %TypeMap;

sub typedef {
    my $type = shift;
    my $name = shift;
    *$name = $type;
}


sub UINT {
    my $precision = int shift;
    croak("precision must be a positive integer") unless $precision > 0;
    my $typestr = "UINT($precision)";
    if (exists $TypeMap{$typestr}) {
        return $TypeMap{$typestr};
    }
    return $TypeMap{$typestr} = new Drip::Type::UintType($precision);
}

package Drip::

1;
