#!/usr/bin/perl -w

package Drip::DripBaseTypes;
use Exporter;
use Drip::Type qw( :ALL );
use Data::Dumper;
use strict ;
use Carp;
use Drip::IOString;

our @ISA = qw( Exporter );
our @EXPORT_OK = qw( SmallCount  InstructionID PC WSOpCode Immediate Wave Asid ThreadID
                     MemSequence RippleSize LatencyType InputArgType OutputArgType
                     CharString DripLink
                   );
our %EXPORT_TAGS = ( ALL => \@EXPORT_OK );

#typedef &UINT(BYTE)                                         , 'SmallCount';
typedef &INT(LONG)                                          , 'InstructionID';
typedef &UINT(LONGLONG)                                     , 'PC';
typedef &UINT(LONG)                                         , 'WSOpCode';
#typedef &ENUM                                               , 'WSOpCode';
typedef &UINT(LONGLONG)                                     , 'Immediate';
typedef &INT(LONG)                                          , 'Wave';
typedef &INT(LONG)                                          , 'Asid';
typedef &INT(LONG)                                          , 'ThreadID';
typedef &INT(LONG)                                          , 'MemSequence';
typedef &UINT(LONG)                                         , 'RippleSize';
typedef &INT(LONG)                                          , 'LatencyType';
typedef &UINT(LONG)                                         , 'InputArgType';
typedef &UINT(LONG)                                         , 'OutputArgType';
#typedef &ENUM('INPUT_A', 'INPUT_B', 'INPUT_C')              , 'InputArgType';
#typedef &ENUM('OUTPUT_A', 'OUTPUT_B', 'OUTPUT_C')           , 'OutputArgType';
typedef &List(&UINT(BYTE))                                  , 'CharString';

typedef struct('_DripLink',
               Field(MemSequence(), 'epochOrderPrev'),
               Field(MemSequence(), 'epochOrder'),
               Field(MemSequence(), 'epochOrderNext'),
               Field(RippleSize(),  'rippleSize'))         , 'DripLink';

sub debug {
#    my $inst = MemSequenceList()->instantiate([MemSequence()->instantiate(500),
#                                             MemSequence()->instantiate(-1),
#                                             MemSequence()->instantiate(403)  ]);
#    print $inst->toString() . "\n";
#     my $stream = new Drip::IOString;
#     $inst->writeValue($stream);
#     print "$$stream\n";
#     my $instAnew = $inst->type->readInstance($stream);
#     print "$$stream\n";
#     print $_->value() . "\n" foreach( @{$instAnew->value} );

#     UINT(LONGLONG)->generateCReadFn(\*STDOUT);
#     MemSequence()->generateCReadFn(\*STDOUT);
#     Link()->generateCReadFn(\*STDOUT);
#     print List(Link())->instanceDeclaration("mslist") . "\n";
#     MemSequenceList()->generateCReadFn(\*STDOUT);
#     List(Link())->generateCReadFn(\*STDOUT);

#    print Link()->basetype() . "\n";
#    print "$_\n" foreach(Drip::Type::allTypes());
    Drip::Type::GenerateCDeclarations(\*STDOUT);
    Drip::Type::GenerateCFnDefinitions(\*STDOUT);
}

1;
