#define ELFCLASS_WAVESCALAR ELFCLASS64
#define ELFDATA_WAVESCALAR ELFDATA2MSB
#define ELFOSABI_WAVESCALAR ELFOSABI_LINUX
#define ELFABIVERSION_WAVESCALAR 0
#define EM_WAVESCALAR 0xf7b5

#define STT_WS_ARC STT_LOOS       /* Symbol is a shared arc */

// macros for extraction of information in st_value field for function symbols
#define ELF64_ST_FUNC_SNDX(value)            ((unsigned short) ((value) >> 48))
#define ELF64_ST_FUNC_INDEX(value)           ((value) & 0xffffffff)
#define ELF64_ST_VALUE_FUNC(funcsect,index)  ((((unsigned long long) (funcsect)) << 48) | (index))

// macros for extraction of information in st_value field for shared arc symbols
#define ELF64_ST_ARC_SNDX(value)             ((unsigned short) ((value) >> 48))
#define ELF64_ST_ARC_INDEX(value)            ((value) & 0xffffffff)
#define ELF64_ST_VALUE_ARC(funcsect,index)   ((((unsigned long long) (funcsect)) << 48) | (index))

#define R_WS_NONE       0
#define R_WS_EXTERN     (1 << 4)
#define R_WS_IMM        (1 << 5)
#define R_WS_ARC        (1 << 6)
#define R_WS_ARC_IN     (1 << 7)
#include <Elf/elf.h>

#define R_WS_IMM8       (R_WS_IMM | 0)
#define R_WS_IMM16      (R_WS_IMM | 1)
#define R_WS_IMM32      (R_WS_IMM | 2)
#define R_WS_IMM64      (R_WS_IMM | 3)
#define R_WS_EXT_IMM8   (R_WS_IMM8  | R_WS_EXTERN)
#define R_WS_EXT_IMM16  (R_WS_IMM16 | R_WS_EXTERN)
#define R_WS_EXT_IMM32  (R_WS_IMM32 | R_WS_EXTERN)
#define R_WS_EXT_IMM64  (R_WS_IMM64 | R_WS_EXTERN)

#define ELF64_R_WS_ARC_TYPE(conType,proType) (((conType) & 0x3) | (((proType) & 0x3) << 2))
#define ELF64_R_WS_ARC_PRODUCER(proType,conType) (R_WS_ARC | ELF64_R_WS_ARC_TYPE(conType,proType))
#define ELF64_R_WS_ARC_CONSUMER(conType,proType) (R_WS_ARC_IN | ELF64_R_WS_ARC_TYPE(proType,conType))
#define ELF64_R_WS_EXT_ARC_PRODUCER(proType,conType) (R_WS_EXTERN | ELF64_R_WS_ARC_PRODUCER(proType,conType))
#define ELF64_R_WS_EXT_ARC_CONSUMER(conType,proType) (R_WS_EXTERN | ELF64_R_WS_ARC_CONSUMER(conType,proType))
#define ELF64_R_WS_ARC_CONTYPE(type) static_cast<InputArgType>((type) & 0x3)
#define ELF64_R_WS_ARC_PROTYPE(type) static_cast<OutputArgType>(((type) >> 2) & 0x3)

#define SHT_WS_verdef     (SHT_LOOS + 1)
#define SHT_WS_functions  (SHT_LOOS + 2)
#define SHT_WS_sharedarcs (SHT_LOOS + 3)

#define SHF_NONE        0

#define SHI_NONE        0
#define SHI_SCALAR      1
#define SHI_VECTOR      2
#define SHI_LIST        (SHI_VECTOR | 0)
#define SHI_ARRAY       (SHI_VECTOR | 1)

typedef Elf32_Word Elf32_Sndx;
typedef Elf64_Word Elf64_Sndx;
typedef unsigned char Elf32_Rtype;
typedef Elf64_Word Elf64_Rtype;
