#!/usr/bin/perl -w

package Drip::Field;
use strict;
use Pebble::HashObject;
use Pebble::Stringy;
use Carp;

BEGIN {
    our @ISA = qw( Pebble::HashObject Pebble::Stringy );
    our %FIELDS = (
        'type' => 'Drip::Type',
        'name' => undef
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    my $self = shift;
    my $type = shift;
    my $name = shift;
    $self->type($type);
    $self->name($name);
    return $self;
}

sub toString
{
    my $self = shift;
    return "Field(" . $self->type->toString() . "(), '" . $self->name() . "')";
}

1;
