#!/usr/bin/perl -w

package Drip::Instance;
use strict;
use Carp;
use Pebble::HashObject;

BEGIN {
    our @ISA = qw( Pebble::HashObject );
    our %FIELDS = (
        'type' => 'Drip::Type',
        '_value' => undef
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    my $self = shift;
    my $type = shift;
    my $value = shift;

    croak("Undefined type value") unless defined $type;
    $self->type($type);
    $self->value($value);
    return $self;
}

sub value
{
    my $self = $_[0];
    if(2 == scalar @_) {
        return $self->_value($self->type->validate($_[1]));
#        eval {$value = $self->_value($self->type->validate($value)); };
#        if($@) { croak $@; }
#        return $value;
    }
    return $self->_value;
}

sub asStaticInitializer
{
    my $self = shift;
    return $self->type->asStaticInitializer($self->value);
}

sub validate
{
    my $self = shift;
    $self->type->validate($self->value);
}

sub writeValue {
    my $self = shift;
    my $fh = shift;
    $self->type->writeInstance($fh, $self);
}

1;
