#!/usr/bin/perl -w

package Drip::InstructionFormatAux;
use strict;
use Exporter;
use Drip::Type qw( :ALL );
use Pebble::Constants;

our @ISA = qw( Exporter );
our @EXPORT_OK = qw( Version SmallCount InstructionID PC DripWSOpCode
                     Immediate Wave Asid ThreadID MemSequence RippleSize
                     LatencyType InputArgType OutputArgType CharString
                   );
our %EXPORT_TAGS = ( ALL => \@EXPORT_OK );

typedef &UINT(LONG)                                         , 'Version';
typedef &UINT(BYTE)                                         , 'SmallCount';
typedef &INT(LONG)                                          , 'InstructionID';
typedef &UINT(LONGLONG)                                     , 'PC';
typedef &UINT(LONG)                                         , 'DripWSOpCode';
typedef &UINT(LONGLONG)                                     , 'Immediate';
typedef &INT(LONG)                                          , 'Wave';
typedef &INT(LONG)                                          , 'Asid';
typedef &INT(LONG)                                          , 'ThreadID';
typedef &INT(LONG)                                          , 'MemSequence';
typedef &UINT(LONG)                                         , 'RippleSize';
typedef &ENUM('LATENCY_NONE', 0,
	      'LATENCY_EASY_RHO_FUNCS', 1, 
	      'LATENCY_ALL_RHO_FUNCS', 2,
	      'LATENCY_BRANCHES', 4,
	      'LATENCY_EPOCH_COORDINATORS', 8,
	      'LATENCY_ALL_EPOCH_ADVANCES', 16,
	      'LATENCY_EASY_EPOCH_ADVANCES', 32,
	      'LATENCY_ALPHA_OPS', 64,
              'LATENCY_ZAPPED_EPOCH_MANAGEMENT', 128)       , 'LatencyType';
typedef &ENUM('INPUT_A', 'INPUT_B', 'INPUT_C')              , 'InputArgType';
typedef &ENUM('OUTPUT_A', 'OUTPUT_B', 'OUTPUT_C')           , 'OutputArgType';
typedef &List(&UINT(BYTE))                                  , 'CharString';

1;
