#!/usr/bin/perl -w

use strict;
use Pebble::ArrayObject;

package Pebble::ArrayList;
our @ISA = qw( Pebble::ArrayObject );

sub initialize
{
    my $self = CORE::shift;
    @$self = @_;
    return $self;
}

sub top
{
    my $self = CORE::shift;
    return $self->[scalar @$self - 1];
}

sub head { return CORE::shift->[0]; }
sub tail { return CORE::shift->top; }

sub push($$) {
    my $self = CORE::shift;
    my $val = CORE::shift;
    push @$self, $val;
}

sub pop($) {
    my $self = CORE::shift;
    pop @$self;
}

sub shift($) {
    my $self = CORE::shift;
    CORE::shift @$self;
}

sub unshift($$) {
    my $self = CORE::shift;
    unshift @$self, CORE::shift;
}

sub indexOf($$) {
    my $self = CORE::shift;
    my $item = CORE::shift;
    my $i = 0;
    foreach(@$self) {
        return $i if $item eq $_;
        ++$i;
    }
    return -1;
}

sub contains($$) {
    my $self = CORE::shift;
    my $item = CORE::shift;
    return $self->indexOf($item) >= 0;
}

sub toString {
    my $self = CORE::shift;
    my $retval = "";
    foreach my $item (@$self) {
        if(!defined $item) {
            $retval .= "undef,\n";
        }
        elsif(UNIVERSAL::can($item, 'toString')) {
            $retval .= $item->toString() . ",\n";
        }
        else {
            $retval .= $item;
        }
    }
    return $retval;
}

1;
