#!/usr/bin/perl -w

package Pebble::CodeInstance;
use strict;
use Carp;
use Pebble::HashObject;
use Pebble::CodeItem;

BEGIN {
    our @ISA = qw ( Pebble::CodeItem );
    our %FIELDS = (
        'operands'   => 'Pebble::ArrayList',
        'waveorder'  => 'Pebble::WaveOrdering',
        'section'    => 'Pebble::Section',
        'attributes' => 'HASH'
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    croak("Wrong number of parameters") unless 3 == scalar @_;
    my $self = shift;
    $self = $self->SUPER::initialize;
    $self->operands(shift);
    $self->waveorder(shift);
    $self->attributes({ });
    $_->addReference($self) foreach(@{$self->operands});
    return $self;
}

1;
