#!/usr/bin/perl -w

package Pebble::DataInstance;
use strict;
use Carp;
use Pebble::CodeInstance;
use Pebble::ArrayList;

BEGIN {
    our @ISA = qw ( Pebble::CodeInstance );
    our %FIELDS = ( 
        'size'       => undef,
	'operand'    => 'Pebble::Operand',
    );
    __PACKAGE__->DECLARE_ACCESSORS ;
}

sub initialize
{
    croak("Wrong number of parameters") unless 3 == scalar @_;
    my $self = shift;
    $self->size(shift);
    $self->operand(shift);
    $self = $self->SUPER::initialize;
    $self->operand and $self->operand->addReference($self);
    return $self
}

sub toString {
    my $self = shift;
    return $self->size . $self->operand->toString;
}

sub addArc { die( "Cannot use data label as arc" ); }

sub visit { return $_[1]->visitDataInstance($_[0]); }

1;
