#!/usr/bin/perl -w

package Pebble::Generator::IndexingFlattener;
use strict;
use Pebble::HashObject;
use Pebble::Visitor;

BEGIN {
    our @ISA = qw( Pebble::HashObject Pebble::Visitor );
    our %FIELDS = (
        'codeIndex' => undef,
        '_asmunit'  => 'Pebble::AssemblyUnit'
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize {
    my $self = shift;
    $self->codeIndex(0);
    return $self;
}

sub visitAssemblyUnit {
    $_[0]->_asmunit($_[1]);
    $_[0]->SUPER::visitAssemblyUnit($_[1]);
    $_[0]->_asmunit(undef);
    return $_[0];
}

sub visitInstrInstance
{
    my $flattener   = shift;
    my $instr = shift;
    $instr->setCodeIndex($flattener->codeIndex);
#    print STDERR "III: ", $instr->getCodeIndex, " (", $flattener->codeIndex, ")\n";
    $flattener->advanceCodeIndex($instr);
    return $flattener;
}

sub advanceCodeIndex {
    my $self = shift;
    my $instr = shift;
    $self->codeIndex($self->codeIndex() +1);
}

1;
