#!/usr/bin/perl -w

use Pebble::InstrLabel;
use Pebble::HashObject;
use strict;

package Pebble::Immediate;
BEGIN {
    our @ISA = qw( Pebble::HashObject Pebble::Operand );
    our %FIELDS = (
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    my $self = shift;
    my $val = shift;
    $self->_value($val);
    return $self;
}

package Pebble::Immediate::Number;
BEGIN {
    our @ISA = qw( Pebble::Immediate );
    our %FIELDS = (
        '_value' => undef
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub value { return $_[0]->_value; }

sub toString
{
    return "IMM: " . $_[0]->_value();
}

package Pebble::Immediate::LabelRef;

BEGIN {
    our @ISA = qw( Pebble::Immediate );
    our %FIELDS = (
        '_value' => 'Pebble::InstrLabel'
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub label { return $_[0]->_value; }
sub value {
    my $label = $_[0]->label;
    Carp::croak("Undefined label referent for ", $label->name) unless defined $label->isSpecified;
    $label->getInstruction and return $label->getInstruction->getCodeIndex;
    return -1;
}

sub toString
{
    return "IMM: " . $_[0]->_value->toString;
}

sub addReference {
    my $self = shift;
    $self->label->addReference(@_);
}

1;
