#!/usr/bin/perl -w

package Pebble::InstrDef::Alias;
use strict;
use Carp;
use Pebble::HashObject;
use Pebble::InstrDef::InstructionDefs;

BEGIN {
    our @ISA = qw( Pebble::InstrDef );
    our %FIELDS = (
        'opcode'     => undef,
        'realopname' => undef,
        'realdef' => 'Pebble::InstrDef'
    );
    __PACKAGE__->Pebble::HashObject::DECLARE_ACCESSORS;
}

our $AUTOLOAD;

sub initialize
{
    my $self = shift;
    my $opname = shift;
    $self = $self->SUPER::initialize( $opname );
    my $opcode = shift;
    my $realthing = shift;
    $self->opcode($opcode);
    if($realthing) {
        if(UNIVERSAL::isa($realthing, 'Pebble::InstrDef')) {
            $self->realdef( $realthing );
        }
        else {
            $self->realopname( $realthing );
        }
    }
    return $self;
}

sub DESTROY { }

sub AUTOLOAD
{
    no strict 'refs';
    my $name = $AUTOLOAD;
    $name =~ s/.*://;

    *$AUTOLOAD = sub {
        my $self = shift;
        $self->realdef or
            $self->realdef($Pebble::InstrDef::InstructionDefs::IDEFS{$self->realopname});
        return $self->realdef->$name(@_);
    };
    goto &$AUTOLOAD;
}

#use Data::Dumper;
#no strict 'refs';
#print Dumper(%{'Pebble::InstrDef::Alias::'});

1;
