package Pebble::InstrDef::InstructionDefs;

use strict;
use Exporter;
our @EXPORT_OK = qw( %IDEFS );
our @ISA = qw(Exporter);

our %IDEFS = (
'addl' => bless({ 'opname' => 'addl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 0 }, "Pebble::InstrDef::Instr"),

'addl_v' => bless({ 'opname' => 'addl_v', 'realopname' => 'addl', 'opcode' => 1 }, 'Pebble::InstrDef::Alias'),

's4addl' => bless({ 'opname' => 's4addl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 2 }, "Pebble::InstrDef::Instr"),

's8addl' => bless({ 'opname' => 's8addl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 3 }, "Pebble::InstrDef::Instr"),

'addq' => bless({ 'opname' => 'addq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 4 }, "Pebble::InstrDef::Instr"),

'addq_v' => bless({ 'opname' => 'addq_v', 'realopname' => 'addq', 'opcode' => 5 }, 'Pebble::InstrDef::Alias'),

's4addq' => bless({ 'opname' => 's4addq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 6 }, "Pebble::InstrDef::Instr"),

's8addq' => bless({ 'opname' => 's8addq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 7 }, "Pebble::InstrDef::Instr"),

'cmpeq' => bless({ 'opname' => 'cmpeq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 8 }, "Pebble::InstrDef::Instr"),

'cmple' => bless({ 'opname' => 'cmple',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 9 }, "Pebble::InstrDef::Instr"),

'cmplt' => bless({ 'opname' => 'cmplt',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 10 }, "Pebble::InstrDef::Instr"),

'cmpule' => bless({ 'opname' => 'cmpule',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 11 }, "Pebble::InstrDef::Instr"),

'cmpult' => bless({ 'opname' => 'cmpult',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 12 }, "Pebble::InstrDef::Instr"),

'ctlz' => bless({ 'opname' => 'ctlz',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 13 }, "Pebble::InstrDef::Instr"),

'ctpop' => bless({ 'opname' => 'ctpop',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 14 }, "Pebble::InstrDef::Instr"),

'cttz' => bless({ 'opname' => 'cttz',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 15 }, "Pebble::InstrDef::Instr"),

'mull' => bless({ 'opname' => 'mull',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 16 }, "Pebble::InstrDef::Instr"),

'mull_v' => bless({ 'opname' => 'mull_v', 'realopname' => 'mull', 'opcode' => 17 }, 'Pebble::InstrDef::Alias'),

'mulq' => bless({ 'opname' => 'mulq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 18 }, "Pebble::InstrDef::Instr"),

'mulq_v' => bless({ 'opname' => 'mulq_v', 'realopname' => 'mulq', 'opcode' => 19 }, 'Pebble::InstrDef::Alias'),

'umulh' => bless({ 'opname' => 'umulh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 20 }, "Pebble::InstrDef::Instr"),

'subl' => bless({ 'opname' => 'subl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 21 }, "Pebble::InstrDef::Instr"),

'subl_v' => bless({ 'opname' => 'subl_v', 'realopname' => 'subl', 'opcode' => 22 }, 'Pebble::InstrDef::Alias'),

's4subl' => bless({ 'opname' => 's4subl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 23 }, "Pebble::InstrDef::Instr"),

's8subl' => bless({ 'opname' => 's8subl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 24 }, "Pebble::InstrDef::Instr"),

'subq' => bless({ 'opname' => 'subq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 25 }, "Pebble::InstrDef::Instr"),

'subq_v' => bless({ 'opname' => 'subq_v', 'realopname' => 'subq', 'opcode' => 26 }, 'Pebble::InstrDef::Alias'),

's4subq' => bless({ 'opname' => 's4subq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 27 }, "Pebble::InstrDef::Instr"),

's8subq' => bless({ 'opname' => 's8subq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 28 }, "Pebble::InstrDef::Instr"),

'opand' => bless({ 'opname' => 'opand',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 29 }, "Pebble::InstrDef::Instr"),

'bis' => bless({ 'opname' => 'bis',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 30 }, "Pebble::InstrDef::Instr"),

'opxor' => bless({ 'opname' => 'opxor',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 31 }, "Pebble::InstrDef::Instr"),

'bic' => bless({ 'opname' => 'bic',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 32 }, "Pebble::InstrDef::Instr"),

'ornot' => bless({ 'opname' => 'ornot',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 33 }, "Pebble::InstrDef::Instr"),

'eqv' => bless({ 'opname' => 'eqv',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 34 }, "Pebble::InstrDef::Instr"),

'cmoveq' => bless({ 'opname' => 'cmoveq',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 35 }, "Pebble::InstrDef::Instr"),

'cmovge' => bless({ 'opname' => 'cmovge',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 36 }, "Pebble::InstrDef::Instr"),

'cmovgt' => bless({ 'opname' => 'cmovgt',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 37 }, "Pebble::InstrDef::Instr"),

'cmovlbc' => bless({ 'opname' => 'cmovlbc',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 38 }, "Pebble::InstrDef::Instr"),

'cmovlbs' => bless({ 'opname' => 'cmovlbs',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 39 }, "Pebble::InstrDef::Instr"),

'cmovle' => bless({ 'opname' => 'cmovle',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 40 }, "Pebble::InstrDef::Instr"),

'cmovlt' => bless({ 'opname' => 'cmovlt',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 41 }, "Pebble::InstrDef::Instr"),

'cmovne' => bless({ 'opname' => 'cmovne',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 42 }, "Pebble::InstrDef::Instr"),

'sll' => bless({ 'opname' => 'sll',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 43 }, "Pebble::InstrDef::Instr"),

'srl' => bless({ 'opname' => 'srl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 44 }, "Pebble::InstrDef::Instr"),

'sra' => bless({ 'opname' => 'sra',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 45 }, "Pebble::InstrDef::Instr"),

'cmpbge' => bless({ 'opname' => 'cmpbge',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 46 }, "Pebble::InstrDef::Instr"),

'extbl' => bless({ 'opname' => 'extbl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 47 }, "Pebble::InstrDef::Instr"),

'extwl' => bless({ 'opname' => 'extwl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 48 }, "Pebble::InstrDef::Instr"),

'extll' => bless({ 'opname' => 'extll',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 49 }, "Pebble::InstrDef::Instr"),

'extql' => bless({ 'opname' => 'extql',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 50 }, "Pebble::InstrDef::Instr"),

'extwh' => bless({ 'opname' => 'extwh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 51 }, "Pebble::InstrDef::Instr"),

'extlh' => bless({ 'opname' => 'extlh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 52 }, "Pebble::InstrDef::Instr"),

'extqh' => bless({ 'opname' => 'extqh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 53 }, "Pebble::InstrDef::Instr"),

'insbl' => bless({ 'opname' => 'insbl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 54 }, "Pebble::InstrDef::Instr"),

'inswl' => bless({ 'opname' => 'inswl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 55 }, "Pebble::InstrDef::Instr"),

'insll' => bless({ 'opname' => 'insll',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 56 }, "Pebble::InstrDef::Instr"),

'insql' => bless({ 'opname' => 'insql',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 57 }, "Pebble::InstrDef::Instr"),

'inswh' => bless({ 'opname' => 'inswh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 58 }, "Pebble::InstrDef::Instr"),

'inslh' => bless({ 'opname' => 'inslh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 59 }, "Pebble::InstrDef::Instr"),

'insqh' => bless({ 'opname' => 'insqh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 60 }, "Pebble::InstrDef::Instr"),

'mskbl' => bless({ 'opname' => 'mskbl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 61 }, "Pebble::InstrDef::Instr"),

'mskwl' => bless({ 'opname' => 'mskwl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 62 }, "Pebble::InstrDef::Instr"),

'mskll' => bless({ 'opname' => 'mskll',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 63 }, "Pebble::InstrDef::Instr"),

'mskql' => bless({ 'opname' => 'mskql',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 64 }, "Pebble::InstrDef::Instr"),

'mskwh' => bless({ 'opname' => 'mskwh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 65 }, "Pebble::InstrDef::Instr"),

'msklh' => bless({ 'opname' => 'msklh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 66 }, "Pebble::InstrDef::Instr"),

'mskqh' => bless({ 'opname' => 'mskqh',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 67 }, "Pebble::InstrDef::Instr"),

'sextb' => bless({ 'opname' => 'sextb',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 68 }, "Pebble::InstrDef::Instr"),

'sextw' => bless({ 'opname' => 'sextw',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 69 }, "Pebble::InstrDef::Instr"),

'zap' => bless({ 'opname' => 'zap',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 70 }, "Pebble::InstrDef::Instr"),

'zapnot' => bless({ 'opname' => 'zapnot',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 71 }, "Pebble::InstrDef::Instr"),

'amask' => bless({ 'opname' => 'amask',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 72 }, "Pebble::InstrDef::Instr"),

'ldbu' => bless({ 'opname' => 'ldbu',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 73 }, "Pebble::InstrDef::MemInstr"),

'ldwu' => bless({ 'opname' => 'ldwu',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 74 }, "Pebble::InstrDef::MemInstr"),

'ldl' => bless({ 'opname' => 'ldl',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 75 }, "Pebble::InstrDef::MemInstr"),

'ldl_l' => bless({ 'opname' => 'ldl_l', 'realopname' => 'ldl', 'opcode' => 76 }, 'Pebble::InstrDef::Alias'),

'ldq' => bless({ 'opname' => 'ldq',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 77 }, "Pebble::InstrDef::MemInstr"),

'ldq_l' => bless({ 'opname' => 'ldq_l', 'realopname' => 'ldq', 'opcode' => 78 }, 'Pebble::InstrDef::Alias'),

'ldq_u' => bless({ 'opname' => 'ldq_u',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 79 }, "Pebble::InstrDef::MemInstr"),

'stb' => bless({ 'opname' => 'stb',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 80 }, "Pebble::InstrDef::MemInstr"),

'stw' => bless({ 'opname' => 'stw',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 81 }, "Pebble::InstrDef::MemInstr"),

'stl' => bless({ 'opname' => 'stl',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 82 }, "Pebble::InstrDef::MemInstr"),

'stq' => bless({ 'opname' => 'stq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 83 }, "Pebble::InstrDef::MemInstr"),

'stq_u' => bless({ 'opname' => 'stq_u',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 84 }, "Pebble::InstrDef::MemInstr"),

'lda' => bless({ 'opname' => 'lda',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 85 }, "Pebble::InstrDef::Instr"),

'ldah' => bless({ 'opname' => 'ldah',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 86 }, "Pebble::InstrDef::Instr"),

'jmp' => bless({ 'opname' => 'jmp',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'RetA', 'NPC' ],
	'HasImmediate' => 1,
	'opcode' => 87 }, "Pebble::InstrDef::Instr"),

'jsr' => bless({ 'opname' => 'jsr', 'realopname' => 'jmp', 'opcode' => 88 }, 'Pebble::InstrDef::Alias'),

'ret' => bless({ 'opname' => 'ret', 'realopname' => 'jmp', 'opcode' => 89 }, 'Pebble::InstrDef::Alias'),

'jsr_coroutine' => bless({ 'opname' => 'jsr_coroutine', 'realopname' => 'jmp', 'opcode' => 90 }, 'Pebble::InstrDef::Alias'),

'bsr' => bless({ 'opname' => 'bsr',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'RetA', 'NPC' ],
	'HasImmediate' => 1,
	'opcode' => 91 }, "Pebble::InstrDef::Instr"),

'beq' => bless({ 'opname' => 'beq',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 92 }, "Pebble::InstrDef::Instr"),

'bge' => bless({ 'opname' => 'bge',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 93 }, "Pebble::InstrDef::Instr"),

'bgt' => bless({ 'opname' => 'bgt',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 94 }, "Pebble::InstrDef::Instr"),

'blbc' => bless({ 'opname' => 'blbc',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 95 }, "Pebble::InstrDef::Instr"),

'blbs' => bless({ 'opname' => 'blbs',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 96 }, "Pebble::InstrDef::Instr"),

'ble' => bless({ 'opname' => 'ble',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 97 }, "Pebble::InstrDef::Instr"),

'blt' => bless({ 'opname' => 'blt',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 98 }, "Pebble::InstrDef::Instr"),

'bne' => bless({ 'opname' => 'bne',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 99 }, "Pebble::InstrDef::Instr"),

'call_pal' => bless({ 'opname' => 'call_pal',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 100 }, "Pebble::InstrDef::Instr"),

'addt' => bless({ 'opname' => 'addt',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 101 }, "Pebble::InstrDef::Instr"),

'adds' => bless({ 'opname' => 'adds', 'realopname' => 'addt', 'opcode' => 102 }, 'Pebble::InstrDef::Alias'),

'addt_c' => bless({ 'opname' => 'addt_c', 'realopname' => 'addt', 'opcode' => 103 }, 'Pebble::InstrDef::Alias'),

'addt_d' => bless({ 'opname' => 'addt_d', 'realopname' => 'addt', 'opcode' => 104 }, 'Pebble::InstrDef::Alias'),

'addt_u' => bless({ 'opname' => 'addt_u', 'realopname' => 'addt', 'opcode' => 105 }, 'Pebble::InstrDef::Alias'),

'addt_ud' => bless({ 'opname' => 'addt_ud', 'realopname' => 'addt', 'opcode' => 106 }, 'Pebble::InstrDef::Alias'),

'addt_suc' => bless({ 'opname' => 'addt_suc', 'realopname' => 'addt', 'opcode' => 107 }, 'Pebble::InstrDef::Alias'),

'addt_sum' => bless({ 'opname' => 'addt_sum', 'realopname' => 'addt', 'opcode' => 108 }, 'Pebble::InstrDef::Alias'),

'addt_su' => bless({ 'opname' => 'addt_su', 'realopname' => 'addt', 'opcode' => 109 }, 'Pebble::InstrDef::Alias'),

'addt_um' => bless({ 'opname' => 'addt_um', 'realopname' => 'addt', 'opcode' => 110 }, 'Pebble::InstrDef::Alias'),

'addt_uc' => bless({ 'opname' => 'addt_uc', 'realopname' => 'addt', 'opcode' => 111 }, 'Pebble::InstrDef::Alias'),

'addt_sud' => bless({ 'opname' => 'addt_sud', 'realopname' => 'addt', 'opcode' => 112 }, 'Pebble::InstrDef::Alias'),

'addt_suic' => bless({ 'opname' => 'addt_suic', 'realopname' => 'addt', 'opcode' => 113 }, 'Pebble::InstrDef::Alias'),

'addt_suim' => bless({ 'opname' => 'addt_suim', 'realopname' => 'addt', 'opcode' => 114 }, 'Pebble::InstrDef::Alias'),

'addt_sui' => bless({ 'opname' => 'addt_sui', 'realopname' => 'addt', 'opcode' => 115 }, 'Pebble::InstrDef::Alias'),

'addt_suid' => bless({ 'opname' => 'addt_suid', 'realopname' => 'addt', 'opcode' => 116 }, 'Pebble::InstrDef::Alias'),

'addt_m' => bless({ 'opname' => 'addt_m', 'realopname' => 'addt', 'opcode' => 117 }, 'Pebble::InstrDef::Alias'),

'adds_c' => bless({ 'opname' => 'adds_c', 'realopname' => 'adds', 'opcode' => 118 }, 'Pebble::InstrDef::Alias'),

'adds_d' => bless({ 'opname' => 'adds_d', 'realopname' => 'adds', 'opcode' => 119 }, 'Pebble::InstrDef::Alias'),

'adds_u' => bless({ 'opname' => 'adds_u', 'realopname' => 'adds', 'opcode' => 120 }, 'Pebble::InstrDef::Alias'),

'adds_ud' => bless({ 'opname' => 'adds_ud', 'realopname' => 'adds', 'opcode' => 121 }, 'Pebble::InstrDef::Alias'),

'adds_suc' => bless({ 'opname' => 'adds_suc', 'realopname' => 'adds', 'opcode' => 122 }, 'Pebble::InstrDef::Alias'),

'adds_sum' => bless({ 'opname' => 'adds_sum', 'realopname' => 'adds', 'opcode' => 123 }, 'Pebble::InstrDef::Alias'),

'adds_su' => bless({ 'opname' => 'adds_su', 'realopname' => 'adds', 'opcode' => 124 }, 'Pebble::InstrDef::Alias'),

'adds_um' => bless({ 'opname' => 'adds_um', 'realopname' => 'adds', 'opcode' => 125 }, 'Pebble::InstrDef::Alias'),

'adds_uc' => bless({ 'opname' => 'adds_uc', 'realopname' => 'adds', 'opcode' => 126 }, 'Pebble::InstrDef::Alias'),

'adds_sud' => bless({ 'opname' => 'adds_sud', 'realopname' => 'adds', 'opcode' => 127 }, 'Pebble::InstrDef::Alias'),

'adds_suic' => bless({ 'opname' => 'adds_suic', 'realopname' => 'adds', 'opcode' => 128 }, 'Pebble::InstrDef::Alias'),

'adds_suim' => bless({ 'opname' => 'adds_suim', 'realopname' => 'adds', 'opcode' => 129 }, 'Pebble::InstrDef::Alias'),

'adds_sui' => bless({ 'opname' => 'adds_sui', 'realopname' => 'adds', 'opcode' => 130 }, 'Pebble::InstrDef::Alias'),

'adds_suid' => bless({ 'opname' => 'adds_suid', 'realopname' => 'adds', 'opcode' => 131 }, 'Pebble::InstrDef::Alias'),

'adds_m' => bless({ 'opname' => 'adds_m', 'realopname' => 'adds', 'opcode' => 132 }, 'Pebble::InstrDef::Alias'),

'subt' => bless({ 'opname' => 'subt',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 133 }, "Pebble::InstrDef::Instr"),

'subs' => bless({ 'opname' => 'subs', 'realopname' => 'subt', 'opcode' => 134 }, 'Pebble::InstrDef::Alias'),

'subt_c' => bless({ 'opname' => 'subt_c', 'realopname' => 'subt', 'opcode' => 135 }, 'Pebble::InstrDef::Alias'),

'subt_d' => bless({ 'opname' => 'subt_d', 'realopname' => 'subt', 'opcode' => 136 }, 'Pebble::InstrDef::Alias'),

'subt_u' => bless({ 'opname' => 'subt_u', 'realopname' => 'subt', 'opcode' => 137 }, 'Pebble::InstrDef::Alias'),

'subt_ud' => bless({ 'opname' => 'subt_ud', 'realopname' => 'subt', 'opcode' => 138 }, 'Pebble::InstrDef::Alias'),

'subt_suc' => bless({ 'opname' => 'subt_suc', 'realopname' => 'subt', 'opcode' => 139 }, 'Pebble::InstrDef::Alias'),

'subt_sum' => bless({ 'opname' => 'subt_sum', 'realopname' => 'subt', 'opcode' => 140 }, 'Pebble::InstrDef::Alias'),

'subt_su' => bless({ 'opname' => 'subt_su', 'realopname' => 'subt', 'opcode' => 141 }, 'Pebble::InstrDef::Alias'),

'subt_um' => bless({ 'opname' => 'subt_um', 'realopname' => 'subt', 'opcode' => 142 }, 'Pebble::InstrDef::Alias'),

'subt_uc' => bless({ 'opname' => 'subt_uc', 'realopname' => 'subt', 'opcode' => 143 }, 'Pebble::InstrDef::Alias'),

'subt_sud' => bless({ 'opname' => 'subt_sud', 'realopname' => 'subt', 'opcode' => 144 }, 'Pebble::InstrDef::Alias'),

'subt_suic' => bless({ 'opname' => 'subt_suic', 'realopname' => 'subt', 'opcode' => 145 }, 'Pebble::InstrDef::Alias'),

'subt_suim' => bless({ 'opname' => 'subt_suim', 'realopname' => 'subt', 'opcode' => 146 }, 'Pebble::InstrDef::Alias'),

'subt_sui' => bless({ 'opname' => 'subt_sui', 'realopname' => 'subt', 'opcode' => 147 }, 'Pebble::InstrDef::Alias'),

'subt_suid' => bless({ 'opname' => 'subt_suid', 'realopname' => 'subt', 'opcode' => 148 }, 'Pebble::InstrDef::Alias'),

'subt_m' => bless({ 'opname' => 'subt_m', 'realopname' => 'subt', 'opcode' => 149 }, 'Pebble::InstrDef::Alias'),

'subs_c' => bless({ 'opname' => 'subs_c', 'realopname' => 'subs', 'opcode' => 150 }, 'Pebble::InstrDef::Alias'),

'subs_d' => bless({ 'opname' => 'subs_d', 'realopname' => 'subs', 'opcode' => 151 }, 'Pebble::InstrDef::Alias'),

'subs_u' => bless({ 'opname' => 'subs_u', 'realopname' => 'subs', 'opcode' => 152 }, 'Pebble::InstrDef::Alias'),

'subs_ud' => bless({ 'opname' => 'subs_ud', 'realopname' => 'subs', 'opcode' => 153 }, 'Pebble::InstrDef::Alias'),

'subs_suc' => bless({ 'opname' => 'subs_suc', 'realopname' => 'subs', 'opcode' => 154 }, 'Pebble::InstrDef::Alias'),

'subs_sum' => bless({ 'opname' => 'subs_sum', 'realopname' => 'subs', 'opcode' => 155 }, 'Pebble::InstrDef::Alias'),

'subs_su' => bless({ 'opname' => 'subs_su', 'realopname' => 'subs', 'opcode' => 156 }, 'Pebble::InstrDef::Alias'),

'subs_um' => bless({ 'opname' => 'subs_um', 'realopname' => 'subs', 'opcode' => 157 }, 'Pebble::InstrDef::Alias'),

'subs_uc' => bless({ 'opname' => 'subs_uc', 'realopname' => 'subs', 'opcode' => 158 }, 'Pebble::InstrDef::Alias'),

'subs_sud' => bless({ 'opname' => 'subs_sud', 'realopname' => 'subs', 'opcode' => 159 }, 'Pebble::InstrDef::Alias'),

'subs_suic' => bless({ 'opname' => 'subs_suic', 'realopname' => 'subs', 'opcode' => 160 }, 'Pebble::InstrDef::Alias'),

'subs_suim' => bless({ 'opname' => 'subs_suim', 'realopname' => 'subs', 'opcode' => 161 }, 'Pebble::InstrDef::Alias'),

'subs_sui' => bless({ 'opname' => 'subs_sui', 'realopname' => 'subs', 'opcode' => 162 }, 'Pebble::InstrDef::Alias'),

'subs_suid' => bless({ 'opname' => 'subs_suid', 'realopname' => 'subs', 'opcode' => 163 }, 'Pebble::InstrDef::Alias'),

'subs_m' => bless({ 'opname' => 'subs_m', 'realopname' => 'subs', 'opcode' => 164 }, 'Pebble::InstrDef::Alias'),

'mult' => bless({ 'opname' => 'mult',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 165 }, "Pebble::InstrDef::Instr"),

'muls' => bless({ 'opname' => 'muls', 'realopname' => 'mult', 'opcode' => 166 }, 'Pebble::InstrDef::Alias'),

'mult_c' => bless({ 'opname' => 'mult_c', 'realopname' => 'mult', 'opcode' => 167 }, 'Pebble::InstrDef::Alias'),

'mult_d' => bless({ 'opname' => 'mult_d', 'realopname' => 'mult', 'opcode' => 168 }, 'Pebble::InstrDef::Alias'),

'mult_u' => bless({ 'opname' => 'mult_u', 'realopname' => 'mult', 'opcode' => 169 }, 'Pebble::InstrDef::Alias'),

'mult_ud' => bless({ 'opname' => 'mult_ud', 'realopname' => 'mult', 'opcode' => 170 }, 'Pebble::InstrDef::Alias'),

'mult_suc' => bless({ 'opname' => 'mult_suc', 'realopname' => 'mult', 'opcode' => 171 }, 'Pebble::InstrDef::Alias'),

'mult_sum' => bless({ 'opname' => 'mult_sum', 'realopname' => 'mult', 'opcode' => 172 }, 'Pebble::InstrDef::Alias'),

'mult_su' => bless({ 'opname' => 'mult_su', 'realopname' => 'mult', 'opcode' => 173 }, 'Pebble::InstrDef::Alias'),

'mult_um' => bless({ 'opname' => 'mult_um', 'realopname' => 'mult', 'opcode' => 174 }, 'Pebble::InstrDef::Alias'),

'mult_uc' => bless({ 'opname' => 'mult_uc', 'realopname' => 'mult', 'opcode' => 175 }, 'Pebble::InstrDef::Alias'),

'mult_sud' => bless({ 'opname' => 'mult_sud', 'realopname' => 'mult', 'opcode' => 176 }, 'Pebble::InstrDef::Alias'),

'mult_suic' => bless({ 'opname' => 'mult_suic', 'realopname' => 'mult', 'opcode' => 177 }, 'Pebble::InstrDef::Alias'),

'mult_suim' => bless({ 'opname' => 'mult_suim', 'realopname' => 'mult', 'opcode' => 178 }, 'Pebble::InstrDef::Alias'),

'mult_sui' => bless({ 'opname' => 'mult_sui', 'realopname' => 'mult', 'opcode' => 179 }, 'Pebble::InstrDef::Alias'),

'mult_suid' => bless({ 'opname' => 'mult_suid', 'realopname' => 'mult', 'opcode' => 180 }, 'Pebble::InstrDef::Alias'),

'mult_m' => bless({ 'opname' => 'mult_m', 'realopname' => 'mult', 'opcode' => 181 }, 'Pebble::InstrDef::Alias'),

'muls_c' => bless({ 'opname' => 'muls_c', 'realopname' => 'muls', 'opcode' => 182 }, 'Pebble::InstrDef::Alias'),

'muls_d' => bless({ 'opname' => 'muls_d', 'realopname' => 'muls', 'opcode' => 183 }, 'Pebble::InstrDef::Alias'),

'muls_u' => bless({ 'opname' => 'muls_u', 'realopname' => 'muls', 'opcode' => 184 }, 'Pebble::InstrDef::Alias'),

'muls_ud' => bless({ 'opname' => 'muls_ud', 'realopname' => 'muls', 'opcode' => 185 }, 'Pebble::InstrDef::Alias'),

'muls_suc' => bless({ 'opname' => 'muls_suc', 'realopname' => 'muls', 'opcode' => 186 }, 'Pebble::InstrDef::Alias'),

'muls_sum' => bless({ 'opname' => 'muls_sum', 'realopname' => 'muls', 'opcode' => 187 }, 'Pebble::InstrDef::Alias'),

'muls_su' => bless({ 'opname' => 'muls_su', 'realopname' => 'muls', 'opcode' => 188 }, 'Pebble::InstrDef::Alias'),

'muls_um' => bless({ 'opname' => 'muls_um', 'realopname' => 'muls', 'opcode' => 189 }, 'Pebble::InstrDef::Alias'),

'muls_uc' => bless({ 'opname' => 'muls_uc', 'realopname' => 'muls', 'opcode' => 190 }, 'Pebble::InstrDef::Alias'),

'muls_sud' => bless({ 'opname' => 'muls_sud', 'realopname' => 'muls', 'opcode' => 191 }, 'Pebble::InstrDef::Alias'),

'muls_suic' => bless({ 'opname' => 'muls_suic', 'realopname' => 'muls', 'opcode' => 192 }, 'Pebble::InstrDef::Alias'),

'muls_suim' => bless({ 'opname' => 'muls_suim', 'realopname' => 'muls', 'opcode' => 193 }, 'Pebble::InstrDef::Alias'),

'muls_sui' => bless({ 'opname' => 'muls_sui', 'realopname' => 'muls', 'opcode' => 194 }, 'Pebble::InstrDef::Alias'),

'muls_suid' => bless({ 'opname' => 'muls_suid', 'realopname' => 'muls', 'opcode' => 195 }, 'Pebble::InstrDef::Alias'),

'muls_m' => bless({ 'opname' => 'muls_m', 'realopname' => 'muls', 'opcode' => 196 }, 'Pebble::InstrDef::Alias'),

'divt' => bless({ 'opname' => 'divt',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 197 }, "Pebble::InstrDef::Instr"),

'divs' => bless({ 'opname' => 'divs', 'realopname' => 'divt', 'opcode' => 198 }, 'Pebble::InstrDef::Alias'),

'divt_c' => bless({ 'opname' => 'divt_c', 'realopname' => 'divt', 'opcode' => 199 }, 'Pebble::InstrDef::Alias'),

'divt_d' => bless({ 'opname' => 'divt_d', 'realopname' => 'divt', 'opcode' => 200 }, 'Pebble::InstrDef::Alias'),

'divt_u' => bless({ 'opname' => 'divt_u', 'realopname' => 'divt', 'opcode' => 201 }, 'Pebble::InstrDef::Alias'),

'divt_ud' => bless({ 'opname' => 'divt_ud', 'realopname' => 'divt', 'opcode' => 202 }, 'Pebble::InstrDef::Alias'),

'divt_suc' => bless({ 'opname' => 'divt_suc', 'realopname' => 'divt', 'opcode' => 203 }, 'Pebble::InstrDef::Alias'),

'divt_sum' => bless({ 'opname' => 'divt_sum', 'realopname' => 'divt', 'opcode' => 204 }, 'Pebble::InstrDef::Alias'),

'divt_su' => bless({ 'opname' => 'divt_su', 'realopname' => 'divt', 'opcode' => 205 }, 'Pebble::InstrDef::Alias'),

'divt_um' => bless({ 'opname' => 'divt_um', 'realopname' => 'divt', 'opcode' => 206 }, 'Pebble::InstrDef::Alias'),

'divt_uc' => bless({ 'opname' => 'divt_uc', 'realopname' => 'divt', 'opcode' => 207 }, 'Pebble::InstrDef::Alias'),

'divt_sud' => bless({ 'opname' => 'divt_sud', 'realopname' => 'divt', 'opcode' => 208 }, 'Pebble::InstrDef::Alias'),

'divt_suic' => bless({ 'opname' => 'divt_suic', 'realopname' => 'divt', 'opcode' => 209 }, 'Pebble::InstrDef::Alias'),

'divt_suim' => bless({ 'opname' => 'divt_suim', 'realopname' => 'divt', 'opcode' => 210 }, 'Pebble::InstrDef::Alias'),

'divt_sui' => bless({ 'opname' => 'divt_sui', 'realopname' => 'divt', 'opcode' => 211 }, 'Pebble::InstrDef::Alias'),

'divt_suid' => bless({ 'opname' => 'divt_suid', 'realopname' => 'divt', 'opcode' => 212 }, 'Pebble::InstrDef::Alias'),

'divt_m' => bless({ 'opname' => 'divt_m', 'realopname' => 'divt', 'opcode' => 213 }, 'Pebble::InstrDef::Alias'),

'divs_c' => bless({ 'opname' => 'divs_c', 'realopname' => 'divs', 'opcode' => 214 }, 'Pebble::InstrDef::Alias'),

'divs_d' => bless({ 'opname' => 'divs_d', 'realopname' => 'divs', 'opcode' => 215 }, 'Pebble::InstrDef::Alias'),

'divs_u' => bless({ 'opname' => 'divs_u', 'realopname' => 'divs', 'opcode' => 216 }, 'Pebble::InstrDef::Alias'),

'divs_ud' => bless({ 'opname' => 'divs_ud', 'realopname' => 'divs', 'opcode' => 217 }, 'Pebble::InstrDef::Alias'),

'divs_suc' => bless({ 'opname' => 'divs_suc', 'realopname' => 'divs', 'opcode' => 218 }, 'Pebble::InstrDef::Alias'),

'divs_sum' => bless({ 'opname' => 'divs_sum', 'realopname' => 'divs', 'opcode' => 219 }, 'Pebble::InstrDef::Alias'),

'divs_su' => bless({ 'opname' => 'divs_su', 'realopname' => 'divs', 'opcode' => 220 }, 'Pebble::InstrDef::Alias'),

'divs_um' => bless({ 'opname' => 'divs_um', 'realopname' => 'divs', 'opcode' => 221 }, 'Pebble::InstrDef::Alias'),

'divs_uc' => bless({ 'opname' => 'divs_uc', 'realopname' => 'divs', 'opcode' => 222 }, 'Pebble::InstrDef::Alias'),

'divs_sud' => bless({ 'opname' => 'divs_sud', 'realopname' => 'divs', 'opcode' => 223 }, 'Pebble::InstrDef::Alias'),

'divs_suic' => bless({ 'opname' => 'divs_suic', 'realopname' => 'divs', 'opcode' => 224 }, 'Pebble::InstrDef::Alias'),

'divs_suim' => bless({ 'opname' => 'divs_suim', 'realopname' => 'divs', 'opcode' => 225 }, 'Pebble::InstrDef::Alias'),

'divs_sui' => bless({ 'opname' => 'divs_sui', 'realopname' => 'divs', 'opcode' => 226 }, 'Pebble::InstrDef::Alias'),

'divs_suid' => bless({ 'opname' => 'divs_suid', 'realopname' => 'divs', 'opcode' => 227 }, 'Pebble::InstrDef::Alias'),

'divs_m' => bless({ 'opname' => 'divs_m', 'realopname' => 'divs', 'opcode' => 228 }, 'Pebble::InstrDef::Alias'),

'cmpteq' => bless({ 'opname' => 'cmpteq',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 229 }, "Pebble::InstrDef::Instr"),

'cmpteq_su' => bless({ 'opname' => 'cmpteq_su', 'realopname' => 'cmpteq', 'opcode' => 230 }, 'Pebble::InstrDef::Alias'),

'cmptlt' => bless({ 'opname' => 'cmptlt',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 231 }, "Pebble::InstrDef::Instr"),

'cmplt_su' => bless({ 'opname' => 'cmplt_su', 'realopname' => 'cmptlt', 'opcode' => 232 }, 'Pebble::InstrDef::Alias'),

'cmptle' => bless({ 'opname' => 'cmptle',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 233 }, "Pebble::InstrDef::Instr"),

'cmptle_su' => bless({ 'opname' => 'cmptle_su', 'realopname' => 'cmple', 'opcode' => 234 }, 'Pebble::InstrDef::Alias'),

'cpys' => bless({ 'opname' => 'cpys',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 235 }, "Pebble::InstrDef::Instr"),

'cpysn' => bless({ 'opname' => 'cpysn',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 236 }, "Pebble::InstrDef::Instr"),

'cpyse' => bless({ 'opname' => 'cpyse',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 237 }, "Pebble::InstrDef::Instr"),

'fcmoveq' => bless({ 'opname' => 'fcmoveq',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 238 }, "Pebble::InstrDef::Instr"),

'fcmovge' => bless({ 'opname' => 'fcmovge',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 239 }, "Pebble::InstrDef::Instr"),

'fcmovgt' => bless({ 'opname' => 'fcmovgt',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 240 }, "Pebble::InstrDef::Instr"),

'fcmovle' => bless({ 'opname' => 'fcmovle',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 241 }, "Pebble::InstrDef::Instr"),

'fcmovlt' => bless({ 'opname' => 'fcmovlt',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 242 }, "Pebble::InstrDef::Instr"),

'fcmovne' => bless({ 'opname' => 'fcmovne',
	'InputArcs' => [ 'A', 'B', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 243 }, "Pebble::InstrDef::Instr"),

'opsqrt' => bless({ 'opname' => 'opsqrt',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 244 }, "Pebble::InstrDef::Instr"),

'sqrtt' => bless({ 'opname' => 'sqrtt', 'realopname' => 'opsqrt', 'opcode' => 245 }, 'Pebble::InstrDef::Alias'),

'sqrtt_c' => bless({ 'opname' => 'sqrtt_c', 'realopname' => 'sqrtt', 'opcode' => 246 }, 'Pebble::InstrDef::Alias'),

'sqrtt_d' => bless({ 'opname' => 'sqrtt_d', 'realopname' => 'sqrtt', 'opcode' => 247 }, 'Pebble::InstrDef::Alias'),

'sqrtt_u' => bless({ 'opname' => 'sqrtt_u', 'realopname' => 'sqrtt', 'opcode' => 248 }, 'Pebble::InstrDef::Alias'),

'sqrtt_ud' => bless({ 'opname' => 'sqrtt_ud', 'realopname' => 'sqrtt', 'opcode' => 249 }, 'Pebble::InstrDef::Alias'),

'sqrtt_suc' => bless({ 'opname' => 'sqrtt_suc', 'realopname' => 'sqrtt', 'opcode' => 250 }, 'Pebble::InstrDef::Alias'),

'sqrtt_sum' => bless({ 'opname' => 'sqrtt_sum', 'realopname' => 'sqrtt', 'opcode' => 251 }, 'Pebble::InstrDef::Alias'),

'sqrtt_su' => bless({ 'opname' => 'sqrtt_su', 'realopname' => 'sqrtt', 'opcode' => 252 }, 'Pebble::InstrDef::Alias'),

'sqrtt_um' => bless({ 'opname' => 'sqrtt_um', 'realopname' => 'sqrtt', 'opcode' => 253 }, 'Pebble::InstrDef::Alias'),

'sqrtt_uc' => bless({ 'opname' => 'sqrtt_uc', 'realopname' => 'sqrtt', 'opcode' => 254 }, 'Pebble::InstrDef::Alias'),

'sqrtt_sud' => bless({ 'opname' => 'sqrtt_sud', 'realopname' => 'sqrtt', 'opcode' => 255 }, 'Pebble::InstrDef::Alias'),

'sqrtt_suic' => bless({ 'opname' => 'sqrtt_suic', 'realopname' => 'sqrtt', 'opcode' => 256 }, 'Pebble::InstrDef::Alias'),

'sqrtt_suim' => bless({ 'opname' => 'sqrtt_suim', 'realopname' => 'sqrtt', 'opcode' => 257 }, 'Pebble::InstrDef::Alias'),

'sqrtt_sui' => bless({ 'opname' => 'sqrtt_sui', 'realopname' => 'sqrtt', 'opcode' => 258 }, 'Pebble::InstrDef::Alias'),

'sqrtt_suid' => bless({ 'opname' => 'sqrtt_suid', 'realopname' => 'sqrtt', 'opcode' => 259 }, 'Pebble::InstrDef::Alias'),

'sqrtt_m' => bless({ 'opname' => 'sqrtt_m', 'realopname' => 'sqrtt', 'opcode' => 260 }, 'Pebble::InstrDef::Alias'),

'opsqrtf' => bless({ 'opname' => 'opsqrtf', 'realopname' => 'opsqrt', 'opcode' => 261 }, 'Pebble::InstrDef::Alias'),

'sqrtf_c' => bless({ 'opname' => 'sqrtf_c', 'realopname' => 'opsqrt', 'opcode' => 262 }, 'Pebble::InstrDef::Alias'),

'sqrtf_u' => bless({ 'opname' => 'sqrtf_u', 'realopname' => 'opsqrt', 'opcode' => 263 }, 'Pebble::InstrDef::Alias'),

'sqrtf_suc' => bless({ 'opname' => 'sqrtf_suc', 'realopname' => 'opsqrt', 'opcode' => 264 }, 'Pebble::InstrDef::Alias'),

'sqrtf_su' => bless({ 'opname' => 'sqrtf_su', 'realopname' => 'opsqrt', 'opcode' => 265 }, 'Pebble::InstrDef::Alias'),

'sqrtf_uc' => bless({ 'opname' => 'sqrtf_uc', 'realopname' => 'opsqrt', 'opcode' => 266 }, 'Pebble::InstrDef::Alias'),

'sqrtf_s' => bless({ 'opname' => 'sqrtf_s', 'realopname' => 'opsqrt', 'opcode' => 267 }, 'Pebble::InstrDef::Alias'),

'sqrtf_sc' => bless({ 'opname' => 'sqrtf_sc', 'realopname' => 'opsqrt', 'opcode' => 268 }, 'Pebble::InstrDef::Alias'),

'lds' => bless({ 'opname' => 'lds',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 269 }, "Pebble::InstrDef::MemInstr"),

'ldt' => bless({ 'opname' => 'ldt',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 270 }, "Pebble::InstrDef::MemInstr"),

'sts' => bless({ 'opname' => 'sts',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 271 }, "Pebble::InstrDef::MemInstr"),

'stt' => bless({ 'opname' => 'stt',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 272 }, "Pebble::InstrDef::MemInstr"),

'itoft' => bless({ 'opname' => 'itoft',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 273 }, "Pebble::InstrDef::Instr"),

'itofs' => bless({ 'opname' => 'itofs',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 274 }, "Pebble::InstrDef::Instr"),

'ftoit' => bless({ 'opname' => 'ftoit',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 275 }, "Pebble::InstrDef::Instr"),

'ftois' => bless({ 'opname' => 'ftois',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 276 }, "Pebble::InstrDef::Instr"),

'cvtqt' => bless({ 'opname' => 'cvtqt',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 277 }, "Pebble::InstrDef::Instr"),

'cvtqt_c' => bless({ 'opname' => 'cvtqt_c', 'realopname' => 'cvtqt', 'opcode' => 278 }, 'Pebble::InstrDef::Alias'),

'cvtqt_m' => bless({ 'opname' => 'cvtqt_m', 'realopname' => 'cvtqt', 'opcode' => 279 }, 'Pebble::InstrDef::Alias'),

'cvtqt_d' => bless({ 'opname' => 'cvtqt_d', 'realopname' => 'cvtqt', 'opcode' => 280 }, 'Pebble::InstrDef::Alias'),

'cvtqt_suic' => bless({ 'opname' => 'cvtqt_suic', 'realopname' => 'cvtqt', 'opcode' => 281 }, 'Pebble::InstrDef::Alias'),

'cvtqt_suim' => bless({ 'opname' => 'cvtqt_suim', 'realopname' => 'cvtqt', 'opcode' => 282 }, 'Pebble::InstrDef::Alias'),

'cvtqt_sui' => bless({ 'opname' => 'cvtqt_sui', 'realopname' => 'cvtqt', 'opcode' => 283 }, 'Pebble::InstrDef::Alias'),

'cvtqt_suid' => bless({ 'opname' => 'cvtqt_suid', 'realopname' => 'cvtqt', 'opcode' => 284 }, 'Pebble::InstrDef::Alias'),

'cvtqs' => bless({ 'opname' => 'cvtqs',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 285 }, "Pebble::InstrDef::Instr"),

'cvtqs_c' => bless({ 'opname' => 'cvtqs_c', 'realopname' => 'cvtqs', 'opcode' => 286 }, 'Pebble::InstrDef::Alias'),

'cvtqs_m' => bless({ 'opname' => 'cvtqs_m', 'realopname' => 'cvtqs', 'opcode' => 287 }, 'Pebble::InstrDef::Alias'),

'cvtqs_d' => bless({ 'opname' => 'cvtqs_d', 'realopname' => 'cvtqs', 'opcode' => 288 }, 'Pebble::InstrDef::Alias'),

'cvtqs_suic' => bless({ 'opname' => 'cvtqs_suic', 'realopname' => 'cvtqs', 'opcode' => 289 }, 'Pebble::InstrDef::Alias'),

'cvtqs_suim' => bless({ 'opname' => 'cvtqs_suim', 'realopname' => 'cvtqs', 'opcode' => 290 }, 'Pebble::InstrDef::Alias'),

'cvtqs_sui' => bless({ 'opname' => 'cvtqs_sui', 'realopname' => 'cvtqs', 'opcode' => 291 }, 'Pebble::InstrDef::Alias'),

'cvtqs_suid' => bless({ 'opname' => 'cvtqs_suid', 'realopname' => 'cvtqs', 'opcode' => 292 }, 'Pebble::InstrDef::Alias'),

'cvtts' => bless({ 'opname' => 'cvtts',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 293 }, "Pebble::InstrDef::Instr"),

'cvtts_c' => bless({ 'opname' => 'cvtts_c', 'realopname' => 'cvtts', 'opcode' => 294 }, 'Pebble::InstrDef::Alias'),

'cvtts_d' => bless({ 'opname' => 'cvtts_d', 'realopname' => 'cvtts', 'opcode' => 295 }, 'Pebble::InstrDef::Alias'),

'cvtts_u' => bless({ 'opname' => 'cvtts_u', 'realopname' => 'cvtts', 'opcode' => 296 }, 'Pebble::InstrDef::Alias'),

'cvtts_ud' => bless({ 'opname' => 'cvtts_ud', 'realopname' => 'cvtts', 'opcode' => 297 }, 'Pebble::InstrDef::Alias'),

'cvtts_suc' => bless({ 'opname' => 'cvtts_suc', 'realopname' => 'cvtts', 'opcode' => 298 }, 'Pebble::InstrDef::Alias'),

'cvtts_sum' => bless({ 'opname' => 'cvtts_sum', 'realopname' => 'cvtts', 'opcode' => 299 }, 'Pebble::InstrDef::Alias'),

'cvtts_su' => bless({ 'opname' => 'cvtts_su', 'realopname' => 'cvtts', 'opcode' => 300 }, 'Pebble::InstrDef::Alias'),

'cvtts_um' => bless({ 'opname' => 'cvtts_um', 'realopname' => 'cvtts', 'opcode' => 301 }, 'Pebble::InstrDef::Alias'),

'cvtts_uc' => bless({ 'opname' => 'cvtts_uc', 'realopname' => 'cvtts', 'opcode' => 302 }, 'Pebble::InstrDef::Alias'),

'cvtts_sud' => bless({ 'opname' => 'cvtts_sud', 'realopname' => 'cvtts', 'opcode' => 303 }, 'Pebble::InstrDef::Alias'),

'cvtts_suic' => bless({ 'opname' => 'cvtts_suic', 'realopname' => 'cvtts', 'opcode' => 304 }, 'Pebble::InstrDef::Alias'),

'cvtts_suim' => bless({ 'opname' => 'cvtts_suim', 'realopname' => 'cvtts', 'opcode' => 305 }, 'Pebble::InstrDef::Alias'),

'cvtts_sui' => bless({ 'opname' => 'cvtts_sui', 'realopname' => 'cvtts', 'opcode' => 306 }, 'Pebble::InstrDef::Alias'),

'cvtts_suid' => bless({ 'opname' => 'cvtts_suid', 'realopname' => 'cvtts', 'opcode' => 307 }, 'Pebble::InstrDef::Alias'),

'cvtts_m' => bless({ 'opname' => 'cvtts_m', 'realopname' => 'cvtts', 'opcode' => 308 }, 'Pebble::InstrDef::Alias'),

'cvtql' => bless({ 'opname' => 'cvtql',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 309 }, "Pebble::InstrDef::Instr"),

'cvtql_v' => bless({ 'opname' => 'cvtql_v', 'realopname' => 'cvtql', 'opcode' => 310 }, 'Pebble::InstrDef::Alias'),

'cvtql_sv' => bless({ 'opname' => 'cvtql_sv', 'realopname' => 'cvtql', 'opcode' => 311 }, 'Pebble::InstrDef::Alias'),

'cvtlq' => bless({ 'opname' => 'cvtlq',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 312 }, "Pebble::InstrDef::Instr"),

'cvttq' => bless({ 'opname' => 'cvttq',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 313 }, "Pebble::InstrDef::Instr"),

'cvttq_c' => bless({ 'opname' => 'cvttq_c', 'realopname' => 'cvttq', 'opcode' => 314 }, 'Pebble::InstrDef::Alias'),

'cvttq_m' => bless({ 'opname' => 'cvttq_m', 'realopname' => 'cvttq', 'opcode' => 315 }, 'Pebble::InstrDef::Alias'),

'cvttq_d' => bless({ 'opname' => 'cvttq_d', 'realopname' => 'cvttq', 'opcode' => 316 }, 'Pebble::InstrDef::Alias'),

'cvttq_vc' => bless({ 'opname' => 'cvttq_vc', 'realopname' => 'cvttq', 'opcode' => 317 }, 'Pebble::InstrDef::Alias'),

'cvttq_vm' => bless({ 'opname' => 'cvttq_vm', 'realopname' => 'cvttq', 'opcode' => 318 }, 'Pebble::InstrDef::Alias'),

'cvttq_v' => bless({ 'opname' => 'cvttq_v', 'realopname' => 'cvttq', 'opcode' => 319 }, 'Pebble::InstrDef::Alias'),

'cvttq_vd' => bless({ 'opname' => 'cvttq_vd', 'realopname' => 'cvttq', 'opcode' => 320 }, 'Pebble::InstrDef::Alias'),

'cvttq_svc' => bless({ 'opname' => 'cvttq_svc', 'realopname' => 'cvttq', 'opcode' => 321 }, 'Pebble::InstrDef::Alias'),

'cvttq_svm' => bless({ 'opname' => 'cvttq_svm', 'realopname' => 'cvttq', 'opcode' => 322 }, 'Pebble::InstrDef::Alias'),

'cvttq_sv' => bless({ 'opname' => 'cvttq_sv', 'realopname' => 'cvttq', 'opcode' => 323 }, 'Pebble::InstrDef::Alias'),

'cvttq_svd' => bless({ 'opname' => 'cvttq_svd', 'realopname' => 'cvttq', 'opcode' => 324 }, 'Pebble::InstrDef::Alias'),

'cvttq_svic' => bless({ 'opname' => 'cvttq_svic', 'realopname' => 'cvttq', 'opcode' => 325 }, 'Pebble::InstrDef::Alias'),

'cvttq_svim' => bless({ 'opname' => 'cvttq_svim', 'realopname' => 'cvttq', 'opcode' => 326 }, 'Pebble::InstrDef::Alias'),

'cvttq_svi' => bless({ 'opname' => 'cvttq_svi', 'realopname' => 'cvttq', 'opcode' => 327 }, 'Pebble::InstrDef::Alias'),

'cvttq_svid' => bless({ 'opname' => 'cvttq_svid', 'realopname' => 'cvttq', 'opcode' => 328 }, 'Pebble::InstrDef::Alias'),

'fbeq' => bless({ 'opname' => 'fbeq',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 329 }, "Pebble::InstrDef::Instr"),

'fbge' => bless({ 'opname' => 'fbge',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 330 }, "Pebble::InstrDef::Instr"),

'fbgt' => bless({ 'opname' => 'fbgt',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 331 }, "Pebble::InstrDef::Instr"),

'fble' => bless({ 'opname' => 'fble',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 332 }, "Pebble::InstrDef::Instr"),

'fblt' => bless({ 'opname' => 'fblt',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 333 }, "Pebble::InstrDef::Instr"),

'fbne' => bless({ 'opname' => 'fbne',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 334 }, "Pebble::InstrDef::Instr"),

'addl_I' => bless({ 'opname' => 'addl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 335 }, "Pebble::InstrDef::Instr"),

'addl_v_I' => bless({ 'opname' => 'addl_v_I', 'realopname' => 'addl_I', 'opcode' => 336 }, 'Pebble::InstrDef::Alias'),

's4addl_I' => bless({ 'opname' => 's4addl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 337 }, "Pebble::InstrDef::Instr"),

's8addl_I' => bless({ 'opname' => 's8addl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 338 }, "Pebble::InstrDef::Instr"),

'addq_I' => bless({ 'opname' => 'addq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 339 }, "Pebble::InstrDef::Instr"),

'addq_v_I' => bless({ 'opname' => 'addq_v_I', 'realopname' => 'addq_I', 'opcode' => 340 }, 'Pebble::InstrDef::Alias'),

's4addq_I' => bless({ 'opname' => 's4addq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 341 }, "Pebble::InstrDef::Instr"),

's8addq_I' => bless({ 'opname' => 's8addq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 342 }, "Pebble::InstrDef::Instr"),

'cmpeq_I' => bless({ 'opname' => 'cmpeq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 343 }, "Pebble::InstrDef::Instr"),

'cmple_I' => bless({ 'opname' => 'cmple_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 344 }, "Pebble::InstrDef::Instr"),

'cmplt_I' => bless({ 'opname' => 'cmplt_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 345 }, "Pebble::InstrDef::Instr"),

'cmpule_I' => bless({ 'opname' => 'cmpule_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 346 }, "Pebble::InstrDef::Instr"),

'cmpult_I' => bless({ 'opname' => 'cmpult_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 347 }, "Pebble::InstrDef::Instr"),

'ctlz_I' => bless({ 'opname' => 'ctlz_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 348 }, "Pebble::InstrDef::Instr"),

'ctpop_I' => bless({ 'opname' => 'ctpop_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 349 }, "Pebble::InstrDef::Instr"),

'cttz_I' => bless({ 'opname' => 'cttz_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 350 }, "Pebble::InstrDef::Instr"),

'mull_I' => bless({ 'opname' => 'mull_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 351 }, "Pebble::InstrDef::Instr"),

'mull_v_I' => bless({ 'opname' => 'mull_v_I', 'realopname' => 'mull_I', 'opcode' => 352 }, 'Pebble::InstrDef::Alias'),

'mulq_I' => bless({ 'opname' => 'mulq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 353 }, "Pebble::InstrDef::Instr"),

'mulq_v_I' => bless({ 'opname' => 'mulq_v_I', 'realopname' => 'mulq_I', 'opcode' => 354 }, 'Pebble::InstrDef::Alias'),

'umulh_I' => bless({ 'opname' => 'umulh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 355 }, "Pebble::InstrDef::Instr"),

'subl_I' => bless({ 'opname' => 'subl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 356 }, "Pebble::InstrDef::Instr"),

'subl_v_I' => bless({ 'opname' => 'subl_v_I', 'realopname' => 'subl_I', 'opcode' => 357 }, 'Pebble::InstrDef::Alias'),

's4subl_I' => bless({ 'opname' => 's4subl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 358 }, "Pebble::InstrDef::Instr"),

's8subl_I' => bless({ 'opname' => 's8subl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 359 }, "Pebble::InstrDef::Instr"),

'subq_I' => bless({ 'opname' => 'subq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 360 }, "Pebble::InstrDef::Instr"),

'subq_v_I' => bless({ 'opname' => 'subq_v_I', 'realopname' => 'subq_I', 'opcode' => 361 }, 'Pebble::InstrDef::Alias'),

's4subq_I' => bless({ 'opname' => 's4subq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 362 }, "Pebble::InstrDef::Instr"),

's8subq_I' => bless({ 'opname' => 's8subq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 363 }, "Pebble::InstrDef::Instr"),

'opand_I' => bless({ 'opname' => 'opand_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 364 }, "Pebble::InstrDef::Instr"),

'bis_I' => bless({ 'opname' => 'bis_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 365 }, "Pebble::InstrDef::Instr"),

'opxor_I' => bless({ 'opname' => 'opxor_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 366 }, "Pebble::InstrDef::Instr"),

'bic_I' => bless({ 'opname' => 'bic_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 367 }, "Pebble::InstrDef::Instr"),

'ornot_I' => bless({ 'opname' => 'ornot_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 368 }, "Pebble::InstrDef::Instr"),

'eqv_I' => bless({ 'opname' => 'eqv_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 369 }, "Pebble::InstrDef::Instr"),

'cmoveq_I' => bless({ 'opname' => 'cmoveq_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 370 }, "Pebble::InstrDef::Instr"),

'cmovge_I' => bless({ 'opname' => 'cmovge_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 371 }, "Pebble::InstrDef::Instr"),

'cmovgt_I' => bless({ 'opname' => 'cmovgt_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 372 }, "Pebble::InstrDef::Instr"),

'cmovlbc_I' => bless({ 'opname' => 'cmovlbc_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 373 }, "Pebble::InstrDef::Instr"),

'cmovlbs_I' => bless({ 'opname' => 'cmovlbs_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 374 }, "Pebble::InstrDef::Instr"),

'cmovle_I' => bless({ 'opname' => 'cmovle_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 375 }, "Pebble::InstrDef::Instr"),

'cmovlt_I' => bless({ 'opname' => 'cmovlt_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 376 }, "Pebble::InstrDef::Instr"),

'cmovne_I' => bless({ 'opname' => 'cmovne_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 377 }, "Pebble::InstrDef::Instr"),

'sll_I' => bless({ 'opname' => 'sll_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 378 }, "Pebble::InstrDef::Instr"),

'srl_I' => bless({ 'opname' => 'srl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 379 }, "Pebble::InstrDef::Instr"),

'sra_I' => bless({ 'opname' => 'sra_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 380 }, "Pebble::InstrDef::Instr"),

'cmpbge_I' => bless({ 'opname' => 'cmpbge_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 381 }, "Pebble::InstrDef::Instr"),

'extbl_I' => bless({ 'opname' => 'extbl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 382 }, "Pebble::InstrDef::Instr"),

'extwl_I' => bless({ 'opname' => 'extwl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 383 }, "Pebble::InstrDef::Instr"),

'extll_I' => bless({ 'opname' => 'extll_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 384 }, "Pebble::InstrDef::Instr"),

'extql_I' => bless({ 'opname' => 'extql_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 385 }, "Pebble::InstrDef::Instr"),

'extwh_I' => bless({ 'opname' => 'extwh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 386 }, "Pebble::InstrDef::Instr"),

'extlh_I' => bless({ 'opname' => 'extlh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 387 }, "Pebble::InstrDef::Instr"),

'extqh_I' => bless({ 'opname' => 'extqh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 388 }, "Pebble::InstrDef::Instr"),

'insbl_I' => bless({ 'opname' => 'insbl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 389 }, "Pebble::InstrDef::Instr"),

'inswl_I' => bless({ 'opname' => 'inswl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 390 }, "Pebble::InstrDef::Instr"),

'insll_I' => bless({ 'opname' => 'insll_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 391 }, "Pebble::InstrDef::Instr"),

'insql_I' => bless({ 'opname' => 'insql_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 392 }, "Pebble::InstrDef::Instr"),

'inswh_I' => bless({ 'opname' => 'inswh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 393 }, "Pebble::InstrDef::Instr"),

'inslh_I' => bless({ 'opname' => 'inslh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 394 }, "Pebble::InstrDef::Instr"),

'insqh_I' => bless({ 'opname' => 'insqh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 395 }, "Pebble::InstrDef::Instr"),

'mskbl_I' => bless({ 'opname' => 'mskbl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 396 }, "Pebble::InstrDef::Instr"),

'mskwl_I' => bless({ 'opname' => 'mskwl_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 397 }, "Pebble::InstrDef::Instr"),

'mskll_I' => bless({ 'opname' => 'mskll_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 398 }, "Pebble::InstrDef::Instr"),

'mskql_I' => bless({ 'opname' => 'mskql_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 399 }, "Pebble::InstrDef::Instr"),

'mskwh_I' => bless({ 'opname' => 'mskwh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 400 }, "Pebble::InstrDef::Instr"),

'msklh_I' => bless({ 'opname' => 'msklh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 401 }, "Pebble::InstrDef::Instr"),

'mskqh_I' => bless({ 'opname' => 'mskqh_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 402 }, "Pebble::InstrDef::Instr"),

'sextb_I' => bless({ 'opname' => 'sextb_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 403 }, "Pebble::InstrDef::Instr"),

'sextw_I' => bless({ 'opname' => 'sextw_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 404 }, "Pebble::InstrDef::Instr"),

'zap_I' => bless({ 'opname' => 'zap_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 405 }, "Pebble::InstrDef::Instr"),

'zapnot_I' => bless({ 'opname' => 'zapnot_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 406 }, "Pebble::InstrDef::Instr"),

'amask_I' => bless({ 'opname' => 'amask_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 407 }, "Pebble::InstrDef::Instr"),

'addt_I' => bless({ 'opname' => 'addt_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 408 }, "Pebble::InstrDef::Instr"),

'adds_I' => bless({ 'opname' => 'adds_I', 'realopname' => 'addt_I', 'opcode' => 409 }, 'Pebble::InstrDef::Alias'),

'addt_c_I' => bless({ 'opname' => 'addt_c_I', 'realopname' => 'addt_I', 'opcode' => 410 }, 'Pebble::InstrDef::Alias'),

'addt_d_I' => bless({ 'opname' => 'addt_d_I', 'realopname' => 'addt_I', 'opcode' => 411 }, 'Pebble::InstrDef::Alias'),

'addt_u_I' => bless({ 'opname' => 'addt_u_I', 'realopname' => 'addt_I', 'opcode' => 412 }, 'Pebble::InstrDef::Alias'),

'addt_ud_I' => bless({ 'opname' => 'addt_ud_I', 'realopname' => 'addt_I', 'opcode' => 413 }, 'Pebble::InstrDef::Alias'),

'addt_suc_I' => bless({ 'opname' => 'addt_suc_I', 'realopname' => 'addt_I', 'opcode' => 414 }, 'Pebble::InstrDef::Alias'),

'addt_sum_I' => bless({ 'opname' => 'addt_sum_I', 'realopname' => 'addt_I', 'opcode' => 415 }, 'Pebble::InstrDef::Alias'),

'addt_su_I' => bless({ 'opname' => 'addt_su_I', 'realopname' => 'addt_I', 'opcode' => 416 }, 'Pebble::InstrDef::Alias'),

'addt_um_I' => bless({ 'opname' => 'addt_um_I', 'realopname' => 'addt_I', 'opcode' => 417 }, 'Pebble::InstrDef::Alias'),

'addt_uc_I' => bless({ 'opname' => 'addt_uc_I', 'realopname' => 'addt_I', 'opcode' => 418 }, 'Pebble::InstrDef::Alias'),

'addt_sud_I' => bless({ 'opname' => 'addt_sud_I', 'realopname' => 'addt_I', 'opcode' => 419 }, 'Pebble::InstrDef::Alias'),

'addt_suic_I' => bless({ 'opname' => 'addt_suic_I', 'realopname' => 'addt_I', 'opcode' => 420 }, 'Pebble::InstrDef::Alias'),

'addt_suim_I' => bless({ 'opname' => 'addt_suim_I', 'realopname' => 'addt_I', 'opcode' => 421 }, 'Pebble::InstrDef::Alias'),

'addt_sui_I' => bless({ 'opname' => 'addt_sui_I', 'realopname' => 'addt_I', 'opcode' => 422 }, 'Pebble::InstrDef::Alias'),

'addt_suid_I' => bless({ 'opname' => 'addt_suid_I', 'realopname' => 'addt_I', 'opcode' => 423 }, 'Pebble::InstrDef::Alias'),

'addt_m_I' => bless({ 'opname' => 'addt_m_I', 'realopname' => 'addt_I', 'opcode' => 424 }, 'Pebble::InstrDef::Alias'),

'adds_c_I' => bless({ 'opname' => 'adds_c_I', 'realopname' => 'adds_I', 'opcode' => 425 }, 'Pebble::InstrDef::Alias'),

'adds_d_I' => bless({ 'opname' => 'adds_d_I', 'realopname' => 'adds_I', 'opcode' => 426 }, 'Pebble::InstrDef::Alias'),

'adds_u_I' => bless({ 'opname' => 'adds_u_I', 'realopname' => 'adds_I', 'opcode' => 427 }, 'Pebble::InstrDef::Alias'),

'adds_ud_I' => bless({ 'opname' => 'adds_ud_I', 'realopname' => 'adds_I', 'opcode' => 428 }, 'Pebble::InstrDef::Alias'),

'adds_suc_I' => bless({ 'opname' => 'adds_suc_I', 'realopname' => 'adds_I', 'opcode' => 429 }, 'Pebble::InstrDef::Alias'),

'adds_sum_I' => bless({ 'opname' => 'adds_sum_I', 'realopname' => 'adds_I', 'opcode' => 430 }, 'Pebble::InstrDef::Alias'),

'adds_su_I' => bless({ 'opname' => 'adds_su_I', 'realopname' => 'adds_I', 'opcode' => 431 }, 'Pebble::InstrDef::Alias'),

'adds_um_I' => bless({ 'opname' => 'adds_um_I', 'realopname' => 'adds_I', 'opcode' => 432 }, 'Pebble::InstrDef::Alias'),

'adds_uc_I' => bless({ 'opname' => 'adds_uc_I', 'realopname' => 'adds_I', 'opcode' => 433 }, 'Pebble::InstrDef::Alias'),

'adds_sud_I' => bless({ 'opname' => 'adds_sud_I', 'realopname' => 'adds_I', 'opcode' => 434 }, 'Pebble::InstrDef::Alias'),

'adds_suic_I' => bless({ 'opname' => 'adds_suic_I', 'realopname' => 'adds_I', 'opcode' => 435 }, 'Pebble::InstrDef::Alias'),

'adds_suim_I' => bless({ 'opname' => 'adds_suim_I', 'realopname' => 'adds_I', 'opcode' => 436 }, 'Pebble::InstrDef::Alias'),

'adds_sui_I' => bless({ 'opname' => 'adds_sui_I', 'realopname' => 'adds_I', 'opcode' => 437 }, 'Pebble::InstrDef::Alias'),

'adds_suid_I' => bless({ 'opname' => 'adds_suid_I', 'realopname' => 'adds_I', 'opcode' => 438 }, 'Pebble::InstrDef::Alias'),

'adds_m_I' => bless({ 'opname' => 'adds_m_I', 'realopname' => 'adds_I', 'opcode' => 439 }, 'Pebble::InstrDef::Alias'),

'subt_I' => bless({ 'opname' => 'subt_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 440 }, "Pebble::InstrDef::Instr"),

'subs_I' => bless({ 'opname' => 'subs_I', 'realopname' => 'subt_I', 'opcode' => 441 }, 'Pebble::InstrDef::Alias'),

'subt_c_I' => bless({ 'opname' => 'subt_c_I', 'realopname' => 'subt_I', 'opcode' => 442 }, 'Pebble::InstrDef::Alias'),

'subt_d_I' => bless({ 'opname' => 'subt_d_I', 'realopname' => 'subt_I', 'opcode' => 443 }, 'Pebble::InstrDef::Alias'),

'subt_u_I' => bless({ 'opname' => 'subt_u_I', 'realopname' => 'subt_I', 'opcode' => 444 }, 'Pebble::InstrDef::Alias'),

'subt_ud_I' => bless({ 'opname' => 'subt_ud_I', 'realopname' => 'subt_I', 'opcode' => 445 }, 'Pebble::InstrDef::Alias'),

'subt_suc_I' => bless({ 'opname' => 'subt_suc_I', 'realopname' => 'subt_I', 'opcode' => 446 }, 'Pebble::InstrDef::Alias'),

'subt_sum_I' => bless({ 'opname' => 'subt_sum_I', 'realopname' => 'subt_I', 'opcode' => 447 }, 'Pebble::InstrDef::Alias'),

'subt_su_I' => bless({ 'opname' => 'subt_su_I', 'realopname' => 'subt_I', 'opcode' => 448 }, 'Pebble::InstrDef::Alias'),

'subt_um_I' => bless({ 'opname' => 'subt_um_I', 'realopname' => 'subt_I', 'opcode' => 449 }, 'Pebble::InstrDef::Alias'),

'subt_uc_I' => bless({ 'opname' => 'subt_uc_I', 'realopname' => 'subt_I', 'opcode' => 450 }, 'Pebble::InstrDef::Alias'),

'subt_sud_I' => bless({ 'opname' => 'subt_sud_I', 'realopname' => 'subt_I', 'opcode' => 451 }, 'Pebble::InstrDef::Alias'),

'subt_suic_I' => bless({ 'opname' => 'subt_suic_I', 'realopname' => 'subt_I', 'opcode' => 452 }, 'Pebble::InstrDef::Alias'),

'subt_suim_I' => bless({ 'opname' => 'subt_suim_I', 'realopname' => 'subt_I', 'opcode' => 453 }, 'Pebble::InstrDef::Alias'),

'subt_sui_I' => bless({ 'opname' => 'subt_sui_I', 'realopname' => 'subt_I', 'opcode' => 454 }, 'Pebble::InstrDef::Alias'),

'subt_suid_I' => bless({ 'opname' => 'subt_suid_I', 'realopname' => 'subt_I', 'opcode' => 455 }, 'Pebble::InstrDef::Alias'),

'subt_m_I' => bless({ 'opname' => 'subt_m_I', 'realopname' => 'subt_I', 'opcode' => 456 }, 'Pebble::InstrDef::Alias'),

'subs_c_I' => bless({ 'opname' => 'subs_c_I', 'realopname' => 'subs_I', 'opcode' => 457 }, 'Pebble::InstrDef::Alias'),

'subs_d_I' => bless({ 'opname' => 'subs_d_I', 'realopname' => 'subs_I', 'opcode' => 458 }, 'Pebble::InstrDef::Alias'),

'subs_u_I' => bless({ 'opname' => 'subs_u_I', 'realopname' => 'subs_I', 'opcode' => 459 }, 'Pebble::InstrDef::Alias'),

'subs_ud_I' => bless({ 'opname' => 'subs_ud_I', 'realopname' => 'subs_I', 'opcode' => 460 }, 'Pebble::InstrDef::Alias'),

'subs_suc_I' => bless({ 'opname' => 'subs_suc_I', 'realopname' => 'subs_I', 'opcode' => 461 }, 'Pebble::InstrDef::Alias'),

'subs_sum_I' => bless({ 'opname' => 'subs_sum_I', 'realopname' => 'subs_I', 'opcode' => 462 }, 'Pebble::InstrDef::Alias'),

'subs_su_I' => bless({ 'opname' => 'subs_su_I', 'realopname' => 'subs_I', 'opcode' => 463 }, 'Pebble::InstrDef::Alias'),

'subs_um_I' => bless({ 'opname' => 'subs_um_I', 'realopname' => 'subs_I', 'opcode' => 464 }, 'Pebble::InstrDef::Alias'),

'subs_uc_I' => bless({ 'opname' => 'subs_uc_I', 'realopname' => 'subs_I', 'opcode' => 465 }, 'Pebble::InstrDef::Alias'),

'subs_sud_I' => bless({ 'opname' => 'subs_sud_I', 'realopname' => 'subs_I', 'opcode' => 466 }, 'Pebble::InstrDef::Alias'),

'subs_suic_I' => bless({ 'opname' => 'subs_suic_I', 'realopname' => 'subs_I', 'opcode' => 467 }, 'Pebble::InstrDef::Alias'),

'subs_suim_I' => bless({ 'opname' => 'subs_suim_I', 'realopname' => 'subs_I', 'opcode' => 468 }, 'Pebble::InstrDef::Alias'),

'subs_sui_I' => bless({ 'opname' => 'subs_sui_I', 'realopname' => 'subs_I', 'opcode' => 469 }, 'Pebble::InstrDef::Alias'),

'subs_suid_I' => bless({ 'opname' => 'subs_suid_I', 'realopname' => 'subs_I', 'opcode' => 470 }, 'Pebble::InstrDef::Alias'),

'subs_m_I' => bless({ 'opname' => 'subs_m_I', 'realopname' => 'subs_I', 'opcode' => 471 }, 'Pebble::InstrDef::Alias'),

'mult_I' => bless({ 'opname' => 'mult_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 472 }, "Pebble::InstrDef::Instr"),

'muls_I' => bless({ 'opname' => 'muls_I', 'realopname' => 'mult_I', 'opcode' => 473 }, 'Pebble::InstrDef::Alias'),

'mult_c_I' => bless({ 'opname' => 'mult_c_I', 'realopname' => 'mult_I', 'opcode' => 474 }, 'Pebble::InstrDef::Alias'),

'mult_d_I' => bless({ 'opname' => 'mult_d_I', 'realopname' => 'mult_I', 'opcode' => 475 }, 'Pebble::InstrDef::Alias'),

'mult_u_I' => bless({ 'opname' => 'mult_u_I', 'realopname' => 'mult_I', 'opcode' => 476 }, 'Pebble::InstrDef::Alias'),

'mult_ud_I' => bless({ 'opname' => 'mult_ud_I', 'realopname' => 'mult_I', 'opcode' => 477 }, 'Pebble::InstrDef::Alias'),

'mult_suc_I' => bless({ 'opname' => 'mult_suc_I', 'realopname' => 'mult_I', 'opcode' => 478 }, 'Pebble::InstrDef::Alias'),

'mult_sum_I' => bless({ 'opname' => 'mult_sum_I', 'realopname' => 'mult_I', 'opcode' => 479 }, 'Pebble::InstrDef::Alias'),

'mult_su_I' => bless({ 'opname' => 'mult_su_I', 'realopname' => 'mult_I', 'opcode' => 480 }, 'Pebble::InstrDef::Alias'),

'mult_um_I' => bless({ 'opname' => 'mult_um_I', 'realopname' => 'mult_I', 'opcode' => 481 }, 'Pebble::InstrDef::Alias'),

'mult_uc_I' => bless({ 'opname' => 'mult_uc_I', 'realopname' => 'mult_I', 'opcode' => 482 }, 'Pebble::InstrDef::Alias'),

'mult_sud_I' => bless({ 'opname' => 'mult_sud_I', 'realopname' => 'mult_I', 'opcode' => 483 }, 'Pebble::InstrDef::Alias'),

'mult_suic_I' => bless({ 'opname' => 'mult_suic_I', 'realopname' => 'mult_I', 'opcode' => 484 }, 'Pebble::InstrDef::Alias'),

'mult_suim_I' => bless({ 'opname' => 'mult_suim_I', 'realopname' => 'mult_I', 'opcode' => 485 }, 'Pebble::InstrDef::Alias'),

'mult_sui_I' => bless({ 'opname' => 'mult_sui_I', 'realopname' => 'mult_I', 'opcode' => 486 }, 'Pebble::InstrDef::Alias'),

'mult_suid_I' => bless({ 'opname' => 'mult_suid_I', 'realopname' => 'mult_I', 'opcode' => 487 }, 'Pebble::InstrDef::Alias'),

'mult_m_I' => bless({ 'opname' => 'mult_m_I', 'realopname' => 'mult_I', 'opcode' => 488 }, 'Pebble::InstrDef::Alias'),

'muls_c_I' => bless({ 'opname' => 'muls_c_I', 'realopname' => 'muls_I', 'opcode' => 489 }, 'Pebble::InstrDef::Alias'),

'muls_d_I' => bless({ 'opname' => 'muls_d_I', 'realopname' => 'muls_I', 'opcode' => 490 }, 'Pebble::InstrDef::Alias'),

'muls_u_I' => bless({ 'opname' => 'muls_u_I', 'realopname' => 'muls_I', 'opcode' => 491 }, 'Pebble::InstrDef::Alias'),

'muls_ud_I' => bless({ 'opname' => 'muls_ud_I', 'realopname' => 'muls_I', 'opcode' => 492 }, 'Pebble::InstrDef::Alias'),

'muls_suc_I' => bless({ 'opname' => 'muls_suc_I', 'realopname' => 'muls_I', 'opcode' => 493 }, 'Pebble::InstrDef::Alias'),

'muls_sum_I' => bless({ 'opname' => 'muls_sum_I', 'realopname' => 'muls_I', 'opcode' => 494 }, 'Pebble::InstrDef::Alias'),

'muls_su_I' => bless({ 'opname' => 'muls_su_I', 'realopname' => 'muls_I', 'opcode' => 495 }, 'Pebble::InstrDef::Alias'),

'muls_um_I' => bless({ 'opname' => 'muls_um_I', 'realopname' => 'muls_I', 'opcode' => 496 }, 'Pebble::InstrDef::Alias'),

'muls_uc_I' => bless({ 'opname' => 'muls_uc_I', 'realopname' => 'muls_I', 'opcode' => 497 }, 'Pebble::InstrDef::Alias'),

'muls_sud_I' => bless({ 'opname' => 'muls_sud_I', 'realopname' => 'muls_I', 'opcode' => 498 }, 'Pebble::InstrDef::Alias'),

'muls_suic_I' => bless({ 'opname' => 'muls_suic_I', 'realopname' => 'muls_I', 'opcode' => 499 }, 'Pebble::InstrDef::Alias'),

'muls_suim_I' => bless({ 'opname' => 'muls_suim_I', 'realopname' => 'muls_I', 'opcode' => 500 }, 'Pebble::InstrDef::Alias'),

'muls_sui_I' => bless({ 'opname' => 'muls_sui_I', 'realopname' => 'muls_I', 'opcode' => 501 }, 'Pebble::InstrDef::Alias'),

'muls_suid_I' => bless({ 'opname' => 'muls_suid_I', 'realopname' => 'muls_I', 'opcode' => 502 }, 'Pebble::InstrDef::Alias'),

'muls_m_I' => bless({ 'opname' => 'muls_m_I', 'realopname' => 'muls_I', 'opcode' => 503 }, 'Pebble::InstrDef::Alias'),

'divt_I' => bless({ 'opname' => 'divt_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 504 }, "Pebble::InstrDef::Instr"),

'divs_I' => bless({ 'opname' => 'divs_I', 'realopname' => 'divt_I', 'opcode' => 505 }, 'Pebble::InstrDef::Alias'),

'divt_c_I' => bless({ 'opname' => 'divt_c_I', 'realopname' => 'divt_I', 'opcode' => 506 }, 'Pebble::InstrDef::Alias'),

'divt_d_I' => bless({ 'opname' => 'divt_d_I', 'realopname' => 'divt_I', 'opcode' => 507 }, 'Pebble::InstrDef::Alias'),

'divt_u_I' => bless({ 'opname' => 'divt_u_I', 'realopname' => 'divt_I', 'opcode' => 508 }, 'Pebble::InstrDef::Alias'),

'divt_ud_I' => bless({ 'opname' => 'divt_ud_I', 'realopname' => 'divt_I', 'opcode' => 509 }, 'Pebble::InstrDef::Alias'),

'divt_suc_I' => bless({ 'opname' => 'divt_suc_I', 'realopname' => 'divt_I', 'opcode' => 510 }, 'Pebble::InstrDef::Alias'),

'divt_sum_I' => bless({ 'opname' => 'divt_sum_I', 'realopname' => 'divt_I', 'opcode' => 511 }, 'Pebble::InstrDef::Alias'),

'divt_su_I' => bless({ 'opname' => 'divt_su_I', 'realopname' => 'divt_I', 'opcode' => 512 }, 'Pebble::InstrDef::Alias'),

'divt_um_I' => bless({ 'opname' => 'divt_um_I', 'realopname' => 'divt_I', 'opcode' => 513 }, 'Pebble::InstrDef::Alias'),

'divt_uc_I' => bless({ 'opname' => 'divt_uc_I', 'realopname' => 'divt_I', 'opcode' => 514 }, 'Pebble::InstrDef::Alias'),

'divt_sud_I' => bless({ 'opname' => 'divt_sud_I', 'realopname' => 'divt_I', 'opcode' => 515 }, 'Pebble::InstrDef::Alias'),

'divt_suic_I' => bless({ 'opname' => 'divt_suic_I', 'realopname' => 'divt_I', 'opcode' => 516 }, 'Pebble::InstrDef::Alias'),

'divt_suim_I' => bless({ 'opname' => 'divt_suim_I', 'realopname' => 'divt_I', 'opcode' => 517 }, 'Pebble::InstrDef::Alias'),

'divt_sui_I' => bless({ 'opname' => 'divt_sui_I', 'realopname' => 'divt_I', 'opcode' => 518 }, 'Pebble::InstrDef::Alias'),

'divt_suid_I' => bless({ 'opname' => 'divt_suid_I', 'realopname' => 'divt_I', 'opcode' => 519 }, 'Pebble::InstrDef::Alias'),

'divt_m_I' => bless({ 'opname' => 'divt_m_I', 'realopname' => 'divt_I', 'opcode' => 520 }, 'Pebble::InstrDef::Alias'),

'divs_c_I' => bless({ 'opname' => 'divs_c_I', 'realopname' => 'divs_I', 'opcode' => 521 }, 'Pebble::InstrDef::Alias'),

'divs_d_I' => bless({ 'opname' => 'divs_d_I', 'realopname' => 'divs_I', 'opcode' => 522 }, 'Pebble::InstrDef::Alias'),

'divs_u_I' => bless({ 'opname' => 'divs_u_I', 'realopname' => 'divs_I', 'opcode' => 523 }, 'Pebble::InstrDef::Alias'),

'divs_ud_I' => bless({ 'opname' => 'divs_ud_I', 'realopname' => 'divs_I', 'opcode' => 524 }, 'Pebble::InstrDef::Alias'),

'divs_suc_I' => bless({ 'opname' => 'divs_suc_I', 'realopname' => 'divs_I', 'opcode' => 525 }, 'Pebble::InstrDef::Alias'),

'divs_sum_I' => bless({ 'opname' => 'divs_sum_I', 'realopname' => 'divs_I', 'opcode' => 526 }, 'Pebble::InstrDef::Alias'),

'divs_su_I' => bless({ 'opname' => 'divs_su_I', 'realopname' => 'divs_I', 'opcode' => 527 }, 'Pebble::InstrDef::Alias'),

'divs_um_I' => bless({ 'opname' => 'divs_um_I', 'realopname' => 'divs_I', 'opcode' => 528 }, 'Pebble::InstrDef::Alias'),

'divs_uc_I' => bless({ 'opname' => 'divs_uc_I', 'realopname' => 'divs_I', 'opcode' => 529 }, 'Pebble::InstrDef::Alias'),

'divs_sud_I' => bless({ 'opname' => 'divs_sud_I', 'realopname' => 'divs_I', 'opcode' => 530 }, 'Pebble::InstrDef::Alias'),

'divs_suic_I' => bless({ 'opname' => 'divs_suic_I', 'realopname' => 'divs_I', 'opcode' => 531 }, 'Pebble::InstrDef::Alias'),

'divs_suim_I' => bless({ 'opname' => 'divs_suim_I', 'realopname' => 'divs_I', 'opcode' => 532 }, 'Pebble::InstrDef::Alias'),

'divs_sui_I' => bless({ 'opname' => 'divs_sui_I', 'realopname' => 'divs_I', 'opcode' => 533 }, 'Pebble::InstrDef::Alias'),

'divs_suid_I' => bless({ 'opname' => 'divs_suid_I', 'realopname' => 'divs_I', 'opcode' => 534 }, 'Pebble::InstrDef::Alias'),

'divs_m_I' => bless({ 'opname' => 'divs_m_I', 'realopname' => 'divs_I', 'opcode' => 535 }, 'Pebble::InstrDef::Alias'),

'cmpteq_I' => bless({ 'opname' => 'cmpteq_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 536 }, "Pebble::InstrDef::Instr"),

'cmpteq_su_I' => bless({ 'opname' => 'cmpteq_su_I', 'realopname' => 'cmpteq_I', 'opcode' => 537 }, 'Pebble::InstrDef::Alias'),

'cmptlt_I' => bless({ 'opname' => 'cmptlt_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 538 }, "Pebble::InstrDef::Instr"),

'cmplt_su_I' => bless({ 'opname' => 'cmplt_su_I', 'realopname' => 'cmptlt_I', 'opcode' => 539 }, 'Pebble::InstrDef::Alias'),

'cmptle_I' => bless({ 'opname' => 'cmptle_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 540 }, "Pebble::InstrDef::Instr"),

'cmptle_su_I' => bless({ 'opname' => 'cmptle_su_I', 'realopname' => 'cmple_I', 'opcode' => 541 }, 'Pebble::InstrDef::Alias'),

'cpys_I' => bless({ 'opname' => 'cpys_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 542 }, "Pebble::InstrDef::Instr"),

'cpysn_I' => bless({ 'opname' => 'cpysn_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 543 }, "Pebble::InstrDef::Instr"),

'cpyse_I' => bless({ 'opname' => 'cpyse_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 544 }, "Pebble::InstrDef::Instr"),

'fcmoveq_I' => bless({ 'opname' => 'fcmoveq_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 545 }, "Pebble::InstrDef::Instr"),

'fcmovge_I' => bless({ 'opname' => 'fcmovge_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 546 }, "Pebble::InstrDef::Instr"),

'fcmovgt_I' => bless({ 'opname' => 'fcmovgt_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 547 }, "Pebble::InstrDef::Instr"),

'fcmovle_I' => bless({ 'opname' => 'fcmovle_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 548 }, "Pebble::InstrDef::Instr"),

'fcmovlt_I' => bless({ 'opname' => 'fcmovlt_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 549 }, "Pebble::InstrDef::Instr"),

'fcmovne_I' => bless({ 'opname' => 'fcmovne_I',
	'InputArcs' => [ 'A', 'C' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 550 }, "Pebble::InstrDef::Instr"),

'opsqrt_I' => bless({ 'opname' => 'opsqrt_I',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 551 }, "Pebble::InstrDef::Instr"),

'sqrtt_I' => bless({ 'opname' => 'sqrtt_I', 'realopname' => 'opsqrt_I', 'opcode' => 552 }, 'Pebble::InstrDef::Alias'),

'sqrtt_c_I' => bless({ 'opname' => 'sqrtt_c_I', 'realopname' => 'sqrtt_I', 'opcode' => 553 }, 'Pebble::InstrDef::Alias'),

'sqrtt_d_I' => bless({ 'opname' => 'sqrtt_d_I', 'realopname' => 'sqrtt_I', 'opcode' => 554 }, 'Pebble::InstrDef::Alias'),

'sqrtt_u_I' => bless({ 'opname' => 'sqrtt_u_I', 'realopname' => 'sqrtt_I', 'opcode' => 555 }, 'Pebble::InstrDef::Alias'),

'sqrtt_ud_I' => bless({ 'opname' => 'sqrtt_ud_I', 'realopname' => 'sqrtt_I', 'opcode' => 556 }, 'Pebble::InstrDef::Alias'),

'sqrtt_suc_I' => bless({ 'opname' => 'sqrtt_suc_I', 'realopname' => 'sqrtt_I', 'opcode' => 557 }, 'Pebble::InstrDef::Alias'),

'sqrtt_sum_I' => bless({ 'opname' => 'sqrtt_sum_I', 'realopname' => 'sqrtt_I', 'opcode' => 558 }, 'Pebble::InstrDef::Alias'),

'sqrtt_su_I' => bless({ 'opname' => 'sqrtt_su_I', 'realopname' => 'sqrtt_I', 'opcode' => 559 }, 'Pebble::InstrDef::Alias'),

'sqrtt_um_I' => bless({ 'opname' => 'sqrtt_um_I', 'realopname' => 'sqrtt_I', 'opcode' => 560 }, 'Pebble::InstrDef::Alias'),

'sqrtt_uc_I' => bless({ 'opname' => 'sqrtt_uc_I', 'realopname' => 'sqrtt_I', 'opcode' => 561 }, 'Pebble::InstrDef::Alias'),

'sqrtt_sud_I' => bless({ 'opname' => 'sqrtt_sud_I', 'realopname' => 'sqrtt_I', 'opcode' => 562 }, 'Pebble::InstrDef::Alias'),

'sqrtt_suic_I' => bless({ 'opname' => 'sqrtt_suic_I', 'realopname' => 'sqrtt_I', 'opcode' => 563 }, 'Pebble::InstrDef::Alias'),

'sqrtt_suim_I' => bless({ 'opname' => 'sqrtt_suim_I', 'realopname' => 'sqrtt_I', 'opcode' => 564 }, 'Pebble::InstrDef::Alias'),

'sqrtt_sui_I' => bless({ 'opname' => 'sqrtt_sui_I', 'realopname' => 'sqrtt_I', 'opcode' => 565 }, 'Pebble::InstrDef::Alias'),

'sqrtt_suid_I' => bless({ 'opname' => 'sqrtt_suid_I', 'realopname' => 'sqrtt_I', 'opcode' => 566 }, 'Pebble::InstrDef::Alias'),

'sqrtt_m_I' => bless({ 'opname' => 'sqrtt_m_I', 'realopname' => 'sqrtt_I', 'opcode' => 567 }, 'Pebble::InstrDef::Alias'),

'opsqrtf_I' => bless({ 'opname' => 'opsqrtf_I', 'realopname' => 'opsqrt_I', 'opcode' => 568 }, 'Pebble::InstrDef::Alias'),

'sqrtf_c_I' => bless({ 'opname' => 'sqrtf_c_I', 'realopname' => 'opsqrt_I', 'opcode' => 569 }, 'Pebble::InstrDef::Alias'),

'sqrtf_u_I' => bless({ 'opname' => 'sqrtf_u_I', 'realopname' => 'opsqrt_I', 'opcode' => 570 }, 'Pebble::InstrDef::Alias'),

'sqrtf_suc_I' => bless({ 'opname' => 'sqrtf_suc_I', 'realopname' => 'opsqrt_I', 'opcode' => 571 }, 'Pebble::InstrDef::Alias'),

'sqrtf_su_I' => bless({ 'opname' => 'sqrtf_su_I', 'realopname' => 'opsqrt_I', 'opcode' => 572 }, 'Pebble::InstrDef::Alias'),

'sqrtf_uc_I' => bless({ 'opname' => 'sqrtf_uc_I', 'realopname' => 'opsqrt_I', 'opcode' => 573 }, 'Pebble::InstrDef::Alias'),

'sqrtf_s_I' => bless({ 'opname' => 'sqrtf_s_I', 'realopname' => 'opsqrt_I', 'opcode' => 574 }, 'Pebble::InstrDef::Alias'),

'sqrtf_sc_I' => bless({ 'opname' => 'sqrtf_sc_I', 'realopname' => 'opsqrt_I', 'opcode' => 575 }, 'Pebble::InstrDef::Alias'),

'ldbu_U' => bless({ 'opname' => 'ldbu_U',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 576 }, "Pebble::InstrDef::Instr"),

'ldwu_U' => bless({ 'opname' => 'ldwu_U',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 577 }, "Pebble::InstrDef::Instr"),

'ldl_U' => bless({ 'opname' => 'ldl_U',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 578 }, "Pebble::InstrDef::Instr"),

'ldl_l_U' => bless({ 'opname' => 'ldl_l_U', 'realopname' => 'ldl_U', 'opcode' => 579 }, 'Pebble::InstrDef::Alias'),

'ldq_U' => bless({ 'opname' => 'ldq_U',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 580 }, "Pebble::InstrDef::Instr"),

'ldq_l_U' => bless({ 'opname' => 'ldq_l_U', 'realopname' => 'ldq_U', 'opcode' => 581 }, 'Pebble::InstrDef::Alias'),

'ldq_u_U' => bless({ 'opname' => 'ldq_u_U',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 582 }, "Pebble::InstrDef::Instr"),

'stb_U' => bless({ 'opname' => 'stb_U',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 583 }, "Pebble::InstrDef::Instr"),

'stw_U' => bless({ 'opname' => 'stw_U',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 584 }, "Pebble::InstrDef::Instr"),

'stl_U' => bless({ 'opname' => 'stl_U',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 585 }, "Pebble::InstrDef::Instr"),

'stq_U' => bless({ 'opname' => 'stq_U',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 586 }, "Pebble::InstrDef::Instr"),

'stq_u_U' => bless({ 'opname' => 'stq_u_U',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 587 }, "Pebble::InstrDef::Instr"),

'lds_U' => bless({ 'opname' => 'lds_U',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 588 }, "Pebble::InstrDef::Instr"),

'ldt_U' => bless({ 'opname' => 'ldt_U',
	'InputArcs' => [ 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 589 }, "Pebble::InstrDef::Instr"),

'sts_U' => bless({ 'opname' => 'sts_U',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 590 }, "Pebble::InstrDef::Instr"),

'stt_U' => bless({ 'opname' => 'stt_U',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 591 }, "Pebble::InstrDef::Instr"),

'Add' => bless({ 'opname' => 'Add',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 592 }, "Pebble::InstrDef::Instr"),

'Sub' => bless({ 'opname' => 'Sub',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 593 }, "Pebble::InstrDef::Instr"),

'Mul' => bless({ 'opname' => 'Mul',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 594 }, "Pebble::InstrDef::Instr"),

'LT' => bless({ 'opname' => 'LT',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 595 }, "Pebble::InstrDef::Instr"),

'GT' => bless({ 'opname' => 'GT',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 596 }, "Pebble::InstrDef::Instr"),

'GE' => bless({ 'opname' => 'GE',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 597 }, "Pebble::InstrDef::Instr"),

'LE' => bless({ 'opname' => 'LE',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 598 }, "Pebble::InstrDef::Instr"),

'EQ' => bless({ 'opname' => 'EQ',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 599 }, "Pebble::InstrDef::Instr"),

'NE' => bless({ 'opname' => 'NE',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 600 }, "Pebble::InstrDef::Instr"),

'AddI' => bless({ 'opname' => 'AddI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 601 }, "Pebble::InstrDef::Instr"),

'SubI' => bless({ 'opname' => 'SubI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 602 }, "Pebble::InstrDef::Instr"),

'MulI' => bless({ 'opname' => 'MulI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 603 }, "Pebble::InstrDef::Instr"),

'LTI' => bless({ 'opname' => 'LTI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 604 }, "Pebble::InstrDef::Instr"),

'GTI' => bless({ 'opname' => 'GTI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 605 }, "Pebble::InstrDef::Instr"),

'GEI' => bless({ 'opname' => 'GEI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 606 }, "Pebble::InstrDef::Instr"),

'LEI' => bless({ 'opname' => 'LEI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 607 }, "Pebble::InstrDef::Instr"),

'EQI' => bless({ 'opname' => 'EQI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 608 }, "Pebble::InstrDef::Instr"),

'NEI' => bless({ 'opname' => 'NEI',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 1,
	'opcode' => 609 }, "Pebble::InstrDef::Instr"),

'mnop' => bless({ 'opname' => 'mnop',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 0,
	'opcode' => 610 }, "Pebble::InstrDef::MemInstr"),

'mnop_ping' => bless({ 'opname' => 'mnop_ping',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 611 }, "Pebble::InstrDef::MemInstr"),

'test_and_set' => bless({ 'opname' => 'test_and_set',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 612 }, "Pebble::InstrDef::MemInstr"),

'swap' => bless({ 'opname' => 'swap',
	'InputArcs' => [ 'ADDR', 'VAL' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 613 }, "Pebble::InstrDef::MemInstr"),

'cas' => bless({ 'opname' => 'cas',
	'InputArcs' => [ 'ADDR', 'COMPAND', 'VAL' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 614 }, "Pebble::InstrDef::MemInstr"),

'thread_create' => bless({ 'opname' => 'thread_create',
	'InputArcs' => [ 'THREAD', 'WAVE' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 615 }, "Pebble::InstrDef::Instr"),

'thread_destroy' => bless({ 'opname' => 'thread_destroy',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 0,
	'opcode' => 616 }, "Pebble::InstrDef::MemInstr"),

'print' => bless({ 'opname' => 'print',
	'InputArcs' => [ 'A', 'B' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 0,
	'opcode' => 617 }, "Pebble::InstrDef::Instr"),

'print1' => bless({ 'opname' => 'print1',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 0,
	'opcode' => 618 }, "Pebble::InstrDef::Instr"),

'sink' => bless({ 'opname' => 'sink',
	'InputArcs' => [ 'A' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 0,
	'opcode' => 619 }, "Pebble::InstrDef::Instr"),

'rho' => bless({ 'opname' => 'rho',
	'InputArcs' => [ 'VALUE', 'PREDICATE' ],
	'OutputArcs' => [ 'T', 'F' ],
	'HasImmediate' => 0,
	'opcode' => 620 }, "Pebble::InstrDef::Instr"),

'phi' => bless({ 'opname' => 'phi',
	'InputArcs' => [ 'T', 'F', 'PREDICATE' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 621 }, "Pebble::InstrDef::Instr"),

'wtd' => bless({ 'opname' => 'wtd',
	'InputArcs' => [ 'WAVE' ],
	'OutputArcs' => [ 'DATA' ],
	'HasImmediate' => 0,
	'opcode' => 622 }, "Pebble::InstrDef::Instr"),

'ttd' => bless({ 'opname' => 'ttd',
	'InputArcs' => [ 'THREAD' ],
	'OutputArcs' => [ 'DATA' ],
	'HasImmediate' => 0,
	'opcode' => 623 }, "Pebble::InstrDef::Instr"),

'dtt' => bless({ 'opname' => 'dtt',
	'InputArcs' => [ 'THREAD', 'IN' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 624 }, "Pebble::InstrDef::Instr"),

'dtw' => bless({ 'opname' => 'dtw',
	'InputArcs' => [ 'WAVE', 'IN' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 625 }, "Pebble::InstrDef::Instr"),

'dttw' => bless({ 'opname' => 'dttw',
	'InputArcs' => [ 'THREAD', 'WAVE', 'IN' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 626 }, "Pebble::InstrDef::Instr"),

'probe' => bless({ 'opname' => 'probe',
	'InputArcs' => [ 'IN' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 627 }, "Pebble::InstrDef::Instr"),

'nop' => bless({ 'opname' => 'nop',
	'InputArcs' => [ 'IN' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 628 }, "Pebble::InstrDef::Instr"),

'identity' => bless({ 'opname' => 'identity',
	'InputArcs' => [ 'IN' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 629 }, "Pebble::InstrDef::Instr"),

'wa' => bless({ 'opname' => 'wa',
	'InputArcs' => [ 'WAVE' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 630 }, "Pebble::InstrDef::Instr"),

'cwa' => bless({ 'opname' => 'cwa',
	'InputArcs' => [ 'WAVE' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 631 }, "Pebble::InstrDef::MemInstr"),

'cnst' => bless({ 'opname' => 'cnst',
	'InputArcs' => [ 'TRIGGER' ],
	'OutputArcs' => [ 'CONST' ],
	'HasImmediate' => 1,
	'opcode' => 632 }, "Pebble::InstrDef::Instr"),

'is_pc' => bless({ 'opname' => 'is_pc',
	'InputArcs' => [ 'DATA', 'DST' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 633 }, "Pebble::InstrDef::Instr"),

'is' => bless({ 'opname' => 'is',
	'InputArcs' => [ 'DATA', 'DST' ],
	'OutputArcs' => [  ],
	'HasImmediate' => 1,
	'opcode' => 634 }, "Pebble::InstrDef::Instr"),

'isret' => bless({ 'opname' => 'isret', 'realopname' => 'is', 'opcode' => 635 }, 'Pebble::InstrDef::Alias'),

'fanout' => bless({ 'opname' => 'fanout',
	'InputArcs' => [ 'IN' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 636 }, "Pebble::InstrDef::Instr"),

'stub_receive' => bless({ 'opname' => 'stub_receive', 'realopname' => 'nop', 'opcode' => 637 }, 'Pebble::InstrDef::Alias'),

'stub_send' => bless({ 'opname' => 'stub_send', 'realopname' => 'nop', 'opcode' => 638 }, 'Pebble::InstrDef::Alias'),

'hack_inst' => bless({ 'opname' => 'hack_inst', 'realopname' => 'nop', 'opcode' => 639 }, 'Pebble::InstrDef::Alias'),

'ir' => bless({ 'opname' => 'ir',
	'InputArcs' => [  ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 640 }, "Pebble::InstrDef::Instr"),

'func_start' => bless({ 'opname' => 'func_start', 'realopname' => 'ir', 'opcode' => 641 }, 'Pebble::InstrDef::Alias'),

'wait' => bless({ 'opname' => 'wait',
	'InputArcs' => [ 'VALUE', 'TRIGGER' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 642 }, "Pebble::InstrDef::Instr"),

'tc' => bless({ 'opname' => 'tc',
	'InputArcs' => [ 'VALUE', 'TOKEN' ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 643 }, "Pebble::InstrDef::Instr"),

'src' => bless({ 'opname' => 'src',
	'InputArcs' => [  ],
	'OutputArcs' => [ 'OUT' ],
	'HasImmediate' => 0,
	'opcode' => 644 }, "Pebble::InstrDef::Instr"),

undef => undef);

1;
