#!/usr/bin/perl -w

package Pebble::InstrDef::MemInstr;
use strict;
use Carp;
use Pebble::HashObject;
use Pebble::InstrDef::Instr;

BEGIN {
    our @ISA = qw( Pebble::InstrDef::Instr );
    our %FIELDS = (
        'waveordering' => 'ARRAY'
    );
    __PACKAGE__->Pebble::HashObject::DECLARE_ACCESSORS;
}

sub validateWaveOrdering
{
    my $self = shift;
    my $waveordering = shift;
    croak("Missing wave ordering on memory operation")
        unless ref($waveordering) eq 'Pebble::WaveOrdering';
}

sub isMemoryInstr { return 1; }

1;
