#!/usr/bin/perl -w

package Pebble::MacroDef;
use strict;
use Carp;
use Pebble::HashObject;

BEGIN {
    our @ISA = qw ( Pebble::HashObject );
    our %FIELDS = (
        prgBlock => "Pebble::PrgBlock",
        scope    => "Pebble::Namespace",
        params   => "ARRAY"
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub setPrgBlock
{
    my $self = shift;
    my $block = shift;
    $self->prgBlock( $block );
}

sub setParams
{
    my $self = shift;
    $self->params([ @_ ]);
}

sub setScope
{
    my $self = shift;
    my $scope = shift;
    $self->scope($scope);
}

sub instantiate
{
    return new Pebble::MacroInstance(@_);
}

1;
