#!/usr/bin/perl -w

package Pebble::NamedThing;

use strict;
use Carp;
use Pebble::ArrayObject;
use constant REFERENT => 0;
use constant DECLARED => 1;

our @ISA = qw( Pebble::ArrayObject );

sub initialize
{
    my $self = shift;
    my $thing = shift;
    my $declared = shift;
    $self->[REFERENT] = $thing;
    $self->[DECLARED] = $declared;
    scalar @_ and carp("Too many parameters to initialize");
    return $self;
}

sub referent
{
    my $self = shift;
    scalar @_ and croak(scalar @_ . " too many parameters to " . __PACKAGE__ . "::referent");
    scalar @_ and $self->[REFERENT] = shift;
    return $self->[REFERENT];
}

sub isDeclared
{
    my $self = shift;
    return $self->[DECLARED];
}

sub declare
{
    my $self = shift;
    $self->isDeclared() and carp("Name '" . $self->toString() . "' already declared");
    $self->[DECLARED] = 1;
    return $self;
}

sub undeclare
{
    my $self = shift;
    $self->[DECLARED] = undef;
    return $self;
}

1;
