#!/usr/bin/perl -w

package Pebble::Object;

use strict;
use Carp;
use Data::Dumper;

sub _newImpl
{
    my ($kind, $impl, @params) = @_;
    my $class;
    $class = ref $kind or $class = $kind;
    return bless($impl, $kind)->initialize(@params);
}

sub initialize
{
    my $self = shift;
    carp("Too many parameters")if(scalar @_ > 1);
    return $self;
}

sub toString
{
    my $self = shift;
    return Data::Dumper::Dumper($self);
}

sub eq {
    my $self = shift;
    my $other = shift;
    return $self == $other;
}

1;
