#!/usr/bin/perl -w

package Pebble::OperandPort;
use strict;
use Carp;
use Pebble::HashObject;
use Pebble::OperandPort;
use Pebble::Stringy;

use overload "eq" => \&eq;

BEGIN {
    our @ISA = qw(Pebble::HashObject Pebble::Stringy );
    our %FIELDS = (
        'instrInstance' => 'Pebble::InstrInstance',
        'instrPort'     => undef
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    my $self = shift;
    $self->instrInstance(shift);
    $self->instrPort(shift);
    return $self;
}

sub eq {
    my $self = shift;
    my $other = shift;
    ref($other) eq __PACKAGE__ or return undef;
    return $self->instrPort == $other->instrPort &&
        $self->instrInstance == $other->instrInstance;
}

sub toString
{
    return $_[0]->instrInstance->toString() . ":" . $_[0]->instrPort();
}

sub getCodeIndex
{
    my $self = shift;
    if(defined $self->instrInstance) {
        return $self->instrInstance->getCodeIndex;
    }
    return -1;
}


sub getPortType
{
    my $self = shift;
    return $self->instrInstance->instrdef->getPortType($self->instrPort);
}

1;
