#!/usr/bin/perl -w

package Pebble::PrgBlock;
use strict;
use Carp;
use Pebble::CodeItem;
use Pebble::ArrayList;

BEGIN {
    our @ISA = qw(  Pebble::CodeItem );
    our %FIELDS = (
        '_codeItems' => 'Pebble::ArrayList',
        '_allItems'  => 'Pebble::ArrayList'
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    my $self = shift;
    $self->_codeItems( new Pebble::ArrayList );
    $self->_allItems ( new Pebble::ArrayList );
    return $self;
}

sub addPrgItem
{
    my $self = shift;
    my $item = shift;
    my $codeindex = undef;
    if(UNIVERSAL::isa($item, "Pebble::CodeItem")) {
        $self->_codeItems->push($item);
    }
    $self->_allItems->push($item);
    return undef;
}

sub codeItems { return @{$_[0]->_codeItems}; }
sub visit { return $_[1]->visitPrgBlock($_[0]); }

1;
