#!/usr/bin/perl -w

package Pebble::Section;

use strict;
use Carp;
use Pebble::HashObject;
use Pebble::Namespace;

BEGIN {
    our @ISA = qw( Pebble::HashObject );
    our %FIELDS = (
        '_topNamespace' => 'Pebble::Namespace',
        '_prgBlocks' => 'Pebble::ArrayList',
        'name' => undef
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    my $self = shift;
    $self->name(shift);
    $self->_topNamespace (new Pebble::Namespace($self, "." . $self->name, shift));
    $self->_prgBlocks (new Pebble::ArrayList);
    return $self;
}

sub topNamespace
{
    return shift->_topNamespace;
}

sub addPrgBlock
{
    scalar @_ == 2 or croak("Wrong number of arguments to addPrgBlock: " . scalar @_);
    my $self = shift;
    my $prgBlock = shift;
    $self->_prgBlocks->push($prgBlock);
    return undef;
}

sub prgBlocks
{
    return @{$_[0]->_prgBlocks};
}

sub visit { return $_[1]->visitSection($_[0]); }

sub getNamedThingByName { return undef; }
sub fullname { return ""; }

1;
