#!/usr/bin/perl -w

package Pebble::WaveOrdering;
use strict;
use Pebble::HashObject;

BEGIN {
    our @ISA = qw( Pebble::HashObject );
    our %FIELDS = (
        'prev'   => undef,
        'curr'   => undef,
        'next'   => undef,
        'ripple' => undef
    );
    __PACKAGE__->DECLARE_ACCESSORS;
}

sub initialize
{
    my $self   = $_[0];
    $self->prev  ($_[1]);
    $self->curr  ($_[2]);
    $self->next  ($_[3]);
    $self->ripple($_[4]);
    return $self;
}

sub toString
{
    return ("<" . $_[0]->prev() . ", " . $_[0]->curr() .
            ", " . $_[0]->next() . ">." . $_[0]->ripple());
}

1;
