;;; FILE:        lock.S
;;; AUTHOR:      Andrew Petersen (petersen@cs.washington.edu)
;;; 
 
.section .code
;;; .version 2

.proc lock_thread(initial_token)
.export ^lock_thread as lock_thread

;;; Landing pads for lock operations
lock_request:
        ir lock_request_IN
lock_destination:
        ir lock_destination_IN
lock_token:
        ir token_IN

	;;; The nodes for the lock itself
	.scope
	tc lock_OUT, lock_request_IN, {initial_token, token_IN}
	is lock_OUT, lock_destination_IN, 0
	.endscope
.endproc

.proc acquire_lock(request, return_addr)
.export ^acquire_lock as acquire_lock
	.scope
	cnst request_addr, request, ^lock_thread::lock_request
	cnst dest_addr, request, ^lock_thread::lock_destination

	is request, request_addr, 0
	is return_addr, dest_addr, 0
	.endscope
.endproc

.proc release_lock(token)
.export ^release_lock as release_lock
	.scope
	cnst addr, token, ^lock_thread::lock_token

	is token, addr, 0
	.endscope
.endproc
