#include <cassert>
#include <iostream>
#include <cstdio>
#include "Drip/InstructionFormatAux.h"
#include "Drip/InstructionFormat.h"

static void usage(const char *appname);

extern "C"
int main(int argc, char **argv)
{
  FILE *is;
  if(argc != 2) {
    usage(argv[0]);
    return 1;
  }
  is = ::fopen(argv[1], "r");
  if(!is) {
      usage(argv[0]);
      return 1;
  }

  EncodedProgram target;

  readEncodedProgramType(is, &target);

  assert(target.version == IF_VERSION);

  return 0;
}

void usage(const char *appname)
{
  using std::cout;
  using std::endl;
  cout << "Usage:" << endl << "\t"
       << appname << " <WSExecInputFile>" << endl;
}
