#!/usr/bin/perl -w

use strict;
use Parse::Lex;

my $lexer;

my @tokens = (
    'PERL', [";perl", "(?:[^;].*?|;(?!endperl))+", ";endperl"], sub {
        $_[1] =~ s/;perl//m;
        $_[1] =~ s/;endperl//m;
        print "===$_[1]===\n";
        eval $_[1];
    },
    qw(COMMENT          ;.*?\n
       EOL              \n
       NAME             \b[_[:alpha:]][_[:alnum:]]*\b
       HEXUINT          \b0x[[:xdigit:]]+\b
       OCTUINT          \b0[0-7]+\b
       DOT              \.
       COMMA            ,
       QS               \?
       LBRACE           {
       RBRACE           }
       CARET            \^
       DOLLAR           \$
       LT               <
       GT               >
       PLUS             \+
       MINUS            -
       SCOPETOK         ::
       DECUINT          \b[1-9]\d*\b
      )
    ,qw(ERROR .*)
);


$lexer = Parse::Lex->new(@tokens);
$lexer->skip( '([ \t]|[\\\\]\n)+');
$lexer->from(\*STDIN);
$lexer->every( sub { print $_[0]->name . "\t-->" . $_[0]->text . "<--\n"; } );
