//
// FILE: mkinstdefs.cxx
// AUTHOR: Andrew Schwerin <schwerin@cs.washington.edu>
// DATE: $Date: 2004/07/07 18:31:46 $
// $Id: mkinstdefs.cxx,v 1.3 2004/07/07 18:31:46 swanson Exp $
//
#include <cstdio>
#include<string>

#define DOPRINT printf
#define INPUT_FORMAT "\t%n'InputArcs' => [ %s ],\n", &i
#define OUTPUT_FORMAT "\t%n'OutputArcs' => [ %s ],\n", &i
#define INPUT(a) ; // inputs[a]
#define OUTPUT(a) ; // outputs[a]
#define ZERO_IN  DOPRINT(INPUT_FORMAT, "")
#define ZERO_OUT DOPRINT(OUTPUT_FORMAT, "")
#define ONE_IN(a) DOPRINT(INPUT_FORMAT, "'" #a"'" )
#define ONE_OUT(a) DOPRINT(OUTPUT_FORMAT, "'" #a"'" )
#define TWO_IN(a, b) DOPRINT(INPUT_FORMAT, "'" #a"'"  ", ""'"  #b"'" )
#define TWO_OUT(a, b) DOPRINT(OUTPUT_FORMAT,"'"  #a"'"  ", ""'"  #b"'" )
#define THREE_IN(a, b, c) DOPRINT(INPUT_FORMAT,"'"  #a"'"  ", ""'"  #b"'"  ", ""'"  #c"'" )
#define THREE_OUT(a, b, c) DOPRINT(OUTPUT_FORMAT,"'"  #a"'"  ", ""'"  #b"'"  ", ""'"  #c"'" )
#define FOUR_IN(a, b, c, d) DOPRINT(INPUT_FORMAT,"'"  #a"'"  ", ""'"  #b"'"  ", ""'"  #c"'"  ", ""'"  #d"'" )
#define FOUR_OUT(a, b, c, d) DOPRINT(OUTPUT_FORMAT,"'"  #a"'"  ", ""'"  #b"'"  ", ""'"  #c"'"  ", ""'"  #d"'" )
#define LINK(real, virt) \
 DOPRINT("'" #virt "' => bless({ 'opname' => '" #virt "', 'realopname' => '" #real "', 'opcode' => %d }, 'Pebble::InstrDef::Alias'),\n\n", opcode++);

#include "uniform_INST.def"
#define INST(OP, FLAGS, IN_COUNT, OUT_COUNT, IMM, IS_MEM, INPUTS, AUTO_INPUTS, OUTPUTS, AUTO_OUTPUTS, FIRE_0_IN_SET, FIRE_0_OUT_SET, FIRE_0_CODE, FIRE_1_IN_SET, FIRE_1_OUT_SET, FIRE_1_CODE, FIRE_2_IN_SET, FIRE_2_OUT_SET, FIRE_2_CODE) \
  DOPRINT("'%s' => bless({ 'opname' => '%s',\n", #OP, #OP);             \
  INPUTS; OUTPUTS;                                                      \
  DOPRINT("\t'HasImmediate' => %s,\n", IMM ? "1" : "0");              \
  DOPRINT("\t'opcode' => %d }, \"%s\"),\n\n", opcode++,                  \
          (IS_MEM ? "Pebble::InstrDef::MemInstr" : "Pebble::InstrDef::Instr")); \

int main (int argc, char*argv[]) 
{
     int i;
     int opcode = 0;
     DOPRINT("package Pebble::InstrDef::InstructionDefs;\n\nuse strict;\n");
     DOPRINT("use Exporter;\nour @EXPORT_OK = qw( %%IDEFS );\nour @ISA = qw(Exporter);\n\n");
     DOPRINT("our %%IDEFS = (\n");
#include"Instructions.def"
     DOPRINT("undef => undef);\n\n1;\n");

     return 0;
}
