#include <stdio.h>
#include <cmplrs/atom.inst.h> 
#include <dlfcn.h>
#include <assert.h>

void printInst(FILE *f, unsigned word);

unsigned InstrumentAll(int argc, char **argv)  
{
     Obj *o; Proc *p;  Block *b;  Inst *i;
     void *handle;
     char *error;
     int c = 0;
     InstRegUsageVec vec;
     int icount = 0;
     FILE *out;
     
     out = fopen("out.map", "w");
     assert(out);
     
     for (o = GetFirstObj(); o != NULL; o = GetNextObj(o)) {  
	  if (BuildObj(o))
	       return 1;  
	  for (p = GetFirstObjProc(o); p != NULL; p = GetNextProc(p)) {  
	       const char *name = ProcName(p);  
	       fprintf(out, "Start Function: %s\n",name);
	       for (b = GetFirstBlock(p); b != NULL; b = GetNextBlock(b)) {  
		    fprintf(out, "\tBlockID: %d\n", GetBlockInfo(b, BlockID));
		    for (i = GetFirstInst(b); i != NULL; i = GetNextInst(i)) { 
			 unsigned int binInst = GetInstInfo(i, InstBinary);
			 unsigned int type = 0;
			 unsigned int class = 0;

			 icount++;
     			 fprintf(out, "\t\t");
			 fprintf(out, "0x%08lx\t", InstPC(i));
			 fprintf(out, "0x%08x", binInst);
			 fprintf(out, "\n");
		    }
		    fprintf(out, "\tEnd Block\n");
	       }
	       fprintf(out, "End Function\n", name);
	  }
	  WriteObj(o);  
     }
     return(0);
}  


