// File:	lcs.c
// Author:	Andrew Petersen (petersen@cs.washington.edu)
// Notes:	Computes the longest common subexpression of two strings
//		AKP:  commandline args are now <strenglength> <serial (0, 1)> <blockSize> <ply>
//                  Strings are very boring.
//

#include <stdio.h>
#include "ws/threads.h"

// An array to hold the results
// Note that the index is one off from the strings

void lcs(int, int, char *, char *);
void doWork();

int stringSize;
int ply;

char *string_A;
char *string_B;

int main(int argc, char *argv[]) {
  int i, j, k;

  if (argc != 3) {
    fprintf(stderr, "Incorrect arguments:  <exe> <stringSize> <ply>\n");
    exit(0);
  }

  stringSize = atoi(argv[1]);
  ply = atoi(argv[2]);

  if (stringSize <= 0)
    stringSize = 1;
  if (ply <= 0)
    ply = 1;

  string_A = (char *)malloc(sizeof(char)*(stringSize + 1));
  string_B = (char *)malloc(sizeof(char)*(stringSize + 1));
      for (i = 0; i < stringSize + 1; i++) {
        string_A[i] = 'a';
        string_B[i] = 'a';
      }

  doWork();
  return 0;
}

void doWork() {
  int i;
  int ids[ply];
  
  initialize_tid_acquire();

  for(i = 0; i < ply; i++)
  	ids[i] = thread_create_pc(lcs, stringSize, string_A, string_B);

  for (i = 0; i < ply; i++) 
        thread_join(ids[i]);

  deinitialize_tid_acquire();

  printf("Done!\n");
}

void lcs(int threadID, int stringSize, char *A, char *B) {
return;
}

